// ConnectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "ConnectDlg.h"
#include <process.h>
#include <conio.h>
#include "RTCUProgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CConnectDlg dialog


CConnectDlg::CConnectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnectDlg)
	m_comboselect = _T("");
	m_status = _T("");
	//}}AFX_DATA_INIT
}


void CConnectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectDlg)
	DDX_Control(pDX, IDC_CLEARCOMBO, m_ctrclearcombo);
	DDX_Control(pDX, IDOK, m_ctrok);
	DDX_Control(pDX, IDC_DISCONNECT, m_ctrdisconnect);
	DDX_Control(pDX, IDC_CONNECT, m_ctrconnect);
	DDX_Control(pDX, IDC_COMBOSELECT, m_ctrcomboselect);
	DDX_CBString(pDX, IDC_COMBOSELECT, m_comboselect);
	DDX_Text(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectDlg, CDialog)
	//{{AFX_MSG_MAP(CConnectDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_CLEARCOMBO, OnClearcombo)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("ConnectSettings");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf_s(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's ini file
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Initialize / Destroy
/////////////////////////////////////////////////////////////////////////////
BOOL CConnectDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  
  m_ctrdisconnect.EnableWindow(false);
  m_attempting=false;

  CRect rc;
  GetWindowRect(&rc);
	WINDOWPLACEMENT wp;
  // Check that the size of the dialog hasn't changed (allow max 4 pixels in both directions)
  if (ReadWindowPlacement(&wp)) {
    if (((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
        ((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC)) {
      wp.showCmd=false;
   	  SetWindowPlacement(&wp);
    }
  }

  // Load all strings saved in the registry, and put'em in the combo
  CString str, strList, f;
  strList = AfxGetApp()->GetProfileString("ConnectSettings", "COMBO");
  // If something in list...
  if (!strList.IsEmpty()) {
    // Find how many entries exists in the list, format is "AA||BB||CC||DD||"
    int i=strList.Replace("||", "||"); // This gives a count for the number of "||" sequences
    while (i) {
      str = strList.Left(strList.Find("||", 0)); // Extract the string
      strList.Delete(0, strList.Find("||", 0)); // Kill the string
      strList.Delete(0,2); // Kill the "||"
      if (!str.IsEmpty())
        m_ctrcomboselect.AddString(str);
      if (f.IsEmpty())
        f=str;
      i--;
    }
  }
  m_ctrdisconnect.EnableWindow(false);
  UpdateData(false);
  m_ctrcomboselect.SelectString(0,f);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConnectDlg::OnDestroy() 
{
  // before it is destroyed, save the position of the window
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
	{
		wp.flags = 0;
		if (IsZoomed())
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		// and write it to the .INI file
		WriteWindowPlacement(&wp);
	}

  // Get all strings in the combobox, and save'em
  CString str, strList;
  for (int i=0; i < m_ctrcomboselect.GetCount();i++)
  {
     m_ctrcomboselect.GetLBText( i, str);
     if (!str.IsEmpty()) {
       strList += str;
       strList += "||";
     }
  } 
  AfxGetApp()->WriteProfileString("ConnectSettings", "COMBO", strList);

  CDialog::OnDestroy();
}


void CConnectDlg::OnOK() 
{
  ShowWindow(false);
}



//---------------------------------------------------------------
static void th(void *arg) {
  ((CConnectDlg*)arg)->thrc=rmonConnect(hCon, ((CConnectDlg*)arg)->m_comboselect);
  _cprintf("rmonConnect()=%i\n", ((CConnectDlg*)arg)->thrc);
  ((CConnectDlg*)arg)->m_attempting=false;
}



void CConnectDlg::OnConnect() 
{
  UpdateData(true);
    // Delete entry if already there
    m_ctrcomboselect.DeleteString(m_ctrcomboselect.FindStringExact(-1, m_comboselect));
    // And insert at top
    m_ctrcomboselect.InsertString(0, m_comboselect);


  if (!m_comboselect.IsEmpty()) {
    m_ctrconnect.EnableWindow(false);
    m_ctrcomboselect.EnableWindow(false);
    m_ctrok.EnableWindow(false);
    m_ctrclearcombo.EnableWindow(false);
    m_ctrdisconnect.EnableWindow(true);

    // Disconnect cable connection
    rmonDisconnect(hCon);

    BeginWaitCursor();
    m_status.Format("Connecting to %s", m_comboselect);
    UpdateData(false);
    thrc=0;

    m_attempting=true;
    _beginthread(th, 0, this);
    
    while (m_attempting) {
      // Let upto 10 messages pass by for each time we are called,
      // so the user sees some response from Windows...
      MSG msg;
      for (int i=0; i<10; i++) {
        if (::PeekMessage(&msg, NULL, 0, 0, PM_NOYIELD | PM_REMOVE)) {
          ::TranslateMessage(&msg);			
          ::DispatchMessage(&msg);			
        }
      }
      Sleep(100);
    }
    EndWaitCursor();


    if (thrc) {
      m_status.Format("Could not connect to %s", m_comboselect);
      UpdateData(false);
      AfxMessageBox("No connection possible to remote unit !");
      m_ctrdisconnect.EnableWindow(false);
      m_ctrconnect.EnableWindow(true);
      m_ctrcomboselect.EnableWindow(true);
      m_ctrok.EnableWindow(true);
      m_ctrclearcombo.EnableWindow(true);
      return;
    }
    m_status.Format("Connected to %s", m_comboselect);

    UpdateData(false);
  } else {
    AfxMessageBox("No number selected/entered for the remote connection !");
  }
}

void CConnectDlg::OnDisconnect() 
{
  // If we are connected remote...
  if (rmonConnected(hCon)==RMONCON_REMOTE)
    // And the user really wants to disconnect....
    if(AfxMessageBox("Are you sure you want to disconnect ?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
      return;

  // Drop the line
  BeginWaitCursor();
  UpdateData(true);
  m_ctrdisconnect.EnableWindow(false);
  m_ctrconnect.EnableWindow(true);
  m_ctrcomboselect.EnableWindow(true);
  m_ctrok.EnableWindow(true);
  m_ctrclearcombo.EnableWindow(true);

  m_status="Disconnected.";

  rmonDisconnect(hCon);

  UpdateData(false);

  // Reconnect cable
  rmonConnect(hCon, "");
}


void CConnectDlg::OnClearcombo() 
{
  if(AfxMessageBox("Do you really want to clear the list ?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
    return;
  m_ctrcomboselect.ResetContent();	
}


void CConnectDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
  PostMessage (WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x,point.y));
	
	CDialog::OnLButtonDown(nFlags, point);
}


 
