// ConnectGwPageUnit.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "ConnectGwPageUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectGwPageUnit property page

IMPLEMENT_DYNCREATE(CConnectGwPageUnit, CPropertyPage)

CConnectGwPageUnit::CConnectGwPageUnit() : CPropertyPage(CConnectGwPageUnit::IDD)
{
	//{{AFX_DATA_INIT(CConnectGwPageUnit)
	m_status		= _T("");
	m_comboselect	= _T("");
	//}}AFX_DATA_INIT
}

CConnectGwPageUnit::~CConnectGwPageUnit()
{
}

void CConnectGwPageUnit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectGwPageUnit)
	DDX_Control(pDX, IDC_CLEARCOMBO, m_ctrclearcombo);
	DDX_Control(pDX, IDC_DISCONNECT, m_ctrdisconnect);
	DDX_Control(pDX, IDC_CONNECT, m_ctrconnect);
	DDX_Control(pDX, IDC_COMBOSELECT, m_ctrcomboselect);
	DDX_Text(pDX, IDC_STATUS, m_status);
	DDX_CBString(pDX, IDC_COMBOSELECT, m_comboselect);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectGwPageUnit, CPropertyPage)
	//{{AFX_MSG_MAP(CConnectGwPageUnit)
	ON_BN_CLICKED(IDC_CLEARCOMBO, OnClearcombo)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(UWM_CONNECT_PAGE, OnConnectPage)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CConnectGwPageUnit::OnInitDialog() 
{
	// Var
	CString str, strList, f;

	// Default
	CPropertyPage::OnInitDialog();

	// Load all strings saved in the registry, and put'em in the combo
	strList = AfxGetApp()->GetProfileString("GWConnect Options", "COMBO");
	// If something in list...
	if (!strList.IsEmpty()) {
		// Find how many entries exists in the list, format is "AA||BB||CC||DD||"
		int i=strList.Replace("||", "||"); // This gives a count for the number of "||" sequences
		while (i) {
			str = strList.Left(strList.Find("||", 0)); // Extract the string
			strList.Delete(0, strList.Find("||", 0)); // Kill the string
			strList.Delete(0,2); // Kill the "||"
			if (!str.IsEmpty()) 
				m_ctrcomboselect.AddString(str);
			if (f.IsEmpty())
				f=str;
			i--;
		}
	}
 
	// Set controls
	UpdateData(false);
	m_ctrcomboselect.SelectString(0, f);
	m_ctrdisconnect.EnableWindow(false);

	// Completed
	return TRUE;
}

void CConnectGwPageUnit::OnDestroy() 
{
	// Get all strings in the combobox, and save'em
	CString str, strList;
	for (int i=0; i < m_ctrcomboselect.GetCount();i++)
	{
		m_ctrcomboselect.GetLBText( i, str);
		if (!str.IsEmpty()) {
			strList += str;
			strList += "||";
		}
	} 
	AfxGetApp()->WriteProfileString("GWConnect Options", "COMBO", strList);

	// Default
	CPropertyPage::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// Buttons
/////////////////////////////////////////////////////////////////////////////

void CConnectGwPageUnit::OnClearcombo() 
{
	// Verify with user
	if(AfxMessageBox("Do you really want to clear the list ?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
		return;

	// Empty contents
	m_ctrcomboselect.ResetContent();	
}

void CConnectGwPageUnit::OnConnect() 
{
	// Update node id
	UpdateData(true);

	// Send connect message
	GetParent()->PostMessage(UWM_CONNECT_SHEET, 0, 1);

	if (!m_comboselect.IsEmpty()) {
		// Delete entry if already there
		m_ctrcomboselect.DeleteString(m_ctrcomboselect.FindStringExact(-1, m_comboselect));
		// And insert at top
		m_ctrcomboselect.InsertString(0, m_comboselect);
	} else {
		AfxMessageBox("No nodeid has been selected !", MB_ICONWARNING);
		m_ctrcomboselect.SetFocus();
	}
}

void CConnectGwPageUnit::OnDisconnect() 
{
	// If we are not longer connected thru GW, we just silently Disconnect.... (to maintain valid states in the dialog....)
	if (rmonConnected(hCon) == RMONCON_GW)
		if(AfxMessageBox("Are you sure you want to disconnect ?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
			return;

	// Send disconnect message
	GetParent()->PostMessage(UWM_CONNECT_SHEET, 0, 0);
}

/////////////////////////////////////////////////////////////////////////////
// Update
/////////////////////////////////////////////////////////////////////////////

LRESULT CConnectGwPageUnit::OnConnectPage(WPARAM wParam, LPARAM lParam)
{
	// Set controls
	if (wParam == 0) {
		// Set controls
		m_ctrdisconnect.EnableWindow(false);
		m_ctrconnect.EnableWindow(true);
		m_ctrcomboselect.EnableWindow(true);
		m_ctrclearcombo.EnableWindow(true);

		// Update status
		m_status = "Disconnected.";
		UpdateData(false);
	} else if (wParam == 1) {
		// Set controls
		m_ctrconnect.EnableWindow(false);
		m_ctrcomboselect.EnableWindow(false);
		m_ctrclearcombo.EnableWindow(false);
	} else if (wParam == 2) {
		// Update status
		m_status.Format("Connecting to %s", m_comboselect);
		UpdateData(false);
	} else if (wParam == 3) {
		// Update status
		m_status.Format("Could not connect to gateway %s", (char*)lParam);
		UpdateData(false);

		// Show error
		AfxMessageBox("No connection possible to remote unit !");

		// Set controls
		m_ctrconnect.EnableWindow(true);
		m_ctrcomboselect.EnableWindow(true);
		m_ctrclearcombo.EnableWindow(true);
		m_ctrdisconnect.EnableWindow(false);
	} else if (wParam == 4) {
		// Update status
		m_status.Format("Could not connect to %s", m_comboselect);
		UpdateData(false);

		// Show error
		AfxMessageBox("No connection possible to remote unit !");

		// Set controls
		m_ctrconnect.EnableWindow(true);
		m_ctrcomboselect.EnableWindow(true);
		m_ctrclearcombo.EnableWindow(true);
		m_ctrdisconnect.EnableWindow(false);
	} else if (wParam == 5) {
		// Update status
		m_status.Format("Connected to %s", m_comboselect);
		UpdateData(false);

		// Set controls
		m_ctrdisconnect.EnableWindow(true);
	}

	// Completed
	return 0;
}
