// DebugMsgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "DebugMsgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebugMsgDlg dialog


CDebugMsgDlg::CDebugMsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDebugMsgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugMsgDlg)
	//}}AFX_DATA_INIT
}


void CDebugMsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugMsgDlg)
	DDX_Control(pDX, IDC_ENABLE, m_ctrenable);
	DDX_Control(pDX, IDC_LIST_MESSAGE, m_listmessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebugMsgDlg, CDialog)
	//{{AFX_MSG_MAP(CDebugMsgDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CLEARLIST, OnClearlist)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_WM_TIMER()
	ON_WM_SIZE()
   ON_WM_GETMINMAXINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("DebugMsg");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf_s(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's ini file
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// Create / Destroy
/////////////////////////////////////////////////////////////////////////////

BOOL CDebugMsgDlg::OnInitDialog() 
{
   // Default init
   CDialog::OnInitDialog();

   // Windows Position
   WINDOWPLACEMENT wp;
   if( ReadWindowPlacement(&wp) ) {
      CRect rc;
      GetWindowRect(&rc);
      if( ((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
          ((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC)) {
         wp.showCmd = false;
   	   SetWindowPlacement(&wp);
      }
   }

   // Make sure that the HScrollbar can scroll to 128 chars
   CSize   sz;
   CDC*    pDC = m_listmessage.GetDC();
   sz          = pDC->GetTextExtent("A", 200);
   m_listmessage.ReleaseDC(pDC);
   m_listmessage.SetHorizontalExtent(sz.cx);

   // Update Timer
//   SetTimer(111, 1000, NULL);

   // Completed
   return TRUE;
}

void CDebugMsgDlg::OnDestroy() 
{
   // before it is destroyed, save the position of the window
   WINDOWPLACEMENT wp;
   wp.length = sizeof wp;
   if( GetWindowPlacement(&wp) )
   {
      wp.flags = 0;
      if( IsZoomed() )
         wp.flags |= WPF_RESTORETOMAXIMIZED;
      // and write it to the .INI file
      WriteWindowPlacement(&wp);
   }

   // Update timer
//   KillTimer(111);

   // Default
   CDialog::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// Update
/////////////////////////////////////////////////////////////////////////////

void CDebugMsgDlg::OnTimer(UINT nIDEvent) 
{
   // Test for connected
   if( rmonConnected(hCon) != RMONCON_NONE ) {
      // Var
      int  rc, enabled;
      // Determine status of debug messages
      rc = rmonGetDebugEnable(hCon, &enabled);
      if( rc == rmonOK && enabled ) {
         m_ctrenable.EnableWindow();
         m_ctrenable.SetWindowText("Disable");
      }
      else if( rc == rmonOK && !enabled ) {
         m_ctrenable.EnableWindow();
         m_ctrenable.SetWindowText("Enable");
	  }
      else {
         m_ctrenable.EnableWindow(FALSE);
         m_ctrenable.SetWindowText("Enable");
      }
   }
   else {
      m_ctrenable.EnableWindow(FALSE);
      m_ctrenable.SetWindowText("Enable");
   }
   // Default
   CDialog::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
// Buttons
/////////////////////////////////////////////////////////////////////////////

void CDebugMsgDlg::OnOK() 
{
   // Hide dialog
   ShowWindow(SW_HIDE);
}

void CDebugMsgDlg::OnClearlist() 
{
   // Remove messages
   m_listmessage.ResetContent();
}

void CDebugMsgDlg::OnEnable() 
{
   CString str;
   m_ctrenable.GetWindowText(str);
   BeginWaitCursor();

   int xx = m_ctrenable.IsWindowEnabled();
   m_ctrenable.EnableWindow(false);

   if( str == "Enable" ) {
      rmonSetDebugEnable(hCon, true);
      m_ctrenable.SetWindowText("Disable");
      m_listmessage.InsertString( -1, "------------ DEBUG MESSAGES ENABLED ------------" );
   }
   else {
      rmonSetDebugEnable(hCon, false);
      m_ctrenable.SetWindowText("Enable");
      m_listmessage.InsertString( -1, "------------ DEBUG MESSAGES DISABLED ------------" );
   }

   // If last item already selected, go select the new "last" item
   int nCount = m_listmessage.GetCount();
   if( nCount == m_listmessage.GetCurSel() + 2 ) { 
      if( nCount > 0 )
         m_listmessage.SetCurSel(nCount-1);
   }

   EndWaitCursor();

   m_ctrenable.EnableWindow(xx);
}

void CDebugMsgDlg::OnSize(UINT nType, int cx, int cy) 
{
	// Default
	CDialog::OnSize(nType, cx, cy);

	// Resize controls
	if( m_listmessage.GetSafeHwnd() )              m_listmessage.MoveWindow( 11, 11, cx - 26, cy - 60 );
	if( m_ctrenable.GetSafeHwnd() )                m_ctrenable.MoveWindow( 11, cy - 35, 100, 23 );
	if( GetDlgItem(IDC_CLEARLIST)->GetSafeHwnd() ) GetDlgItem(IDC_CLEARLIST)->MoveWindow( ((cx / 2) - 46), cy - 35, 100, 23 );
	if( GetDlgItem(IDOK)->GetSafeHwnd() )          GetDlgItem(IDOK)->MoveWindow( cx - 115, cy - 35, 100, 23 );
}

void CDebugMsgDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
   // Set minimum size
   lpMMI->ptMinTrackSize.x = 425;
   lpMMI->ptMinTrackSize.y = 300;
}
