// DlgFTPFirmware.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "DlgFTPFirmware.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define userid "anonymous"
#define password "rtcuide"
#define ftpaddress "ftp.rtcu.dk"

/////////////////////////////////////////////////////////////////////////////
// CDlgFTPFirmware dialog


CDlgFTPFirmware::CDlgFTPFirmware(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFTPFirmware::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgFTPFirmware)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgFTPFirmware::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFTPFirmware)
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgFTPFirmware, CDialog)
	//{{AFX_MSG_MAP(CDlgFTPFirmware)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnDownload)
	ON_LBN_DBLCLK(IDC_LIST, OnDblclkList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgFTPFirmware message handlers


BOOL CDlgFTPFirmware::OnInitDialog() 
{
  CDialog::OnInitDialog();

  BeginWaitCursor();
	
	CFtpConnection* m_pFtpConnection;
	CInternetSession* m_pInetSession;

	// the CInternetSession will not be closed or deleted
	// until the dialog is closed
  m_pInetSession = new CInternetSession("TESTAPP", 1, PRE_CONFIG_INTERNET_ACCESS);

	// Alert the user if the internet session could not be started
	if (!m_pInetSession)
	{
		AfxMessageBox("Bad session", MB_OK|MB_ICONEXCLAMATION);
    EndDialog(0);
    return TRUE;
	}

  try
	{
		m_pFtpConnection = m_pInetSession->GetFtpConnection(ftpaddress, userid, password, INTERNET_INVALID_PORT_NUMBER, TRUE);
	}
	catch (CInternetException* pEx)
	{
		// catch errors from WinINet
		TCHAR szErr[1024];
		if (pEx->GetErrorMessage(szErr, 1024))
			AfxMessageBox(szErr, MB_OK|MB_ICONEXCLAMATION);
		else
			AfxMessageBox("Exception", MB_OK|MB_ICONEXCLAMATION);
		pEx->Delete();

		m_pFtpConnection = NULL;
    EndDialog(0);
    return TRUE;
  }

  // Make a directory listing....
  CFtpFileFind finder(m_pFtpConnection);

   // start looping
   BOOL bWorking = finder.FindFile(_T("*.BIN"));
   
   int found=0;
   while (bWorking)
   {
      found++;
      bWorking = finder.FindNextFile();
      m_list.AddString(finder.GetFileURL());

      TRACE("%s\n", (LPCTSTR) finder.GetFileURL());
   }

  finder.Close();

  m_pFtpConnection->Close();
	m_pInetSession->Close();
  
  delete m_pFtpConnection;  
  delete m_pInetSession;

  EndWaitCursor();

  if (found==0) {
    AfxMessageBox(IDS_FIRMWARE_NOFILES,MB_ICONEXCLAMATION);
    EndDialog(0);
  }

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgFTPFirmware::OnDownload() 
{
  int rc;
	
	CFtpConnection* m_pFtpConnection;
	CInternetSession* m_pInetSession;

  if (m_list.GetTextLen(m_list.GetCurSel())== -1) { 
    AfxMessageBox(IDS_FIRMWARE_NOFILE_SELECTED,MB_ICONEXCLAMATION);
    return;
  }

  CString filename;
  m_list.GetText(m_list.GetCurSel(), filename);

  // Strip the "ftp://...." from the selected filename so we only have "filename.bin"
  CString str;
  str = filename.Right(filename.GetLength() - filename.ReverseFind('/'));
  str.Delete(0);

  // Get a save filename for the file (suggest the same name as on the FTP site)
	CFileDialog filedialog(
 	  FALSE,                                         // Save File Dialog
		"bin",                                        // Default extension
		str,                                         //  default filename
		OFN_ENABLESIZING | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR,       // OPENFILENAME flags
		"BIN file|*.bin||");                         // Filter strings

  if (filedialog.DoModal()==IDOK) {
    m_destinationfile = filedialog.GetPathName();
  } else {
    return;
  }

  // Let upto 10 messages pass by so the user sees some response from Windows...
  MSG msg;
  for (int i=0; i<10; i++) {
    if (::PeekMessage(&msg, NULL, 0, 0, PM_NOYIELD | PM_REMOVE)) {
      ::TranslateMessage(&msg);			
      ::DispatchMessage(&msg);			
    }
  }


  m_pInetSession = new CInternetSession("TESTAPP", 1, PRE_CONFIG_INTERNET_ACCESS);

	// Alert the user if the internet session could not be started
	if (!m_pInetSession)
	{
		AfxMessageBox("Bad session", MB_OK|MB_ICONEXCLAMATION);
		OnCancel();
	}

  BeginWaitCursor();

  try
	{
		m_pFtpConnection = m_pInetSession->GetFtpConnection(ftpaddress, userid, password, INTERNET_INVALID_PORT_NUMBER, TRUE);
	}
	catch (CInternetException* pEx)
	{
		// catch errors from WinINet
		TCHAR szErr[1024];
		if (pEx->GetErrorMessage(szErr, 1024))
			AfxMessageBox(szErr, MB_OK|MB_ICONEXCLAMATION);
		else
			AfxMessageBox("Exception", MB_OK|MB_ICONEXCLAMATION);
		pEx->Delete();

		m_pFtpConnection = NULL;
	}

  // Go get the file
  rc = m_pFtpConnection->GetFile(str, m_destinationfile, false);

  if (rc==0) {
    m_destinationfile="";
    AfxMessageBox(IDS_FIRMWARE_ERROR_GETTING_FILE,MB_ICONEXCLAMATION);
  }

  m_pFtpConnection->Close();
	m_pInetSession->Close();
  
  delete m_pFtpConnection;  
  delete m_pInetSession;

  EndWaitCursor();
  if (rc!=0)
    EndDialog(1);

}

void CDlgFTPFirmware::OnDblclkList() 
{
  OnDownload();	
}
