// DlgFilesysInput.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "DlgFilesysInput.h"
#include "afxdialogex.h"


// CDlgFilesysInput dialog

IMPLEMENT_DYNAMIC(CDlgFilesysInput, CDialog)

CDlgFilesysInput::CDlgFilesysInput(CWnd* pParent /*=NULL*/)
   : CDialog(CDlgFilesysInput::IDD, pParent)
   , m_NewName(_T(""))
   , m_type(0)
{
}

CDlgFilesysInput::~CDlgFilesysInput()
{
}

void CDlgFilesysInput::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDOK, c_btn_on);
   DDX_Control(pDX, IDC_TEXT_NEW_NAME, c_text_newname);
   DDX_Text(pDX, IDC_EDIT_NEW_NAME, m_NewName);
}

BEGIN_MESSAGE_MAP(CDlgFilesysInput, CDialog)
   ON_EN_CHANGE(IDC_EDIT_NEW_NAME, &CDlgFilesysInput::OnChangeEdit)
END_MESSAGE_MAP()

BOOL CDlgFilesysInput::OnInitDialog()
{
   // Default
   CDialog::OnInitDialog();

   // Rename file
   if (m_type==0)
   {
      // Build title
      CString Title(_T("Rename file - "));
      Title += m_text;
      // Set title
      SetWindowText(Title);
      // Limit text
      ((CEdit*)GetDlgItem(IDC_EDIT_NEW_NAME))->LimitText(12);
   }
   // Create directory
   else if (m_type==1)
   {
      // Set title
      SetWindowText(_T("New directory"));
      // Set text
      c_text_newname.SetWindowText(_T("Directory name:"));
      // Limit text
      ((CEdit*)GetDlgItem(IDC_EDIT_NEW_NAME))->LimitText(8);
   }
   // New folder
   else if (m_type==2)
   {
      // Set title
      SetWindowText(_T("New folder"));
      // Set text
      c_text_newname.SetWindowText(_T("Folder name:"));
      // Limit text
      ((CEdit*)GetDlgItem(IDC_EDIT_NEW_NAME))->LimitText(20);
   }
   // Rename user file
   else if (m_type==3)
   {
      // Build title
      CString Title(_T("Rename file - "));
      Title += m_text;
      // Set title
      SetWindowText(Title);
      // Limit text
      ((CEdit*)GetDlgItem(IDC_EDIT_NEW_NAME))->LimitText(20);
   }

   // Set controls
   c_btn_on.EnableWindow(false);

   // Completed
   return TRUE;
}

void CDlgFilesysInput::OnChangeEdit()
{
   // Var
   bool enable = true;
   int  pos, len;

   // Update variables
   UpdateData(TRUE);

   // Rename file?
   if (m_type==0)
   {
      // Find '.'
      pos = m_NewName.Find(_T('.'));
      len = m_NewName.GetLength() - pos;
      if (pos<1 || pos>8 || len<2 || len>4)
         enable = false;
   }
   // Rename user file
   else if (m_type==3)
   {
      if (m_NewName.Find(_T('.')) < 1)
         enable = false;
   }

   // Enable ok?
   c_btn_on.EnableWindow(enable);
}
