// DlgPDUSend.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "DlgPDUSend.h"
#include "afxdialogex.h"


// CDlgPDUSend dialog

IMPLEMENT_DYNAMIC(CDlgPDUSend, CDialog)

CDlgPDUSend::CDlgPDUSend(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPDUSend::IDD, pParent)
{
   m_dcs = _T("");
   m_length = 0;
}

CDlgPDUSend::~CDlgPDUSend()
{
}

void CDlgPDUSend::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_EDITPDU, m_Edit);
   DDX_Text(pDX, IDC_DCS, m_dcs);
   DDX_Text(pDX, IDC_LENGTH, m_length);
   DDV_MinMaxInt(pDX, m_length, 0, 140);
}

BEGIN_MESSAGE_MAP(CDlgPDUSend, CDialog)
   ON_WM_DESTROY()
   ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

// CDlgPDUSend message handlers

BOOL CDlgPDUSend::OnInitDialog() 
{
   CDialog::OnInitDialog();

   CRect rc;
   GetWindowRect(&rc);
   WINDOWPLACEMENT wp;
   // Check that the size of the dialog hasn't changed (allow max 4 pixels in both directions)
   if (ReadWindowPlacement(&wp))
   {
      if (((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
          ((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC))
      {
         wp.showCmd=false;
         SetWindowPlacement(&wp);
      }
   }

   return TRUE;
}

void CDlgPDUSend::OnDestroy() 
{
   // before it is destroyed, save the position of the window
   WINDOWPLACEMENT wp;
   wp.length = sizeof wp;
   if (GetWindowPlacement(&wp))
   {
      wp.flags = 0;
      if (IsZoomed())
         wp.flags |= WPF_RESTORETOMAXIMIZED;
      // and write it to the .INI file
      WriteWindowPlacement(&wp);
   }

   CDialog::OnDestroy();
}

void CDlgPDUSend::PostNcDestroy()
{
   // Cleanup dialog
   CDialog::PostNcDestroy();
   delete this;
}

void CDlgPDUSend::OnCancel() 
{
   ShowWindow(SW_HIDE);
}

void CDlgPDUSend::OnOK() 
{
   if (!UpdateData(true)) return;
   // Fetch the data from the internal copy held in HexEdit control
   m_Edit.GetData(PDUBuffer, sizeof(PDUBuffer));
   ShowWindow(SW_HIDE);
//   GetParent()->PostMessage(UWM_OPTION_VALIDATE, 0, 0);
}

void CDlgPDUSend::OnLButtonDown(UINT nFlags, CPoint point) 
{
   PostMessage (WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x,point.y));
   CDialog::OnLButtonDown(nFlags, point);
}

void CDlgPDUSend::OpenDialog(void)
{
   m_Edit.m_bpr=8;
   m_Edit.SetOptions(true, true, true, false);
   // Give HexEdit a copy of our data
   m_Edit.SetData(PDUBuffer, sizeof(PDUBuffer));
   m_dcs="0xF5";
   UpdateData(false);
   ShowWindow(SW_SHOW);
}

BOOL CDlgPDUSend::ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
   CString strBuffer = AfxGetApp()->GetProfileString(_T("UnitPDU"), _T("WindowPos"));
   if (strBuffer.IsEmpty()) return FALSE;

   WINDOWPLACEMENT wp;
   int nRead = _stscanf_s(
                          strBuffer,
                          _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d"),
                          &wp.flags,
                          &wp.showCmd,
                          &wp.ptMinPosition.x,
                          &wp.ptMinPosition.y,
                          &wp.ptMaxPosition.x,
                          &wp.ptMaxPosition.y,
                          &wp.rcNormalPosition.left,
                          &wp.rcNormalPosition.top,
                          &wp.rcNormalPosition.right,
                          &wp.rcNormalPosition.bottom
                         );

   if (nRead != 10)
   return FALSE;

   wp.length = sizeof wp;
   *pwp = wp;
   return TRUE;
}

void CDlgPDUSend::WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
{
   TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

   wsprintf(
            szBuffer,
            _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d"),
            pwp->flags,
            pwp->showCmd,
            pwp->ptMinPosition.x,
            pwp->ptMinPosition.y,
            pwp->ptMaxPosition.x,
            pwp->ptMaxPosition.y,
            pwp->rcNormalPosition.left,
            pwp->rcNormalPosition.top,
            pwp->rcNormalPosition.right,
            pwp->rcNormalPosition.bottom
           );
   AfxGetApp()->WriteProfileString(_T("UnitPDU"), _T("WindowPos"), szBuffer);
}
