// DlgPopup.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "afxdialogex.h"
#include "DlgPopup.h"


// CDlgPopup dialog

IMPLEMENT_DYNAMIC(CDlgPopup, CDialogEx)

CDlgPopup::CDlgPopup(CWnd* pParent /*=NULL*/)
  : CDialogEx(CDlgPopup::IDD, pParent)
  , visible_(false)
  , close_(false)
{
}

CDlgPopup::~CDlgPopup()
{
}

void CDlgPopup::DoDataExchange(CDataExchange* pDX)
{
  CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDlgPopup, CDialogEx)
  ON_WM_DESTROY()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CDlgPopup::OnInitDialog()
{
  // Default initialize
  CDialogEx::OnInitDialog();

  // Completed
  return TRUE;
}

void CDlgPopup::OnDestroy()
{
  Close();
  CDialogEx::OnDestroy();
}

void CDlgPopup::PostNcDestroy()
{
  CDialogEx::PostNcDestroy();
  delete this;
}

/////////////////////////////////////////////////////////////////////////////
// Fail safe
/////////////////////////////////////////////////////////////////////////////

void CDlgPopup::OnCancel()
{
  close_ = true;
}

void CDlgPopup::OnOK()
{
  close_ = true;
}

/////////////////////////////////////////////////////////////////////////////
// Show Popup Message
/////////////////////////////////////////////////////////////////////////////

void CDlgPopup::MessageBox(const CString &message, const CString &title)
{
  if (visible_) return;
  visible_ = true;
  close_   = false;

  // Configure window
  CenterWindow();

  // Set window text
  SetWindowText(title);
  SetDlgItemText(IDC_TEXT, message);
  ShowWindow(SW_SHOW);
  while (!close_) {
    MSG msg;
    Sleep(100);
    for (int i=0; i<10; i++) {
      if (::PeekMessage(&msg, NULL, 0, 0, PM_NOYIELD | PM_REMOVE)) {
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
      }
      if (close_) break;
    }
  };

  // Completed
  ShowWindow(SW_HIDE);
  visible_ = false;
}

void CDlgPopup::Close(void)
{
  if (visible_) {
    // Var
    int timeout = 50;

    // Close dialog
    close_ = true;

    // Wait until dialog is closed or timeout
    while (timeout-- > 0 && visible_) {
      MSG msg;
      Sleep(100);
      for (int i=0; i<10; i++) {
        if (::PeekMessage(&msg, NULL, 0, 0, PM_NOYIELD | PM_REMOVE)) {
          ::TranslateMessage(&msg);
          ::DispatchMessage(&msg);
        }
        if (!visible_) break;
      }
    }
  }
}
