// DlgUpload.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "DlgUpload.h"
#include "RTCUProgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgUpload dialog


CDlgUpload::CDlgUpload(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgUpload::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgUpload)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
   m_type               = 1; // Direct as default
   m_report.AppHeadSeg  = 0;
   m_report.FWHeadSeg   = 0;
   m_CancelInProgress   = false;
   m_UploadInProgress   = false;
   m_SilentVoice        = false;
   m_Busy               = false;
}


void CDlgUpload::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgUpload)
	DDX_Control(pDX, IDCANCEL, m_ctrcancel);
	DDX_Control(pDX, IDC_STATUS, m_ctrstatus);
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgUpload, CDialog)
	//{{AFX_MSG_MAP(CDlgUpload)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("dlgUpload");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf_s(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's ini file
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// Start upload
/////////////////////////////////////////////////////////////////////////////

BOOL CDlgUpload::OnInitDialog() 
{
   // Default init
	CDialog::OnInitDialog();

   // Windows Position
   WINDOWPLACEMENT wp;
   if( ReadWindowPlacement(&wp) ) {
      CRect rc;
      GetWindowRect(&rc);
      if( ((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
          ((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC)) {
         wp.showCmd = false;
   	   SetWindowPlacement(&wp);
      }
   }

   // Init progress bar
   m_progress.SetRange( 0, 100 );
   UpdateData(false);

   // Completed
	return TRUE;
}

void CDlgUpload::OnDestroy() 
{
   // before it is destroyed, save the position of the window
   WINDOWPLACEMENT wp;
   wp.length = sizeof wp;
   if( GetWindowPlacement(&wp) )
   {
      wp.flags = 0;
      if( IsZoomed() )
         wp.flags |= WPF_RESTORETOMAXIMIZED;
      // and write it to the .INI file
      WriteWindowPlacement(&wp);
   }

   CDialog::OnDestroy();
}

void CDlgUpload::OnTimer(UINT nIDEvent) 
{
   // Stop Timer
   KillTimer(nIDEvent);

   // Start upload
   if( nIDEvent == 111 ) {
      DWORD ThreadId;
      CreateThread(NULL, 0x200000, thProg, this, 0, &ThreadId);
      m_UploadInProgress = true;
   }
   // Wait for reset
   else if( nIDEvent == 999 ) {
      // Are the reset completed?
      if( rmonConnected(hCon) == RMONCON_NONE ) {
         // Update status text
         m_ctrstatus.SetWindowText("Waiting for RTCU unit to reset");
         m_ctrcancel.SetFocus();
         // Restart waiting timer
         SetTimer( 999, 1000, NULL );
      }
      else {
         // Start timer
         SetTimer( 111, 500, NULL );
      }
   }

	// Default
	CDialog::OnTimer(nIDEvent);
}

void CDlgUpload::OnCancel() 
{
   // Var
   CString text;

   // Retrieve button text
   m_ctrcancel.GetWindowText(text);

   // Close?
   if( text == _T("Cancel") )
   {
      if(AfxMessageBox("Are you sure you wish to cancel upload?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDYES)
         m_CancelInProgress = true;
   }
   else
   {
      // Retrieve pointer to parent dlg
      CRTCUProgDlg* pParent = (CRTCUProgDlg*)GetParent();

      // When background upload selected
      if( m_type == 0 ) {
         // Application
         if( !m_filenameapp.IsEmpty() ) {
            // Interrupted
            if( m_report.AppHeadSeg > 0 ) {
               pParent->SaveReportFile( m_SerialNumber, m_report, m_filenameapp );
            } else {
               pParent->DeleteReportFile(m_SerialNumber);
            }
         // Firmware
         } else if( !m_filenamefw.IsEmpty() ) {
            // Interrupted
            if( m_report.FWHeadSeg > 0 ) {
               pParent->SaveReportFile( m_SerialNumber, m_report, m_filenamefw );
            } else {
               pParent->DeleteReportFile(m_SerialNumber);
            }
         }
      }

      // Enable uploads
      m_CancelInProgress = false;
      m_UploadInProgress = false;
      m_SilentVoice      = false;
      m_Busy             = false;
      m_filenameapp.Empty();
      m_filenamefw.Empty();
      pParent->UpdateResume();
      ShowWindow(false);
      m_progress.SetPos(0);
      m_ctrstatus.SetWindowText("");
   }
}

/////////////////////////////////////////////////////////////////////////////
// Progress callback
/////////////////////////////////////////////////////////////////////////////

static int RMONCC cbfunc( void* pThis, int percentdone )
{
   // Update progress
   ((CDlgUpload*)pThis)->m_progress.SetPos(percentdone);

   // Cancel transfer?
   if(((CDlgUpload*)pThis)->m_CancelInProgress) {
	   // Reply: Cancel!
	   return 1;
   }

   // Reply: Continue
   return 0;
}

static int RMONCC cbfuncVoice( void* pThis, int percentdone )
{
   // Update progress
   ((CDlgUpload*)pThis)->m_progress.SetPos(percentdone);

   // Cancel transfer?
   if(((CDlgUpload*)pThis)->m_CancelInProgress) {
	   // Reply: Cancel!
	   return 1;
   }

   // Reply: Continue
   return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Upload application
/////////////////////////////////////////////////////////////////////////////

void CDlgUpload::AppBackground()
{
   rmonRet rc;
   rmonBGReport Report;
   int conditions;

   // Change button
   m_ctrcancel.SetWindowText(_T("Cancel"));
   m_filenameapp.MakeUpper();

   m_progress.SetPos(0);
   BeginWaitCursor();

   unsigned char Programmable, Project=0;
   rc = rmonIsUnitProgrammable(hCon, &Programmable);
   if (rc != 0) {
      AfxMessageBox("Failed to determine if unit is programmable.!");
      m_ctrstatus.SetWindowText(_T("Failed"));
      m_ctrcancel.SetWindowText(_T("Close"));
      m_ctrcancel.SetFocus();
      m_Busy = false;
      return;
   }
   DEBUGMSG("Unit is programmable : %s", (Programmable == 0 ? "No" : "Yes"));

   // Check if it's a PRJ file that is loaded...
   if( m_filenameapp.Find(".PRJ") != -1 ) {
      Project=1;

      if(!Programmable) {
         m_filenameapp.Delete(m_filenameapp.Find(".PRJ"), 4);
         CFileStatus status;
         // If there is no PSX file, and the unit is NOT programmable, report error !
         if( !CFile::GetStatus(m_filenameapp+".PSX", status ) ) {
            AfxMessageBox("Unit is a Micro unit, and there is no associated PSX file for the selected project!");
            m_ctrstatus.SetWindowText(_T("Failed"));
            m_ctrcancel.SetWindowText(_T("Close"));
            m_ctrcancel.SetFocus();
            m_Busy = false;
            return;
         }
         // Change filename 
         m_filenameapp += ".PSX";
      }
      else {
         // get filename from project
         CString appfile = "";
         rc = rmonApplicationFilename(m_filenameapp, appfile.GetBufferSetLength(256));
         appfile.ReleaseBuffer();

         if (rc != 0) {
            AfxMessageBox("Failed to get associated application file for the selected project!");
            m_ctrstatus.SetWindowText(_T("Failed"));
            m_ctrcancel.SetWindowText(_T("Close"));
            m_ctrcancel.SetFocus();
            m_Busy = false;
            return;
         }

         // Change filename 
         m_filenameapp = appfile;
      }
   }
   else if( !Programmable && m_filenameapp.Right(4) != ".PSX" ) {
      AfxMessageBox("Unit is not programmable!");
      m_ctrstatus.SetWindowText(_T("Unit is not programmable!"));
      m_ctrcancel.SetWindowText(_T("Close"));
      m_ctrcancel.SetFocus();
      m_Busy = false;
      return;
   }
   DEBUGMSG("Programmable = %d, filename ='%s'\n", Programmable, m_filenameapp);

   // Is there any special conditions to transfer
   if (rmonCheckTransfer(hCon, 2, m_filenameapp, &conditions)) {
      AfxMessageBox(_T("Error communicating with unit!"),MB_OK|MB_ICONSTOP);
      m_ctrcancel.SetWindowText(_T("Close"));
      m_ctrcancel.SetFocus();
      m_Busy = false;
      return;
   }
   if (conditions == 1) {
      if (AfxMessageBox(_T("This will overwrite Voice messages\n\nContinue anyway?"),MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION) == IDNO) {
         m_ctrcancel.SetWindowText(_T("Close"));
         m_ctrcancel.SetFocus();
         m_Busy = false;
         return;
      }
   }

   // Status
   m_ctrstatus.SetWindowText("Uploading application");

   EndWaitCursor();

   DEBUGMSG("start upload\n");
   // Start upload
   if( m_report.AppHeadSeg == 0 ) {
      // Build BUR object
      Report.extSeg  = 0;
      Report.headSeg = 0;

      // Program unit
      rc = rmonApplicationStartUpload(hCon, m_filenameapp.GetBuffer(0), &Report, cbfunc, this);
   }
   // Resume upload
   else {
      // Build BUR object
      Report.extSeg  = m_report.AppCodeSeg;
      Report.headSeg = m_report.AppHeadSeg;

      // Program unit
      rc = rmonApplicationResumeUpload(hCon, m_filenameapp.GetBuffer(0), &Report, cbfunc, this);
   }

   CString strStatus;
   switch(rc) {
      case rmonOK:              strStatus = "Data transferred to RTCU successfully"; break;
      case rmonComError:        strStatus = "Error when communicating with RTCU"; break;
      case rmonIllegalFile:     strStatus = "The selected file is NOT a valid application file"; break;
      case rmonNotProgrammable: strStatus = "Unit is not programmable (unit is a Micro unit)"; break;
      case rmonErrorHalt:       strStatus = "Could not halt unit"; break;
      case rmonNoBackground:    strStatus = "Target does not support background upload"; break;
      case rmonInterrupted:     strStatus = "Upload interrupted"; break;
      case rmonCancelled:       strStatus = "Upload cancelled"; break;
      case rmonFileNotFound:
        if (Project)            strStatus = "Project binary file not found\nPlease ensure that the project is build.";
        else                    strStatus = "File not found";
        break;
      case rmonIllegalHandle:   strStatus = "Connection to unit not open."; break;
      case rmonTargetError:     strStatus = "Update image not identical. Restart transfer."; break;
      case rmonIllegalTarget:   strStatus = "The connected device does not support features used by the project\n(Debug, Floating point or Large String Support)."; break;
      case rmonImageTooLarge:   strStatus = "Application is too large for connected unit"; break;
      case rmonImageSupport:    strStatus = "The application image is not supported by the connected device"; break;
      default:                  strStatus.Format("Error: %d",rc); break;
   }

   if( rc == rmonOK ) {
      // Change status text
      m_ctrstatus.SetWindowText(strStatus);
      // Clear BUR
      m_report.AppCodeSeg = 0;
      m_report.AppHeadSeg = 0;
   }
   else {
      // Change BUR
      m_report.AppCodeSeg = Report.extSeg;
      m_report.AppHeadSeg = Report.headSeg;
      // Change status text
      if( rc == rmonInterrupted || rc == rmonCancelled )
         m_ctrstatus.SetWindowText(strStatus);
      else
         m_ctrstatus.SetWindowText("Error");
      if( rc == rmonInterrupted )
         MessageBox(_T("Communication to the RTCU unit has been interrupted. Connection has been terminated"));
      else
         MessageBox(strStatus);
   }

   if( rc == rmonInterrupted && rmonConnected(hCon) != RMONCON_LOCAL && rmonConnected(hCon) != RMONCON_NONE )
      rmonDisconnect(hCon);

   m_ctrcancel.SetWindowText(_T("Close"));
   m_ctrcancel.SetFocus();
   m_Busy = false;
}

void CDlgUpload::AppDirect()
{
   // Var
   int            NumFiles, report;
   rmonRet        rc;
   unsigned char  Programmable, Project=0;
   bool           do_voice = false;
   CString        application_file;
   CString s;

   m_filenameapp.MakeUpper();

   // Change button
   m_ctrcancel.SetWindowText(_T("Cancel"));

   // Update
   m_progress.SetPos(0);
   BeginWaitCursor();

   rmonIsUnitProgrammable(hCon, &Programmable);

   if( m_filenameapp.Find(".PRJ") != -1 ) {
      Project=1;

      // Get the filename from the project...
      rc = rmonApplicationFilename(m_filenameapp, application_file.GetBufferSetLength(256));
      application_file.ReleaseBuffer();
      application_file.MakeUpper();
      if (rc != 0) {
         AfxMessageBox("Failed to get associated application file for the selected project!");
         m_ctrstatus.SetWindowText(_T("Failed"));
   m_ctrcancel.SetWindowText(_T("Close"));
         m_ctrcancel.SetFocus();
         m_Busy = false;
         return;
      }
      if (application_file.Find(".RPC") == -1) {
         // Check if any voice files present
         rc = rmonNumOfVoiceMessages( m_filenameapp.GetBuffer(0), &NumFiles );
         // Voice files in prj file, ask if they should be uploaded....
         if( (rc == rmonOK) && NumFiles) {
            // Is there any special conditions to transfer
            rc = rmonCheckTransfer(hCon, 5, NULL, &report);
            if (rc == rmonOK) {
               if (report == 3) {
                  if (!m_SilentVoice) {
                     AfxMessageBox(_T("Voice transfer not possible due to pending background update"), MB_OK|MB_ICONSTOP);
                  }
               } else {
                  if (m_SilentVoice) {
                     do_voice = true;
                  } else {
                     if (AfxMessageBox("The project contains voice messages, do you also want to transfer these to the RTCU?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDYES)
                        do_voice = true;
                  }
               }
            }
         }
      }
      m_filenameapp.Delete(m_filenameapp.Find(".PRJ"), 4);

      if(!Programmable) {
         CFileStatus status;
         // If there is no PSX file, and the unit is NOT programmable, report error !
         if( !CFile::GetStatus(m_filenameapp+".PSX",status) ) {
            AfxMessageBox("Unit is a Micro unit, and there is no associated PSX file for the selected project!");
            m_ctrstatus.SetWindowText(_T("No associated PSX file for the selected project!"));
            m_ctrcancel.SetWindowText(_T("Close"));
            m_ctrcancel.SetFocus();
            m_Busy = false;
            return;
         }
         // Unit is not programmable, try with a PSX file...  
         s  = m_filenameapp + ".PSX";
      }
      else {
         s = application_file;
      }
   }
   else {
      s = m_filenameapp;
   }
   DEBUGMSG("start upload\n");

   m_ctrstatus.SetWindowText("uploading application");
   rc = rmonApplicationUpload(hCon, s.GetBuffer(0), cbfunc, this);

   if( do_voice && rc == rmonOK ) {
      s  = m_filenameapp + ".PRJ";
      m_ctrstatus.SetWindowText("Uploading voice");
      m_progress.SetPos(0);
      rc = rmonVoiceUpload(hCon, s.GetBuffer(0), cbfuncVoice, this);
   }

   EndWaitCursor();

   CString strStatus;
   switch(rc) {
      case rmonOK:               strStatus = "Data transferred to RTCU successfully"; break;
      case rmonComError:         strStatus = "Error when communicating with RTCU"; break;
      case rmonIllegalFile:      strStatus = "The selected file is NOT a valid application file"; break;
      case rmonNotProgrammable:  strStatus = "Unit is not programmable (unit is a Micro unit)"; break;
      case rmonErrorHalt:        strStatus = "Could not halt unit"; break;
      case rmonCancelled:        strStatus = "Upload cancelled"; break;
      case rmonFileNotFound:
        if (Project)             strStatus = "Project binary file not found\nPlease ensure that the project is build.";
        else                     strStatus = "File not found";
        break;
      case rmonIllegalHandle:    strStatus = "Connection to unit not open."; break;
      case rmonTargetError:      strStatus = "Error when communicating with RTCU."; break;
      case rmonIllegalTarget:
        if (m_targetid > 100)    strStatus = "The connected device does not support features used by the project\n(Debug, Floating point or Large String Support).";
        else                     strStatus = "The connected unit does not support the X32 project setting";
        break;
			case rmonMemoryConfig:     strStatus = "Memory configuration in project is different from unit"; break;
			case rmonImageTooLarge:    strStatus = "Data is too large for connected unit"; break;
			case rmonImageSupport:     strStatus = "The application image is not supported by the connected device"; break;
   }

   if( rc == rmonOK ) 
      m_ctrstatus.SetWindowText(strStatus);
   else {
      if( rc == rmonCancelled )
         m_ctrstatus.SetWindowText(strStatus);
      else
         m_ctrstatus.SetWindowText("Error");
      MessageBox(strStatus);
   }

   m_ctrcancel.SetWindowText(_T("Close"));
   m_ctrcancel.SetFocus();
   m_Busy = false;

   if( rmonReset(hCon) != rmonOK ) 
      AfxMessageBox("Could not reset unit !");
}

/////////////////////////////////////////////////////////////////////////////
// Upload firmware
/////////////////////////////////////////////////////////////////////////////

void CDlgUpload::FWBackground()
{
   // Var
   rmonRet rc;
   CString strStatus;
   rmonBGReport Report;
   int conditions;

   // Is there any special conditions to transfer
   if (rmonCheckTransfer(hCon, 4, m_filenamefw, &conditions)) {
      AfxMessageBox(_T("Error communicating with unit!"),MB_OK|MB_ICONSTOP);
      return;
   }
   if (conditions == 1) {
      if (AfxMessageBox(_T("This will overwrite Voice messages\n\nContinue anyway?"), MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION) == IDNO) {
         return;
      }
   }
   if (conditions == 2) {
      MessageBox(_T("The selected firmware requires that\nfirmware version 3.00 is applied first"));
      return;
   }

   // Change button
   m_ctrcancel.SetWindowText(_T("Cancel"));

   m_progress.SetPos(0);
   BeginWaitCursor();

   // Status text
   strStatus.LoadString(IDS_PROGRAMMING_FIRMWARE);
   m_ctrstatus.SetWindowText(strStatus);

   // Start upload
   if( m_report.FWHeadSeg == 0 ) {
      // Build BUR object
      Report.extSeg  = 0;
      Report.intSeg  = 0;
      Report.headSeg = 0;

      // Program unit
      rc = rmonFirmwareStartUpload(hCon, m_filenamefw.GetBuffer(0), &Report, cbfunc, this);
   }
   // Resume upload
   else {
      // Build BUR object
      Report.extSeg  = m_report.FWCodeSeg;
      Report.intSeg  = m_report.FWConstSeg;
      Report.headSeg = m_report.FWHeadSeg;

      // Program unit
      rc = rmonFirmwareResumeUpload(hCon, m_filenamefw.GetBuffer(0), &Report, cbfunc, this);
   }

   EndWaitCursor();
   switch(rc) {
      case rmonOK:            strStatus.LoadString(IDS_FIRMWARE_SUCCESS); break;
      case rmonComError:      strStatus.LoadString(IDS_FIRMWARE_DOWNLOAD_ERROR); break;
      case rmonIllegalFile:   strStatus.LoadString(IDS_FIRMWARE_WRONG_FILE); break;
      case rmonIllegalTarget: strStatus.LoadString(IDS_FIRMWARE_INVALID_TARGET); break;
      case rmonNoBackground:  strStatus = "Background transfer is not supported on the connected RTCU !"; break;
      case rmonInterrupted:   strStatus = "Upload interrupted"; break;
      case rmonCancelled:     strStatus = "Upload cancelled"; break;
      case rmonOldFormat:     strStatus = "The selected firmware is out of date. Please use a later version."; break;
      case rmonFileNotFound:  strStatus = "File not found"; break;
      case rmonIllegalHandle: strStatus = "Connection to unit not open."; break;
      case rmonTargetError:   strStatus = "Update image not identical. Restart transfer."; break;
      case rmonDowngrade:     strStatus = "The version of the selected firmware is not supported by the unit. Please use a later version."; break;
      default:                strStatus = "Unknown error"; break;
   }

   if( rc == rmonOK ) {
      // Update status text
      m_ctrstatus.SetWindowText(strStatus);
      // Update BUR
      m_report.FWCodeSeg   = 0;
      m_report.FWConstSeg  = 0;
      m_report.FWHeadSeg   = 0;
   }
   else {
      // Update BUR
      m_report.FWCodeSeg   = Report.extSeg;
      m_report.FWConstSeg  = Report.intSeg;
      m_report.FWHeadSeg   = Report.headSeg;
      // Update status text
      if( rc == rmonInterrupted || rc == rmonCancelled )
         m_ctrstatus.SetWindowText(strStatus);
      else
         m_ctrstatus.SetWindowText("Error");
      if( rc == rmonInterrupted )
         MessageBox(_T("Communication to the RTCU unit has been interrupted. Connection has been terminated"));
      else
         MessageBox(strStatus);
   }

   if( rc == rmonInterrupted && rmonConnected(hCon) != RMONCON_LOCAL && rmonConnected(hCon) != RMONCON_NONE )
      rmonDisconnect(hCon);

   m_ctrcancel.SetWindowText(_T("Close"));
   m_ctrcancel.SetFocus();
   m_Busy = false;
}

void CDlgUpload::FWDirect()
{
   // Var
   rmonRet rc;
   CString strStatus;
   int report;

   // Is there any special conditions to transfer
   if (rmonCheckTransfer(hCon, 3, m_filenamefw, &report)) {
      AfxMessageBox(_T("Error communicating with unit!"), MB_OK|MB_ICONSTOP);
      return;
   }
   if (report == 1) {
      if (AfxMessageBox(_T("This will overwrite Voice messages\n\nContinue anyway?"), MB_YESNO|MB_DEFBUTTON2|MB_ICONEXCLAMATION) == IDNO) {
         return;
      }
   }
   if (report == 2) {
      MessageBox(_T("The selected firmware requires that\nfirmware version 3.00 is applied first"));
      return;
   }

   // Change button
   m_ctrcancel.SetWindowText(_T("Cancel"));

   m_progress.SetPos(0);
   BeginWaitCursor();

   // Status text
   strStatus.LoadString(IDS_PROGRAMMING_FIRMWARE);
   m_ctrstatus.SetWindowText(strStatus);

   rc = rmonFirmwareUpload(hCon, m_filenamefw.GetBuffer(0), cbfunc, this);

   EndWaitCursor();

   switch(rc) {
      case rmonOK:            strStatus.LoadString(IDS_FIRMWARE_SUCCESS); break;
      case rmonNoMonitorMode: strStatus.LoadString(IDS_FIRMWARE_NOSTARTMONITOR); break;
      case rmonComError:      strStatus.LoadString(IDS_FIRMWARE_DOWNLOAD_ERROR); break;
      case rmonErrorReset:    strStatus.LoadString(IDS_DOWNLOAD_RESET_FAIL); break;
      case rmonIllegalFile:   strStatus.LoadString(IDS_FIRMWARE_WRONG_FILE); break;
      case rmonIllegalTarget: strStatus.LoadString(IDS_FIRMWARE_INVALID_TARGET); break;
      case rmonTargetError:   strStatus = "This operation is not supported on the connected RTCU !"; break;
      case rmonCancelled:     strStatus = "Upload cancelled"; break;
      case rmonOldFormat:     strStatus = "The selected firmware is out of date. Please use a later version."; break;
      case rmonFileNotFound:  strStatus = "File not found"; break;
      case rmonIllegalHandle: strStatus = "Connection to unit not open."; break;
      case rmonNotGateway:    strStatus = "Firmware cannot be transferred via Gateway."; break;
      case rmonDowngrade:     strStatus = "The version of the selected firmware is not supported by the unit. Please use a later version."; break;
      default:                strStatus = "Unknown error"; break;
   }

   if( rc == rmonOK )
      m_ctrstatus.SetWindowText(strStatus);
   else {
	  if( rc == rmonCancelled )
         m_ctrstatus.SetWindowText(strStatus);
      else
         m_ctrstatus.SetWindowText("Error");
      MessageBox(strStatus);
   }

   if( rc == rmonOK && !m_filenameapp.IsEmpty() ) {
      m_filenamefw.Empty();
      SetTimer( 999, 1000, NULL );
   } else {
      m_Busy = false;
   }

   m_ctrcancel.SetWindowText(_T("Close"));
   m_ctrcancel.SetFocus();
}

/////////////////////////////////////////////////////////////////////////////
// Multi thread upload
/////////////////////////////////////////////////////////////////////////////

unsigned long __stdcall CDlgUpload::thProg( LPVOID lpvParam )
{
   // Pointer
   CDlgUpload* pDoc = (CDlgUpload*)lpvParam;
   // Test pointer
   if(pDoc) {
      // Firmware selected?
      if( !pDoc->m_filenamefw.IsEmpty() ) {
         // Direct or Background upload
         if(pDoc->m_type) pDoc->FWDirect(); else pDoc->FWBackground();
      }
      // Application selected?
      else if( !pDoc->m_filenameapp.IsEmpty() ) {
         // Direct or Background upload
         if(pDoc->m_type) pDoc->AppDirect(); else pDoc->AppBackground();
      }
   }
   // Reply
   return 0;
}
