// Options.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "Options.h"
#include "afxdialogex.h"


// COptions dialog

IMPLEMENT_DYNAMIC(COptions, CDialog)

COptions::COptions(CWnd* pParent /*=nullptr*/)
	: CDialog(IDD_OPTIONS, pParent)
	, m_password(_T(""))
	, m_debugenable(FALSE)
{
}

COptions::~COptions()
{
}

void COptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMPORTCABLE, c_portcable);
	DDX_Text(pDX, IDC_COMPORTCABLE, m_comportcable);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDV_MaxChars(pDX, m_password, 20);
	DDX_Check(pDX, IDC_DEBUG_ENABLE, m_debugenable);
}

BEGIN_MESSAGE_MAP(COptions, CDialog)
END_MESSAGE_MAP()

// COptions message handlers

BOOL COptions::OnInitDialog()
{
	// Var
	CString str, strList, f;
	char    ports[RMON_MAXPORTS][9];
	int     i, size;

	// Default
	CDialog::OnInitDialog();

	// Fill comport lists
	c_portcable.AddString(_T("NONE"));
	c_portcable.AddString(_T("USB1"));
	if (rmonGetPortList(ports, &size) == rmonOK) {
		for (i = 0; i < size; i++) {
			c_portcable.AddString(_T(ports[i]));
		}
	}

	// Select comports
	if (m_comportcable.IsEmpty() || m_comportcable == _T("COM0"))
		c_portcable.SetCurSel(0);
	else
		c_portcable.SelectString(-1, m_comportcable);

	// Completed
	return TRUE;
}
