// OptionsPageCfg.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "OptionsPageCfg.h"


// COptionsPageCfg dialog

IMPLEMENT_DYNAMIC(COptionsPageCfg, CPropertyPage)

COptionsPageCfg::COptionsPageCfg()
  : CPropertyPage(COptionsPageCfg::IDD)
  , m_password(_T(""))
  , m_debugenable(FALSE)
{

}

COptionsPageCfg::~COptionsPageCfg()
{
}

void COptionsPageCfg::DoDataExchange(CDataExchange* pDX)
{
  CPropertyPage::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_COMPORTMODEM, c_portmodem);
  DDX_Control(pDX, IDC_COMPORTCABLE, c_portcable);
  DDX_Control(pDX, IDC_MODEMBAUD, c_modembaud);
  DDX_Text(pDX, IDC_PASSWORD, m_password);
  DDV_MaxChars(pDX, m_password, 20);
  DDX_Check(pDX, IDC_DEBUG_ENABLE, m_debugenable);
}


BEGIN_MESSAGE_MAP(COptionsPageCfg, CPropertyPage)
END_MESSAGE_MAP()


// COptionsPageCfg message handlers

BOOL COptionsPageCfg::OnInitDialog()
{
  // Var
  CString str, strList, f;
  char    ports[RMON_MAXPORTS][9];
  int     i, size;

  // Default
  CPropertyPage::OnInitDialog();

  // Fill comport lists
  c_portcable.AddString(_T("NONE"));
  c_portcable.AddString(_T("USB1"));
  c_portmodem.AddString(_T("NONE"));
  if (rmonGetPortList(ports, &size) == rmonOK) {
    for (i = 0; i < size; i++) {
      c_portcable.AddString(_T(ports[i]));
      c_portmodem.AddString(_T(ports[i]));
    }
  }

  // Select comports
  if (m_comportcable.IsEmpty() || m_comportcable == _T("COM0"))
    c_portcable.SetCurSel(0);
  else
    c_portcable.SelectString(-1, m_comportcable);
  if (m_comportmodem.IsEmpty() || m_comportmodem == _T("COM0"))
    c_portmodem.SetCurSel(0);
  else
    c_portmodem.SelectString(-1, m_comportmodem);

  // Bring the selected string in focus
  c_modembaud.SelectString(-1, m_modembaud);

  // Completed
  return TRUE;
}

BOOL COptionsPageCfg::OnApply()
{
  // Update variables
  UpdateData(true);

  // Get selected comports
  c_portcable.GetLBText(c_portcable.GetCurSel(), m_comportcable);
  c_portmodem.GetLBText(c_portmodem.GetCurSel(), m_comportmodem);
  if (m_comportcable == _T("NONE")) m_comportcable = _T("COM0");
  if (m_comportmodem == _T("NONE")) m_comportmodem = _T("COM0");

  // Get selected baud
  c_modembaud.GetWindowText(m_modembaud);

  // Default
  return CPropertyPage::OnApply();
}
