// OptionsPageModem.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "OptionsPageModem.h"


// COptionsPageModem dialog

IMPLEMENT_DYNAMIC(COptionsPageModem, CPropertyPage)

COptionsPageModem::COptionsPageModem()
  : CPropertyPage(COptionsPageModem::IDD)
  , m_initstring(_T(""))
{

}

COptionsPageModem::~COptionsPageModem()
{
}

void COptionsPageModem::DoDataExchange(CDataExchange* pDX)
{
  CPropertyPage::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_INITSTRINGSCOMBO, c_modeminit);
  DDX_Text(pDX, IDC_INIT_STRING, m_initstring);
	DDV_MaxChars(pDX, m_initstring, 128);
}


BEGIN_MESSAGE_MAP(COptionsPageModem, CPropertyPage)
  ON_BN_CLICKED(IDC_ADD, &COptionsPageModem::OnAdd)
  ON_BN_CLICKED(IDC_REMOVE, &COptionsPageModem::OnRemove)
  ON_CBN_SELENDOK(IDC_INITSTRINGSCOMBO, &COptionsPageModem::OnSelendok)
END_MESSAGE_MAP()


// COptionsPageModem message handlers

BOOL COptionsPageModem::OnInitDialog()
{
	// Var
	CString str, strList, f;
	int     i;

  // Default
  CPropertyPage::OnInitDialog();

  // Load all strings saved in the registry, and put'em in the combo
  strList = AfxGetApp()->GetProfileString("Options", "COMBO Modeminit");
  if (strList.IsEmpty())
    strList="AT&F ! Factory default||ATB17 ! ISDN Modem||ATS80.6=1;ATB18 ! Zyxel ISDN Modem(38400)||ATS80.6=1;ATB15 ! Zyxel ISDN Modem(9600)||AT+CBST=71,0,1 ! GSM Modem 1||AT+CBST=0,0,1 ! GSM Modem 2||ATS35=0 ! Older Nokia GSM modem||";

  // Find how many entries exists in the list, format is "AA||BB||CC||DD||"
  i=strList.Replace("||", "||"); // This gives a count for the number of "||" sequences
  while (i) {
    str = strList.Left(strList.Find("||", 0)); // Extract the string
    strList.Delete(0, strList.Find("||", 0)); // Kill the string
    strList.Delete(0,2); // Kill the "||"
    c_modeminit.AddString(str);
    if (f.IsEmpty())
      f=str;
    i--;
  }

  // Bring the selected string in focus
  c_modeminit.SelectString(-1, m_initstring);

  // Completed
  return TRUE;
}

BOOL COptionsPageModem::OnApply()
{
  // Var
  CString strList, str;

  // Update variables
  UpdateData(true);

  // Get all strings in the combobox, and save'em
  for (int i = 0; i < c_modeminit.GetCount(); i++) {
    c_modeminit.GetLBText(i, str);
    if (!str.IsEmpty()) {
      strList += str;
      strList += "||";
    }
  } 
  AfxGetApp()->WriteProfileString("Options", "COMBO Modeminit", strList);

  // Default
  return CPropertyPage::OnApply();
}

void COptionsPageModem::OnAdd()
{
  // Update variables
  UpdateData(true);

  // Delete entry if already there
  c_modeminit.DeleteString(c_modeminit.FindStringExact(-1, m_initstring));

  // And insert at top
  c_modeminit.InsertString(0, m_initstring);
  c_modeminit.SetCurSel(0);
  UpdateData(false);
}

void COptionsPageModem::OnRemove()
{
  // Update variables
  UpdateData(true);

  // Delete entry
  if (c_modeminit.GetCount() == 1)
    c_modeminit.ResetContent();
  else
    c_modeminit.DeleteString(c_modeminit.GetCurSel());

  // Update dialog
  c_modeminit.SetCurSel(0);
  OnSelendok();
  UpdateData(false);
}

void COptionsPageModem::OnSelendok()
{
  // Var
  CString str;

  // Update variables
  UpdateData(true);

  // Save selected
  int index = c_modeminit.GetCurSel();
  c_modeminit.GetLBText(index, str);
  m_initstring = str;

  // Update dialog
  UpdateData(false);
}
