// OptionsSheet.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "OptionsSheet.h"


// COptionsSheet

IMPLEMENT_DYNAMIC(COptionsSheet, CPropertySheet)

COptionsSheet::COptionsSheet()
  :CPropertySheet("Settings", NULL, 0)
{
  // Hide apply button
  m_psh.dwFlags |= PSH_NOAPPLYNOW;

  // Insert pages
  AddPage(&m_Page1);
  AddPage(&m_Page2);
}

COptionsSheet::~COptionsSheet()
{
}


BEGIN_MESSAGE_MAP(COptionsSheet, CPropertySheet)
END_MESSAGE_MAP()


// COptionsSheet message handlers

BOOL COptionsSheet::OnInitDialog()
{
  // Var
  CRect rc;

  // Default
  BOOL bResult = CPropertySheet::OnInitDialog();

  // Adjust pages
  for (int i = 0; i < GetPageCount(); ++i) {
    if (GetPage(i)->GetSafeHwnd()) {
      // Change size
      GetPage(i)->GetWindowRect(&rc);
      rc.right  -= 51;
      GetPage(i)->SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);
    }
  }

  // Adjust TAB ctrl
  GetTabControl()->GetWindowRect(&rc);
  rc.right -= 51;
  GetTabControl()->SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);

  // Adjust buttons
  GetDlgItem(IDCANCEL)->GetWindowRect(&rc);
	ScreenToClient(&rc);
  rc.left -= 51; rc.right -= 51;
  GetDlgItem(IDCANCEL)->MoveWindow(&rc);
  GetDlgItem(IDOK)->GetWindowRect(&rc);
	ScreenToClient(&rc);
  rc.left -= 51; rc.right -= 51;
  GetDlgItem(IDOK)->MoveWindow(&rc);

  // Adjust sheet
  GetWindowRect(&rc);
  rc.right  -= 51;
  SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);

  // Completed
  return bResult;
}
