// RTCUProg.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "RTCUProgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

struct gw_state  gStateGW;
HRMONCON         hCon;

/////////////////////////////////////////////////////////////////////////////
// CRTCUProgApp

BEGIN_MESSAGE_MAP(CRTCUProgApp, CWinApp)
	//{{AFX_MSG_MAP(CRTCUProgApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
//	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTCUProgApp construction

CRTCUProgApp::CRTCUProgApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CRTCUProgApp object

CRTCUProgApp theApp;
CString      g_workdir;

/////////////////////////////////////////////////////////////////////////////
// CRTCUProgApp initialization

BOOL CRTCUProgApp::InitInstance()
{
	// Var
	CString str, strList;
	int     i, pos;

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

  // Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Logic IO"));

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _DEBUG
   if (!AllocConsole())
	  	AfxMessageBox("Failed to create the console!", MB_ICONEXCLAMATION);
    else
      DEBUGMSG("Application is started\n");
#endif  

	CRTCUProgDlg dlg;
	m_pMainWnd = &dlg;

	m_haccel = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR1));

	hCon = HRMONCON_ILLEGAL;

   // Get working directory
   TCHAR szPath[MAX_PATH];
   if (SUCCEEDED(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, szPath)))
   {
      g_workdir  = szPath;
      if (g_workdir.Right(1) != _T("\\")) g_workdir += _T("\\");
      g_workdir += _T("Logic IO\\");
      CreateDirectory(g_workdir, NULL); 
      g_workdir += _T("RTCUProg\\");
      CreateDirectory(g_workdir, NULL); 
   }
   else
   {
      int pos;
      g_workdir = AfxGetApp()->m_pszHelpFilePath;
      pos       = g_workdir.ReverseFind((char)92);
      g_workdir = g_workdir.Left(pos+1);
   }


	//
	// Configure RTCUCSP library
	//

	// Read gateway settings
	gStateGW.Port        = (unsigned short) AfxGetApp()->GetProfileInt("GWConnect Options", "GW Port", 5001);
	gStateGW.IP          = AfxGetApp()->GetProfileString("GWConnect Options", "GW IP", "domain.com");
	gStateGW.Key         = AfxGetApp()->GetProfileString("GWConnect Options", "GW Key", "AABBCCDD");
	gStateGW.maxsend     = (unsigned char) AfxGetApp()->GetProfileInt("REMOTE GPRS Options", "GW Maxsend", 3);
	gStateGW.resptimeout = (unsigned short) AfxGetApp()->GetProfileInt("REMOTE GPRS Options", "GW Resptimeout", 30);
	strList              = AfxGetApp()->GetProfileString("GWConnect Options", "CRYPTKEY", "00000000-00000000-00000000-00000000");

	// Build encryption key
	if (GetProfileInt("GWConnect Options", "CRYPTKEY Enable", 0)) {
		// Iterate cryptkey bytes
		pos = 0;
		for (i = 0; i < 16; i++)
		{
			// Insert byte
			gStateGW.CryptKey[i] = hatoi(strList.Mid(pos, 2));

			// Calculate next position
			pos += 2;
			if ((i + 1) % 4 == 0) pos++;
		}
	} else {
		memset(gStateGW.CryptKey, 0, 16);
	}

	// Configure library
    rmonSetGWParameters(gStateGW.Port, 0, (LPCTSTR)gStateGW.IP, (LPCTSTR)gStateGW.Key);
    rmonSetGWParametersAdv(gStateGW.CryptKey, 3, gStateGW.maxsend, gStateGW.resptimeout, 30);

	// Open library
	rmonOpen();


	//
	// Run main dialog
	//

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

  // Close connection
  rmonDisconnect(hCon);

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

BOOL CRTCUProgApp::ProcessMessageFilter(int code, LPMSG lpMsg) 
{
    if(m_haccel)
    {
        if(::TranslateAccelerator(m_pMainWnd->m_hWnd,m_haccel,lpMsg)) 
            return(TRUE);
    }

	return CWinApp::ProcessMessageFilter(code, lpMsg);
}

/////////////////////////////////////////////////////////////////////////////
// Utility
/////////////////////////////////////////////////////////////////////////////

char CRTCUProgApp::hatoi(const CString& ha) const
{
	// Var
	char res = 0, i;

	// Iterate nibles
	for (i = 0; i < 2; i++) {
		// Move last nible
		res <<= 4;
		// Set nible
		if (ha.GetAt(i) >= '0' && ha.GetAt(i) <= '9')      res += (ha.GetAt(i) - '0');
		else if (ha.GetAt(i) >= 'a' && ha.GetAt(i) <= 'f') res += (ha.GetAt(i) - 'a' + 10);
		else if (ha.GetAt(i) >= 'A' && ha.GetAt(i) <= 'F') res += (ha.GetAt(i) - 'A' + 10);
	}

	// Completed
	return res;
}
