// RTCUProgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "RTCUProgDlg.h"
#include "DlgFTPFirmware.h"
#include "OptionsSheet.h"
#include "Options.h"
#include <process.h>

#include "UnitGPRSSetup.h"
#include "UnitNetSheet.h"
#include "UnitGWSheet.h"
#include "UnitPassword.h"
#include "UnitRtc.h"
#include "UnitUpgrade.h"
#include "UnitPinCode.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

struct unit_info gUnitInfo;
bool gConnected;

//---------------------------------------------------------------
// Thread that receives DebugMsg() from the target RTCU
//---------------------------------------------------------------
#pragma optimize("g", off) // Disable global optimization
static void thDebug(void *arg) {
   char    buffer[512];
   int     rc;
   CTime   t;
   CString s;
   int     nCount;

   for (;;) {
      // Retrieve message
      rc = rmonReceiveDebugMsg(hCon, buffer, sizeof(buffer));
      if( rc == 0 ) {
         if(arg) {
            // Use PC time:
            t = CTime::GetCurrentTime();
            s = t.Format("%X");
            ((CDebugMsgDlg*)arg)->m_listmessage.InsertString( -1, s + " ->" + buffer );

            // If last item already selected, go select the new "last" item
            nCount = ((CDebugMsgDlg*)arg)->m_listmessage.GetCount();
            if( nCount == ((CDebugMsgDlg*)arg)->m_listmessage.GetCurSel() + 2 ) { 
               if( nCount > 0 ) ((CDebugMsgDlg*)arg)->m_listmessage.SetCurSel(nCount-1);
            }
         }
      }
      else {
         Sleep(50);
      }
   }
}
#pragma optimize("", on)




/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_ver_rtcucsp;
	CString	m_ver_rtcuprog;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_ver_rtcucsp = _T("Unknown");
	m_ver_rtcuprog = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_TEXT_RTCUCSP, m_ver_rtcucsp);
	DDX_Text(pDX, IDC_TEXT_VER, m_ver_rtcuprog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	// Var
	int ver;

	// Default
	CDialog::OnInitDialog();

	// Set RTCUCSP library version
	ver = rmonGetVer();
	m_ver_rtcucsp.Format("%i.%02i", ver/100, ver%100);

	// Set RTCUProg version
	m_ver_rtcuprog = _T(PROG_VERSION);

	// Update dialog
	UpdateData(FALSE);

	// Completed
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CRTCUProgDlg dialog

CRTCUProgDlg::CRTCUProgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRTCUProgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRTCUProgDlg)
	m_AppSelected     = _T("");
	m_FWSelected      = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon           = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dlgdebugmsg     = 0;
	m_dlgupload       = 0;
	m_dlgsms          = 0;
  m_dlgoptions      = 0;
  m_dlgoptionserver = 0;
  m_dlgfilesystem   = 0;
}

void CRTCUProgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTCUProgDlg)
	DDX_Control(pDX, IDC_FRAME_FW, c_FrameFw);
	DDX_Control(pDX, IDC_FRAME_APP, c_FrameApp);
	DDX_Control(pDX, IDC_FIRMWARESELECTED, c_FWSelected);
	DDX_Control(pDX, IDC_APPLICATIONSELECTED, c_AppSelected);
	DDX_Control(pDX, IDC_UPLOADAPPANDFW, m_ctrappfw);
	DDX_Control(pDX, IDC_FIRMWARERESUME, m_ctrfwres);
	DDX_Control(pDX, IDC_APPLICATIONRESUME, m_ctrappres);
	DDX_Control(pDX, IDC_FIRMWAREUPLOAD, m_ctrfw);
	DDX_Control(pDX, IDC_APPLICATIONUPLOAD, m_ctrapp);
	DDX_Control(pDX, IDC_STATUS, m_ctrstatus);
	DDX_Text(pDX, IDC_APPLICATIONSELECTED, m_AppSelected);
	DDX_Text(pDX, IDC_FIRMWARESELECTED, m_FWSelected);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRTCUProgDlg, CDialog)
	//{{AFX_MSG_MAP(CRTCUProgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FIRMWAREUPLOAD, OnFirmwareUpload)
	ON_BN_CLICKED(IDC_APPLICATIONUPLOAD, OnApplicationupload)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_WM_TIMER()
	ON_COMMAND(IDM_SETTING, OnSetting)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(IDM_MODEM, OnModem)
	ON_UPDATE_COMMAND_UI(IDM_MODEM, OnUpdateModem)
	ON_COMMAND(IDM_GPRS, OnGprs)
	ON_UPDATE_COMMAND_UI(IDM_GPRS, OnUpdateGprs)
	ON_COMMAND(ID_FILE_APPLICATION_BACKGROUNDUPDATE, OnFileApplicationBackgroundupdate)
	ON_COMMAND(ID_FILE_APPLICATION_DIRECTUPDATE, OnFileApplicationDirectupdate)
	ON_COMMAND(ID_FILE_FIRMWARE_BACKGROUNDUPDATE, OnFileFirmwareBackgroundupdate)
	ON_COMMAND(ID_FILE_FIRMWARE_DIRECTUPDATE, OnFileFirmwareDirectupdate)
	ON_COMMAND(ID_FILE_APPLICATION_SELECTFILE, OnFileApplicationSelectfile)
	ON_COMMAND(ID_FILE_FIRMWARE_SELECTFILE, OnFileFirmwareSelectfile)
	ON_COMMAND(ID_SHOWMESSAGESFROMUNIT, OnShowmessagesfromunit)
	ON_UPDATE_COMMAND_UI(ID_SHOWMESSAGESFROMUNIT, OnUpdateShowmessagesfromunit)
	ON_COMMAND(ID_FILE_FIRMWARE_INTERNET, OnFileFirmwareInternet)
	ON_BN_CLICKED(IDC_APPLICATIONRESUME, OnApplicationresume)
	ON_BN_CLICKED(IDC_FIRMWARERESUME, OnFirmwareresume)
	ON_BN_CLICKED(IDC_UPLOADAPPANDFW, OnUploadappandfw)
	ON_UPDATE_COMMAND_UI(ID_FILE_APPLICATION_BACKGROUNDUPDATE, OnUpdateFileApplicationBackgroundupdate)
	ON_UPDATE_COMMAND_UI(ID_FILE_FIRMWARE_BACKGROUNDUPDATE, OnUpdateFileFirmwareBackgroundupdate)
	ON_COMMAND(ID_UNIT_HALT, OnUnitHalt)
	ON_UPDATE_COMMAND_UI(ID_UNIT_HALT, OnUpdateUnitHalt)
	ON_COMMAND(ID_UNIT_RESET, OnUnitReset)
	ON_UPDATE_COMMAND_UI(ID_UNIT_RESET, OnUpdateUnitReset)
	ON_COMMAND(IDM_PASSWORD, OnPassword)
	ON_UPDATE_COMMAND_UI(IDM_PASSWORD, OnUpdatePassword)
	ON_COMMAND(IDM_RTC, OnRtc)
	ON_UPDATE_COMMAND_UI(IDM_RTC, OnUpdateRtc)
	ON_COMMAND(IDM_UNITSMS, OnUnitsms)
	ON_UPDATE_COMMAND_UI(IDM_UNITSMS, OnUpdateUnitsms)
	ON_COMMAND(IDM_UPGRADE, OnUpgrade)
	ON_UPDATE_COMMAND_UI(IDM_UPGRADE, OnUpdateUpgrade)
   ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDM_GATEWAYSETTINGS, OnGatewaysettings)
	ON_UPDATE_COMMAND_UI(IDM_GATEWAYSETTINGS, OnUpdateGatewaysettings)
	ON_COMMAND(IDM_GPRSSETUP, OnGprssetup)
	ON_UPDATE_COMMAND_UI(IDM_GPRSSETUP, OnUpdateGprssetup)
	//}}AFX_MSG_MAP
  ON_COMMAND(IDM_FLEX_OPTIONS, &CRTCUProgDlg::OnFlexOptions)
  ON_UPDATE_COMMAND_UI(IDM_FLEX_OPTIONS, &CRTCUProgDlg::OnUpdateFlexOptions)
  ON_COMMAND(IDM_OPTIONSERVER, &CRTCUProgDlg::OnOptionserver)
  ON_UPDATE_COMMAND_UI(IDM_OPTIONSERVER, &CRTCUProgDlg::OnUpdateOptionserver)
  ON_COMMAND(IDM_UNIT_SETPINCODE, &CRTCUProgDlg::OnPINcode)
  ON_UPDATE_COMMAND_UI(IDM_UNIT_SETPINCODE, &CRTCUProgDlg::OnUpdatePINcode)
  ON_COMMAND(IDM_FILESYSTEM, &CRTCUProgDlg::OnFilesystem)
  ON_UPDATE_COMMAND_UI(IDM_FILESYSTEM, &CRTCUProgDlg::OnUpdateFilesystem)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Helpers for saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("RTCUProgSettings");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = sscanf_s(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's ini file
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// Create / Destroy
/////////////////////////////////////////////////////////////////////////////

BOOL CRTCUProgDlg::OnInitDialog()
{
	// Var
	WINDOWPLACEMENT wp;
	CString         str, p1, p2;
	int             pos;

	// Default init
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);      // Set big icon
	SetIcon(m_hIcon, FALSE);     // Set small icon

	// Windows Position
	if( ReadWindowPlacement(&wp) ) {
		CRect rc;
		GetWindowRect(&rc);
		if( ((rc.bottom-rc.top) & 0xFFFC) == ((wp.rcNormalPosition.bottom - wp.rcNormalPosition.top) & 0xFFFC) &&
			((rc.right-rc.left) & 0xFFFC) == ((wp.rcNormalPosition.right - wp.rcNormalPosition.left) & 0xFFFC)) {
			wp.showCmd = false;
   			SetWindowPlacement(&wp);
		}
	}

	// Direct/Background update
	m_AppType   = AfxGetApp()->GetProfileInt( "Options", "APPTYPE", 1 );
	m_FWType    = AfxGetApp()->GetProfileInt( "Options", "FWTYPE",  1 );
	if(m_AppType) CheckAppDirect(true); else CheckAppDirect(false);
	if(m_FWType)  CheckFWDirect(true);  else CheckFWDirect(false);

	// Select files
	str         = AfxGetApp()->GetProfileString( "Options", "APPFILE", "" );
	pos         = str.ReverseFind((char)92);     // (char)92 = "\"
	if( pos > 0 ) {
		if(m_AppType) c_FrameApp.SetWindowText(_T("Transfer Application (Direct)")); else c_FrameApp.SetWindowText(_T("Transfer Application (Background)"));
		m_AppSelected = _T(" ") + str.Mid(pos+1);
	}
	str         = AfxGetApp()->GetProfileString( "Options", "FWFILE", "" );
	pos         = str.ReverseFind((char)92);     // (char)92 = "\"
	if( pos > 0 ) {
		if(m_FWType) c_FrameFw.SetWindowText(_T("Transfer Firmware (Direct)")); else c_FrameFw.SetWindowText(_T("Transfer Firmware (Background)"));
		m_FWSelected = _T(" ") + str.Mid(pos+1);
	}

	// Messages from unit
	m_dlgdebugmsg = new CDebugMsgDlg();
	m_dlgdebugmsg->Create(IDD_DEBUGMSG, this);

	// SMS messages
	m_dlgsms		= new CUnitSms();
	m_dlgsms->Create(IDD_UNIT_SMS, this);

  m_dlgoptions = new CUnitOptions();
  m_dlgoptions->Create(IDD_FLEXOPTIONS, this);
  m_dlgoptionserver = new CUnitOptionServer();
  m_dlgoptionserver->Create(IDD_UNIT_OPTIONSERVER, this);

	// Update dialog controls
	UpdateData(FALSE);

	// Create session
	hCon = rmonOpenConnection();
	DEBUGMSG("Connection: %s\n", hCon == HRMONCON_ILLEGAL ? "Failed" : "Open");

	// Get comports
	p1 = AfxGetApp()->GetProfileString("Options", "CABLE COMPORT", "USB1");
	p2 = AfxGetApp()->GetProfileString("Options", "MODEM COMPORT", "COM0");

	// If remote port is COM0 (ie none), don't allow the menuitems 
	if (p2 == "COM0")
		m_remoteportavailable=false;
	else
		m_remoteportavailable=true;

	// If local port is COM0 (ie none), don't allow the menuitems 
	if (p1 == "COM0")
		m_localportavailable=false;
	else
		m_localportavailable=true;

	// Comport config
	rmonRet rc = rmonSetComport(hCon, p1, p2);
	DEBUGMSG("rmonSetComport(%p, '%s', '%s') = %d\n", hCon, p1, p2, rc);

	// Get modem init string
	str = AfxGetApp()->GetProfileString("Options", "MODEMINIT", "ATS80.6=1;ATB15 ! Zyxel ISDN Modem");
	if (str.Find('!') != -1)  // if there is a comment, only grab to the point before the comment
		str=str.Left(str.Find('!'));
	str.TrimLeft();
	str.TrimRight();

	// Modem config
	DEBUGMSG("ModemInit=[%s]\n", str);
	rmonSetModemInit(hCon, str);
	rmonSetRemoteBaudrate(hCon, atoi(AfxGetApp()->GetProfileString("Options", "MODEM BAUDRATE", "57600")));

	// Connect to unit, cable
	if (m_localportavailable) {
		int rc = rmonConnect(hCon, "");
		if (rc) {
	        AfxMessageBox(_T("The serial port specified for cable connection is NOT available.\nOnly remote connection via modem or via the RCH is possible."));
			m_localportavailable=false;
		}
	}

	Sleep(500);

	// Start to remove debug massages from queue
	_beginthread(thDebug, 0, m_dlgdebugmsg);

	// Start connection status timer
	SetTimer(100,500,NULL);
	m_ctrstatus.SetWindowText(_T("Not connected"));

	// Create windows
	m_pGWConnect = new CConnectGwSheet();
	m_pGWConnect->Create(this, WS_POPUP|WS_CAPTION|DS_MODALFRAME);

	m_ptrdlgconnect = new CConnectDlg(this);
	m_ptrdlgconnect->Create(IDD_CONNECT, this);

	m_dlgupload = new CDlgUpload(this);
	m_dlgupload->Create(IDD_UPLOAD, this);

   m_dlgfilesystem = new CDlgFilesystem(this);
   m_dlgfilesystem->Create(IDD_FILESYSTEM, this);

	// Completed
	return TRUE;
}

void CRTCUProgDlg::OnDestroy()
{
  WinHelp(0L, HELP_QUIT);

  if (m_ptrdlgconnect)
    delete m_ptrdlgconnect;

  // before it is destroyed, save the position of the window
  WINDOWPLACEMENT wp;
  wp.length = sizeof wp;
  if( GetWindowPlacement(&wp) )
  {
    wp.flags = 0;
    if( IsZoomed() )
      wp.flags |= WPF_RESTORETOMAXIMIZED;
    // and write it to the .INI file
    WriteWindowPlacement(&wp);
  }

  CDialog::OnDestroy();
}

void CRTCUProgDlg::PostNcDestroy() 
{
	// Default
	CDialog::PostNcDestroy();

	// Release pointers
	if(m_dlgdebugmsg) delete m_dlgdebugmsg;
	if(m_dlgupload)   delete m_dlgupload;
	if(m_dlgsms)      delete m_dlgsms;
   if(m_dlgfilesystem) delete m_dlgfilesystem;
}

/////////////////////////////////////////////////////////////////////////////
// System
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRTCUProgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRTCUProgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRTCUProgDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	PostMessage (WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x,point.y));
	// Default
	CDialog::OnLButtonDown(nFlags, point);
}

//----------------------------------------------------------------------------
// Will enable pCmdUI OnUpdate handlers on menu items, 
// (Remember to also include "ON_WM_INITMENUPOPUP()" in BEGIN_MESSAGE_MAP section
//----------------------------------------------------------------------------
void CRTCUProgDlg::OnInitMenuPopup(CMenu *pPopupMenu, UINT /*nIndex*/,BOOL /*bSysMenu*/) 
{
  ASSERT(pPopupMenu != NULL);
  // Check the enabled state of various menu items.

  CCmdUI state;
  state.m_pMenu = pPopupMenu;
  ASSERT(state.m_pOther == NULL);
  ASSERT(state.m_pParentMenu == NULL);

  // Determine if menu is popup in top-level menu and set m_pOther to
  // it if so (m_pParentMenu == NULL indicates that it is secondary popup).
  HMENU hParentMenu;
  if (AfxGetThreadState()->m_hTrackingMenu == pPopupMenu->m_hMenu)
      state.m_pParentMenu = pPopupMenu;    // Parent == child for tracking popup.
  else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL) {
    CWnd* pParent = this;
       // Child windows don't have menus--need to go to the top!
    if (pParent != NULL && (hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL) {
      int nIndexMax = ::GetMenuItemCount(hParentMenu);
      for (int nIndex = 0; nIndex < nIndexMax; nIndex++) {
        if (::GetSubMenu(hParentMenu, nIndex) == pPopupMenu->m_hMenu) {
          // When popup is found, m_pParentMenu is containing menu.
          state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
          break;
        }
      }
    }
  }


  state.m_nIndexMax = pPopupMenu->GetMenuItemCount();
  for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax; state.m_nIndex++) {
    state.m_nID = pPopupMenu->GetMenuItemID(state.m_nIndex);
    if (state.m_nID == 0)
       continue; // Menu separator or invalid cmd - ignore it.

    ASSERT(state.m_pOther == NULL);
    ASSERT(state.m_pMenu != NULL);
    if (state.m_nID == (UINT)-1) {
       // Possibly a popup menu, route to first item of that popup.
       state.m_pSubMenu = pPopupMenu->GetSubMenu(state.m_nIndex);
       if (state.m_pSubMenu == NULL ||
        (state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 ||
        state.m_nID == (UINT)-1)
       {
        continue;       // First item of popup can't be routed to.
       }
       state.DoUpdate(this, TRUE);   // Popups are never auto disabled.
    } else {
       // Normal menu item.
       // Auto enable/disable if frame window has m_bAutoMenuEnable
       // set and command is _not_ a system command.
       state.m_pSubMenu = NULL;
       state.DoUpdate(this, FALSE);
    }

    // Adjust for menu deletions and additions.
    UINT nCount = pPopupMenu->GetMenuItemCount();
    if (nCount < state.m_nIndexMax) {
       state.m_nIndex -= (state.m_nIndexMax - nCount);
       while (state.m_nIndex < nCount && pPopupMenu->GetMenuItemID(state.m_nIndex) == state.m_nID) {
        state.m_nIndex++;
       }
    }
    state.m_nIndexMax = nCount;
  }
}

/////////////////////////////////////////////////////////////////////////////
// Menu
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnAboutbox() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CRTCUProgDlg::OnGprs() 
{
	// Show gateway window
	m_pGWConnect->ShowWindow(true);
}

void CRTCUProgDlg::OnModem() 
{
	// Show modem window
	m_ptrdlgconnect->ShowWindow(true);
}

void CRTCUProgDlg::OnSetting() 
{
    // Var
    COptions dlg;
//    COptionsSheet dlg;

  // Read settings
  dlg.m_password        = AfxGetApp()->GetProfileString("Options", "PASSWORD", "");
  dlg.m_comportcable    = AfxGetApp()->GetProfileString("Options", "CABLE COMPORT", "USB1");
  dlg.m_debugenable     = AfxGetApp()->GetProfileInt(   "Options", "DEBUG ENABLE", 0);

  // Save settings
  CString old_cable     = dlg.m_comportcable;
  CString old_password  = dlg.m_password;

  // Change settings
  if (dlg.DoModal() == IDOK) {
    // Write setting
    AfxGetApp()->WriteProfileString("Options", "PASSWORD",       dlg.m_password );
    AfxGetApp()->WriteProfileString("Options", "CABLE COMPORT",  dlg.m_comportcable);
    AfxGetApp()->WriteProfileInt(   "Options", "DEBUG ENABLE",   dlg.m_debugenable);

    // Password changed?
    if (old_password != dlg.m_password) {
      // Try to logon again
      ManageLogon(false);
    }

    // Tell'em that they need to close The app
    if (old_cable != dlg.m_comportcable) {
      AfxMessageBox(IDS_OPTIONS_RESTART, MB_ICONINFORMATION);
    }
  }
}

// Decide if "Connect Via Gateway" menu item should be enabled
void CRTCUProgDlg::OnUpdateGprs(CCmdUI* pCmdUI) 
{
	// Only allow Gateway connect if we are not in active connection via modem, and the modem connect window is invisible
	pCmdUI->Enable((rmonConnected(hCon)!=RMONCON_REMOTE) && !m_ptrdlgconnect->IsWindowVisible());	
}

// Decide if "Connect Via Modem" menu item should be enabled
void CRTCUProgDlg::OnUpdateModem(CCmdUI* pCmdUI) 
{
	// Only allow modem connect if comport is available, and we are not in active connection via GW, and the GPRS connect window is invisible
	pCmdUI->Enable((m_remoteportavailable && rmonConnected(hCon)!=RMONCON_GW) && !m_pGWConnect->IsWindowVisible());
}

/////////////////////////////////////////////////////////////////////////////
// Update dialog
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnTimer(UINT nIDEvent) 
{
   int conn;
   static int oldconn=4711;
   static bool busy=false;

   if(busy) return;
   busy=true;

   if( nIDEvent == 100 ) {
      // If CConnectDlg is attempting a remote connect, show some "?????" in status bar
      if( m_ptrdlgconnect->m_attempting || m_pGWConnect->m_attempting ) {
         m_ctrstatus.SetWindowText(_T("Attempting to connect...."));
         m_ctrapp.EnableWindow(false);
         m_ctrfw.EnableWindow(false);
         gUnitInfo.Connected = false;
         oldconn=4711;
      }
      else {
         // Else ask about the current connection status
         conn = rmonConnected(hCon);

         // If connection status changed since last time we were called...
         if( conn != oldconn ) {
            // If we came from remote to another state, post a "Disconnect" button message to the connect dialog
            if( oldconn == RMONCON_REMOTE )
               m_ptrdlgconnect->SendMessage( WM_COMMAND, IDC_DISCONNECT, 0 );

            // If we came from GW to another state, post a "Disconnect" button message to the GW connect dialog
            if( oldconn == RMONCON_GW )
               m_pGWConnect->SendMessage(WM_COMMAND, IDC_DISCONNECT, 0);

            oldconn = conn;
            switch(conn) {
               case RMONCON_NONE:
                  gConnected     = false;
                  gUnitInfo.Connected    = false;
                  m_bgsupported  = false;
                  gUnitInfo.SerialNumber = 0;
                  gUnitInfo.TargetID     = 0;
                  gUnitInfo.FirmwareVer  = 0;
                  m_ctrapp.EnableWindow(false);
                  m_ctrappres.EnableWindow(false);
                  m_ctrfw.EnableWindow(false);
                  m_ctrfwres.EnableWindow(false);
                  m_ctrappfw.EnableWindow(false);
                  m_ctrstatus.SetWindowText(_T("Not connected"));
                  if (m_dlgfilesystem) m_dlgfilesystem->PostMessage(UWM_UPDATE_WINDOW, 10, 0);
                  break;

               case RMONCON_LOCAL:
                  ManageLogon(true);
                  break;

               case RMONCON_GW: 
                  ManageLogon(true);
                  break;

               case RMONCON_REMOTE:
                  ManageLogon(true);
                  break;
            }

            UpdateResume();
            if (m_dlgoptions) m_dlgoptions->ConnectChanged();
            if (m_dlgoptionserver) m_dlgoptionserver->ConnectChanged();
         }
      }
      m_dlgdebugmsg->m_ctrenable.EnableWindow(gUnitInfo.Connected);
   }
   busy = false;

	CDialog::OnTimer(nIDEvent);
}

void CRTCUProgDlg::ManageLogon(bool /*quiet*/)
{
   // Var
   static bool active=false;
   int         rc, monitorversion;

   // Prevent multiple calls to this.,,
   if(active) return;

   rc                      = 0;
   active                  = true;
   monitorversion          = 4710;
   gUnitInfo.TargetID      = 4711;
   gUnitInfo.FirmwareVer   = 4712;

   // Get unit version info
   for (int i = 0; i < 3; i++) {
      rc = rmonVer(hCon, &monitorversion);
      if (rc == rmonIllegalHandle) {
         // Connection has been closed
         m_ctrstatus.SetWindowText(_T("Not connected"));
         active                = false;
         gUnitInfo.TargetID    = 0;
         gUnitInfo.FirmwareVer = 0;
         return;
      }
      if (!rc) break;
      // Wait before next try
      Sleep(3000);
   }
   if (rc) {
      if (rmonConnected(hCon) == RMONCON_GW ||
          rmonConnected(hCon) == RMONCON_REMOTE) {
         // Close connection
         rmonDisconnect(hCon);
      }
      // Set flags to "No connection"
      m_ctrstatus.SetWindowText(_T("Not connected"));
      active                = false;
      gUnitInfo.TargetID    = 0;
      gUnitInfo.FirmwareVer = 0;
      return;
   }

   // Get targetid and firmware revision
   rc = rmonGetTargetInfo(hCon, &gUnitInfo.TargetID, &gUnitInfo.FirmwareVer);
   if (rc) {
      // Set flags to "No connection"
      gUnitInfo.TargetID      = 4711;
      gUnitInfo.FirmwareVer   = 4712;
   }

   // If firmware version is below 4.02 or above 90.00 (monitor mode), no support for logon
   // (Or no answer in the rmonGetTargetInfo() function)
   if( (gUnitInfo.FirmwareVer==4712 || (gUnitInfo.TargetID<100 && gUnitInfo.FirmwareVer<402)) && monitorversion<9000 ) {
      m_ctrstatus.SetWindowText(_T("Target information is not available"));
      gUnitInfo.Connected   = true;
      active                = false;
      gUnitInfo.TargetID    = 0;
      gUnitInfo.FirmwareVer = 0;
      return;
   }

   // Determine if in monitor mode
   gUnitInfo.monitor = (monitorversion > 9000);
//   if( monitorversion > 9000 ) gUnitInfo.FirmwareVer = monitorversion;

   BeginWaitCursor();
   // Try to authenticate with no password
   //rc=rmonAuthenticate(1,"");

   rc = rmonAuthenticate(hCon, (LPCTSTR)AfxGetApp()->GetProfileString("Options","PASSWORD",""));
   EndWaitCursor();

   // If password is needed
   if( rc == rmonDenied ) {
      unsigned long SerialNumber;
      CString       text;

      rc = rmonGetTargetProfile(hCon, NULL, NULL, &SerialNumber);
      if (rc) SerialNumber = 0;
      if (!SerialNumber) text = _T("Unable to logon to unit, please enter the correct logon password !");
      else text.Format(_T("Unable to logon to unit %d,\nplease enter the correct logon password !"), SerialNumber);

      AfxMessageBox(text);
      active = false; // As Onsetup calls us again.....
      gConnected = true;
      OnSetting();
   }
   else if( rc == rmonOK ) {
      // Not possible in monitor mode
      if( !gUnitInfo.monitor ) {
        // Debug messages
        rmonSetDebugEnable(hCon, AfxGetApp()->GetProfileInt("Options", "DEBUG ENABLE", 0));
        // SMS messages
        if (gUnitInfo.FirmwareVer >= 451 || gUnitInfo.TargetID > 100) {
          rmonReceiveSMSEnable(hCon, 1);
        }
      }

      gUnitInfo.Connected    = true;
      ShowUnitInfo();
      m_ctrapp.SetFocus();

      // Notify connection
      if (m_dlgfilesystem) m_dlgfilesystem->PostMessage(UWM_UPDATE_WINDOW, 10, 1);
   }
   else {
      gConnected = true;
      AfxMessageBox(_T("Unable to logon to unit ! Is the unit connected properly to the PC ?"));
   }
   active = false;
}

void CRTCUProgDlg::ShowUnitInfo()
{
   unsigned char Programmable = 1;
   char appname[255];
   int  appver;
   CString sappinfo;
   CString x, stargetid;
   CString ct;

   // Go get the serialnumber
   if( rmonGetSerialNumber(hCon, &gUnitInfo.SerialNumber) ) {
      // If error, try again (can be busy just after a powerup/authenticate/connect
      Sleep(1000);
      if( rmonGetSerialNumber(hCon, &gUnitInfo.SerialNumber) ) return;
   }

   rmonIsUnitProgrammable(hCon, &Programmable);

   // Not possible in monitor mode
   if( !gUnitInfo.monitor ) {
      rmonRet rctest = rmonGetAppInfo(hCon, appname, &appver);
      if( rctest != rmonOK ) {
         // Something vent wrong
         sappinfo = _T("APP: ??? / ???");
      } else {
         // Something vent wrong
         sappinfo.Format(_T("APP: %s / %i.%02i"), appname, appver/100, appver%100 );
      }
   }

   // Get targetid and firmware revision
   stargetid = "";
   if ((gUnitInfo.SerialNumber/100000000) == 2) {
	   switch (gUnitInfo.SerialNumber/1000000) {
	   case 201: stargetid = "MX2i eco";     break;
	   case 202: stargetid = "MX2i basic";   break;
	   case 203: stargetid = "MX2i eco+";    break;
	   case 204: stargetid = "MX2i pro";     break;
	   case 205: stargetid = "MX2i pro+";    break;
	   case 206: stargetid = "DX4 eco";      break;
	   case 207: stargetid = "DX4 pro";      break;
	   case 208: stargetid = "AX9 pro";      break;
	   case 209: stargetid = "AX9 eco";      break;
	   case 212: stargetid = "MX2i basic";   break; // Condor GPS
	   case 213: stargetid = "MX2i eco+";    break; // Condor GPS
	   case 214: stargetid = "MX2i pro";     break; // Condor GPS
	   case 215: stargetid = "MX2i pro+";    break; // Condor GPS
	   case 216: stargetid = "MX2i basic";   break; // GTop GPS
	   case 217: stargetid = "MX2i eco+";    break; // GTop GPS
	   case 218: stargetid = "MX2i pro";     break; // GTop GPS
	   case 219: stargetid = "MX2i pro+";    break; // GTop GPS
	   case 220: stargetid = "CX1 pro";      break;
	   case 221: stargetid = "CX1 pro-c";    break;
	   case 222: stargetid = "CX1 flex";     break;
	   case 224: stargetid = "MX2 SOM";      break; // Condor GPS
	   case 225: stargetid = "MX2 SOM";      break; // GTop GPS
      case 226: stargetid = "MX2 KoolBox EUR"; break;
      case 227: stargetid = "MX2 KoolBox US";  break;
	   case 231: stargetid = "AX9 eco";      break;
	   case 232: stargetid = "AX9 eco-x";    break;
	   case 233: stargetid = "AX9 pro";      break;
	   case 234: stargetid = "AX9 pro-x";    break;
      case 235: stargetid = "CX1 warp 2G";     break;
      case 236: stargetid = "CX1 warp-c 2G";   break;
      case 237: stargetid = "CX1 warp 3G";     break;
      case 238: stargetid = "CX1 warp-c 3G";   break;
	   case 240: stargetid = "SX1 pro";      break; // 1st production
	   case 241: stargetid = "SX1 pro-r";    break; // 1st production
	   case 242: stargetid = "SX1 pro";      break;
	   case 243: stargetid = "SX1 pro-r";    break;
	   case 244: stargetid = "SX1 pro";      break;
	   case 245: stargetid = "SX1 pro-r";    break;
	   case 251: stargetid = "CX1i flex";    break;
	   case 252: stargetid = "CX1i pro";     break;
	   case 253: stargetid = "CX1 pro-c";    break;
	   case 254: stargetid = "CX1i pro+";    break;
	   case 255: stargetid = "CX1 warp";     break;
	   case 256: stargetid = "CX1 warp-c";   break;
	   case 261: stargetid = "DX4 flex";     break;
	   case 262: stargetid = "DX4 eco+";     break;
	   case 266: stargetid = "AX9 eco-x";    break;
	   case 267: stargetid = "AX9 pro-x";    break;
	   case 268: stargetid = "AX9i eco";     break;
	   case 269: stargetid = "AX9i pro";     break;
	   case 270: stargetid = "DX4i pro-LTE"; break;
	   case 271: stargetid = "DX4i warp";    break;
	   case 272: stargetid = "DX4i pro";     break;
	   case 273: stargetid = "DX4i pro-3G FT";  break;
       case 274: stargetid = "DX4i pro-2G";  break;
       case 275: stargetid = "DX4i pro-3G";  break;
	   case 276: stargetid = "DX4i pro-LTE"; break;
       case 277: stargetid = "DX4i pro-2G";  break;
       case 278: stargetid = "DX4i pro-3G";  break;
       case 279: stargetid = "DX4i pro-3G FT";  break;
	   case 281: stargetid = "MX2i eco+";    break;
	   case 282: stargetid = "MX2i pro";     break;
	   case 283: stargetid = "MX2i pro+";    break;
       case 284: stargetid = "MX2 encore";      break;
       case 285: stargetid = "MX2 turbo-2G";    break;
       case 286: stargetid = "MX2 turbo";       break;
       case 287: stargetid = "MX2 turbo(A)";    break;
	   case 291: stargetid = "MX2 encore";   break;
	   case 292: stargetid = "MX2 turbo";    break;
       case 293: stargetid = "MX2 turbo-2G"; break;
       case 294: stargetid = "MX2 turbo(A)"; break;
	   case 295: stargetid = "AX9 encore";   break;
	   case 296: stargetid = "AX9 turbo";    break;
       case 297: stargetid = "AX9 turbo(A)"; break;
	   case 298: stargetid = "AX9 encore LTE";  break;
	   case 299: stargetid = "AX9 turbo LTE";   break;
	   }
   }
   if ((gUnitInfo.SerialNumber/100000000) == 3) {
	   switch (gUnitInfo.SerialNumber/1000000) {
       case 312: stargetid = "NX-400 LTE";  break;
       case 314: 
       case 315: stargetid = "NX-400 evo";  break;

       case 323: 
       case 381: stargetid = "NX-200 DR";   break;

       case 325:
       case 327:
       case 382: stargetid = "NX-200e";     break;

       case 331: stargetid = "NX-900";      break;
       case 332:
       case 333: 
       case 335: stargetid = "NX-910";      break;

       case 346: stargetid = "LX5 RT";      break;
       case 350: stargetid = "LX5 pro";     break;
       case 351: stargetid = "LX5 eco";     break;
       case 360:
       case 361: stargetid = "LX4 pro";     break;
       case 362: stargetid = "LX4 eco";     break;

       case 376:
       case 377: stargetid = "LX2 pro ";    break;
	   }
   }
    if (stargetid.IsEmpty()) {
        switch (gUnitInfo.TargetID) {
        case 1:   stargetid = "SA";  break;
        case 2:   stargetid = "DIN"; break;
        case 4:   stargetid = "D4";  break;
        case 5:   stargetid = "A5";  break;
        case 6:   stargetid = "A6";  break;
        case 7:   stargetid = "M7";  break;
        case 8:   stargetid = "CTU"; break;
        case 9:   stargetid = "A9";  break;
        case 10:  stargetid = "M10"; break;
        case 11:  stargetid = "M11"; break;
        case 102: stargetid = "MX2"; break;
        case 103: stargetid = "DX4 mk2"; break;
        case 104: stargetid = "DX4"; break;
        case 105: stargetid = "CX1"; break;
        case 106: stargetid = "SX1"; break;
        case 109: stargetid = "AX9"; break;
        case 122: stargetid = "MX2T"; break;
        case 129: stargetid = "AX9T"; break;
        case 192: stargetid = "MX2 SOM"; break;
        case 201: stargetid = "eGate";   break;
        case 202: stargetid = "NX-200";  break;
        case 204: stargetid = "NX-400";  break;
        case 209: stargetid = "NX-900";  break;
        case 211: stargetid = "LT Gateway";  break;
        case 212: stargetid = "LT Gateway 2";  break;
        case 302: stargetid = "LX2";  break;
        case 304: stargetid = "LX4";  break;
        case 305: stargetid = "LX5";  break;
        case 335: stargetid = "eGate V2";  break;
        case 340: stargetid = "Zhaga";  break;
        default:  stargetid.Format(_T("Unknown, %i"), gUnitInfo.TargetID); break;
        }
    }

   if(!Programmable) stargetid += _T(" (Micro)");

   switch(rmonConnected(hCon)) {
      case RMONCON_LOCAL: 
         ct = _T("cable.");
         break;
      case RMONCON_GW: 
         ct = _T("RCH.");
         break;
      case RMONCON_REMOTE:
         ct = _T("modem.");
         break;
   }

   // Not possible in monitor mode
   if (gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 210)
   {
      if( !gUnitInfo.monitor )
         x.Format(_T("Connected using %s   SER: %09i  |  FW: %i.%02i  |  %s  |  TRG: %s"), ct, gUnitInfo.SerialNumber, gUnitInfo.FirmwareVer/100, gUnitInfo.FirmwareVer%100, sappinfo, stargetid);
      else
         x.Format(_T("Connected using %s   SER: %09i  |  FW: %i.%02i (Monitor)  |  TRG: %s"), ct, gUnitInfo.SerialNumber, (gUnitInfo.FirmwareVer - 9000)/100, gUnitInfo.FirmwareVer%100, stargetid);
   }
   else
   {
      if( !gUnitInfo.monitor )
         x.Format(_T("Connected using %s   SER: %09i  |  FW: %i.%02i.%02i  |  %s  |  TRG: %s"), ct, gUnitInfo.SerialNumber, gUnitInfo.FirmwareVer >> 16, (gUnitInfo.FirmwareVer >> 8) & 0x00FF, gUnitInfo.FirmwareVer & 0x00FF, sappinfo, stargetid);
      else
         x.Format(_T("Connected using %s   SER: %09i  |  FW: %i.%02i.%02i (Monitor)  |  TRG: %s"), ct, gUnitInfo.SerialNumber, gUnitInfo.FirmwareVer >> 16, (gUnitInfo.FirmwareVer >> 8) & 0x00FF, gUnitInfo.FirmwareVer & 0x00FF, stargetid);
   }

   m_ctrstatus.SetWindowText(x);

   // Not possible in monitor mode
   if( !gUnitInfo.monitor ) {
      // Debug message dialog update
      int  rc, enabled;
      rc = rmonGetDebugEnable(hCon, &enabled);
      if (enabled)
         m_dlgdebugmsg->m_ctrenable.SetWindowText(_T("Disable"));
      else
         m_dlgdebugmsg->m_ctrenable.SetWindowText(_T("Enable"));
   }

   // Determine support for background upload
   m_bgsupported = true;
   if( gUnitInfo.TargetID > 0 && gUnitInfo.TargetID < 9 )
	   m_bgsupported = false; // Not supported on small units
   if( gUnitInfo.TargetID < 100 && (gUnitInfo.FirmwareVer < 472 ) )
	   m_bgsupported = false; // Only supported after Firmware version 4.72
   if( gUnitInfo.monitor )
	   m_bgsupported = false; // Not supported in monitor mode
   gConnected = true;
}

void CRTCUProgDlg::UpdateResume()
{
   // Var
   CString path;

   // Determine if upload in progress
   if( m_dlgupload->m_UploadInProgress ) {
      m_ctrapp.EnableWindow(false);
      m_ctrappres.EnableWindow(false);
      m_ctrfw.EnableWindow(false);
      m_ctrfwres.EnableWindow(false);
	  return;
   }

   // Determine if resume file is present
   bool file         = FindReportFile(gUnitInfo.SerialNumber);

   // Read resume file
   BUR Report;
   Report.AppHeadSeg = 0;
   Report.FWHeadSeg  = 0;
   if(file) LoadReportFile( gUnitInfo.SerialNumber, Report, path );

   // Application
   if( !m_AppSelected.IsEmpty() && gUnitInfo.Connected && !(m_AppType == 0 && !m_bgsupported) )
      m_ctrapp.EnableWindow(true);
   else
      m_ctrapp.EnableWindow(false);

   // Application resume
   if( m_AppType == 0 && m_ctrapp.IsWindowEnabled() && Report.AppHeadSeg > 0 )
      m_ctrappres.EnableWindow(true);
   else
      m_ctrappres.EnableWindow(false);

   // Firmware
   if( (rmonConnected(hCon) == RMONCON_GW && m_FWType != 0) || m_FWSelected.IsEmpty() || !gUnitInfo.Connected || (m_FWType == 0 && !m_bgsupported) )
      m_ctrfw.EnableWindow(false);
   else
      m_ctrfw.EnableWindow(true);

   // Firmware resume
   if( m_FWType == 0 && m_ctrfw.IsWindowEnabled() && Report.FWHeadSeg > 0 )
      m_ctrfwres.EnableWindow(true);
   else
      m_ctrfwres.EnableWindow(false);

   // Application and Firmware
   if( gUnitInfo.Connected && !m_AppSelected.IsEmpty() && !m_FWSelected.IsEmpty() && !(rmonConnected(hCon) == RMONCON_GW && m_FWType != 0) )
      m_ctrappfw.EnableWindow(true);
   else
      m_ctrappfw.EnableWindow(false);
}

void CRTCUProgDlg::OnUpdateFileApplicationBackgroundupdate(CCmdUI* pCmdUI) 
{
   // Disable Background
   pCmdUI->Enable(m_bgsupported||!gUnitInfo.Connected);
}

void CRTCUProgDlg::OnUpdateFileFirmwareBackgroundupdate(CCmdUI* pCmdUI) 
{
   // Disable Background
   pCmdUI->Enable(m_bgsupported||!gUnitInfo.Connected);
}

/////////////////////////////////////////////////////////////////////////////
// Upload Application
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnApplicationupload() 
{
   // Is upload busy?
   if (m_dlgupload->m_Busy) return;
   m_dlgupload->m_Busy = true;

   // Configure programming
   m_dlgupload->m_filenameapp       = AfxGetApp()->GetProfileString( "Options", "APPFILE", "" );
   m_dlgupload->m_type              = m_AppType;
   m_dlgupload->m_SerialNumber      = gUnitInfo.SerialNumber;
   m_dlgupload->m_targetid          = gUnitInfo.TargetID;

   // Reset resume
   m_dlgupload->m_report.FWHeadSeg  = 0;
   m_dlgupload->m_report.AppHeadSeg = 0;

   // Disable uploads
   m_ctrapp.EnableWindow(false);
   m_ctrappres.EnableWindow(false);
   m_ctrfw.EnableWindow(false);
   m_ctrfwres.EnableWindow(false);

   // Program unit
   m_dlgupload->ShowWindow(true);
   m_dlgupload->SetTimer( 111, 500, NULL );
}

void CRTCUProgDlg::OnApplicationresume() 
{
   // Var
   CString appfile;

   // Is upload busy?
   if (m_dlgupload->m_Busy) return;
   m_dlgupload->m_Busy = true;

   // Load resume info
   LoadReportFile( gUnitInfo.SerialNumber, m_dlgupload->m_report, appfile );

   // Configure programming
   m_dlgupload->m_filenameapp  = appfile;
   m_dlgupload->m_type         = m_AppType;
   m_dlgupload->m_SerialNumber = gUnitInfo.SerialNumber;
   m_dlgupload->m_targetid     = gUnitInfo.TargetID;

   // Disable uploads
   m_ctrapp.EnableWindow(false);
   m_ctrappres.EnableWindow(false);
   m_ctrfw.EnableWindow(false);
   m_ctrfwres.EnableWindow(false);

   // Program unit
   m_dlgupload->ShowWindow(true);
   m_dlgupload->SetTimer( 111, 500, NULL );
}

/////////////////////////////////////////////////////////////////////////////
// Upload Firmware
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnFirmwareUpload() 
{
   // Is upload busy?
   if (m_dlgupload->m_Busy) return;
   m_dlgupload->m_Busy = true;

   // Configure programming
   m_dlgupload->m_filenamefw        = AfxGetApp()->GetProfileString( "Options", "FWFILE", "" );
   m_dlgupload->m_type              = m_FWType;
   m_dlgupload->m_SerialNumber      = gUnitInfo.SerialNumber;
   m_dlgupload->m_targetid          = gUnitInfo.TargetID;

   // Reset resume
   m_dlgupload->m_report.FWHeadSeg  = 0;
   m_dlgupload->m_report.AppHeadSeg = 0;

   // Disable uploads
   m_ctrapp.EnableWindow(false);
   m_ctrappres.EnableWindow(false);
   m_ctrfw.EnableWindow(false);
   m_ctrfwres.EnableWindow(false);

   // Program unit
   m_dlgupload->ShowWindow(true);
   m_dlgupload->SetTimer( 111, 500, NULL );
}

void CRTCUProgDlg::OnFirmwareresume() 
{
   // Var
   CString fwfile;

   // Is upload busy?
   if (m_dlgupload->m_Busy) return;
   m_dlgupload->m_Busy = true;

   // Load resume info
   LoadReportFile( gUnitInfo.SerialNumber, m_dlgupload->m_report, fwfile );

   // Configure programming
   m_dlgupload->m_filenamefw   = fwfile;
   m_dlgupload->m_type         = m_FWType;
   m_dlgupload->m_SerialNumber = gUnitInfo.SerialNumber;
   m_dlgupload->m_targetid     = gUnitInfo.TargetID;

   // Disable uploads
   m_ctrapp.EnableWindow(false);
   m_ctrappres.EnableWindow(false);
   m_ctrfw.EnableWindow(false);
   m_ctrfwres.EnableWindow(false);

   // Program unit
   m_dlgupload->ShowWindow(true);
   m_dlgupload->SetTimer( 111, 500, NULL );
}

/////////////////////////////////////////////////////////////////////////////
// Upload Application and Firmware
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnUploadappandfw() 
{
   // Is upload busy?
   if (m_dlgupload->m_Busy) return;
   m_dlgupload->m_Busy = true;

   // Only when Direct Upload selected and Both Firmware and application selected
   if( gUnitInfo.Connected && !m_AppSelected.IsEmpty() && !m_FWSelected.IsEmpty() && m_FWType != 0 && m_AppType != 0 && (rmonConnected(hCon) == RMONCON_LOCAL || rmonConnected(hCon) == RMONCON_REMOTE) ) {
      // Configure programming
      m_dlgupload->m_filenameapp       = AfxGetApp()->GetProfileString( "Options", "APPFILE", "" );
      m_dlgupload->m_filenamefw        = AfxGetApp()->GetProfileString( "Options", "FWFILE", "" );
      m_dlgupload->m_type              = 1;
      m_dlgupload->m_SerialNumber      = gUnitInfo.SerialNumber;
      m_dlgupload->m_SilentVoice       = true;
      m_dlgupload->m_targetid          = gUnitInfo.TargetID;

      // Resume report
      m_dlgupload->m_report.AppCodeSeg = 0;
      m_dlgupload->m_report.AppHeadSeg = 0;
      m_dlgupload->m_report.FWCodeSeg  = 0;
      m_dlgupload->m_report.FWConstSeg = 0;
      m_dlgupload->m_report.FWHeadSeg  = 0;

      // Disable uploads
      m_ctrapp.EnableWindow(false);
      m_ctrappres.EnableWindow(false);
      m_ctrfw.EnableWindow(false);
      m_ctrfwres.EnableWindow(false);

      // Program unit
      m_dlgupload->ShowWindow(true);
      m_dlgupload->SetTimer( 111, 500, NULL );
   } else {
      m_dlgupload->m_Busy = false;
   }
}

/////////////////////////////////////////////////////////////////////////////
// Select files
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnFileApplicationSelectfile() 
{
   // Retrieve current path and file
   CString appfile = AfxGetApp()->GetProfileString( "Options", "APPFILE", "" );
   // Generate select file dialog
   CString defExt  = "RTCU Application files (.PRJ .VSX .PSX .RPC)|*.PRJ;*.VSX;*.PSX;*.RPC||";
   CFileDialog filedialog( TRUE, "VSX", appfile, OFN_ENABLESIZING | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR, defExt );
   // Select file
   if( filedialog.DoModal() == IDOK ) {
      // Determine new path and file
      m_AppSelected = _T(" ") + filedialog.GetFileName();
      appfile       = filedialog.GetPathName();
      // Update reg
      AfxGetApp()->WriteProfileString( "Options", "APPFILE", appfile );
      // Update dialog
      UpdateData(FALSE);
      UpdateResume();
   }  
}

void CRTCUProgDlg::OnFileFirmwareSelectfile() 
{
   // Retrieve current path and file
   CString fwfile = AfxGetApp()->GetProfileString( "Options", "FWFILE", "" );
   // Generate select file dialog
   CFileDialog filedialog( TRUE, "bin", fwfile, OFN_ENABLESIZING | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR, "Firmware files|*.bin||" );
   // Select file
   if( filedialog.DoModal() == IDOK ) {
      // Determine new path and file
      m_FWSelected = _T(" ") + filedialog.GetFileName();
      fwfile       = filedialog.GetPathName();
      // Update reg
      AfxGetApp()->WriteProfileString( "Options", "FWFILE", fwfile );
      // Update dialog
      UpdateData(FALSE);
      UpdateResume();
   }
}

void CRTCUProgDlg::OnFileFirmwareInternet() 
{
   CDlgFTPFirmware dlg;
   if( dlg.DoModal() == IDOK ) {
      m_FWSelected = _T(" ");
      int pos      = dlg.m_destinationfile.ReverseFind((char)92);     // (char)92 = "\"
      if( pos > 0 )
         m_FWSelected += dlg.m_destinationfile.Mid(pos+1);
      else
         m_FWSelected += dlg.m_destinationfile;
      AfxGetApp()->WriteProfileString( "Options", "FWFILE", dlg.m_destinationfile );
      UpdateData(FALSE);
      AfxMessageBox(IDS_FIRMWARE_DOWNLOAD_OK, MB_ICONINFORMATION);
      UpdateResume();
   }
}

/////////////////////////////////////////////////////////////////////////////
// Direct/Background update
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnFileApplicationBackgroundupdate() 
{
   // Save state
   AfxGetApp()->WriteProfileInt( "Options", "APPTYPE", 0 );
   m_AppType   = 0;

   // Change Text
   c_FrameApp.SetWindowText(_T("Transfer Application (Background)"));

   // Change menu
   CheckAppDirect(false);

   // Update buttons
   UpdateResume();
}

void CRTCUProgDlg::OnFileApplicationDirectupdate() 
{
   // Save state
   AfxGetApp()->WriteProfileInt( "Options", "APPTYPE", 1 );
   m_AppType   = 1;

   // Change Text
   c_FrameApp.SetWindowText(_T("Transfer Application (Direct)"));

   // Change menu
   CheckAppDirect(true);

   // Update buttons
   UpdateResume();
}

void CRTCUProgDlg::OnFileFirmwareBackgroundupdate() 
{
   // Save state
   AfxGetApp()->WriteProfileInt( "Options", "FWTYPE", 0 );
   m_FWType    = 0;

   // Change Text
   c_FrameFw.SetWindowText(_T("Transfer Firmware (Background)"));

   // Change menu
   CheckFWDirect(false);

   // Update buttons
   UpdateResume();
}

void CRTCUProgDlg::OnFileFirmwareDirectupdate() 
{
   // Save state
   AfxGetApp()->WriteProfileInt( "Options", "FWTYPE", 1 );
   m_FWType    = 1;

   // Change Text
   c_FrameFw.SetWindowText(_T("Transfer Firmware (Direct)"));

   // Change menu
   CheckFWDirect(true);

   // Update buttons
   UpdateResume();
}

void CRTCUProgDlg::CheckAppDirect( const bool& Direct ) 
{
   // Var
   UINT DirCheck, BackCheck;
   // Direct Update
   if(Direct) {
      DirCheck  = MF_BYCOMMAND | MF_CHECKED;
      BackCheck = MF_BYCOMMAND | MF_UNCHECKED;
   }
   // Background Update
   else {
      DirCheck  = MF_BYCOMMAND | MF_UNCHECKED;
      BackCheck = MF_BYCOMMAND | MF_CHECKED;
   }
   // Retrieve menu
   CMenu* pMenu = GetMenu();
   if(pMenu) {
      // Update menu
      pMenu->CheckMenuItem( ID_FILE_APPLICATION_BACKGROUNDUPDATE, BackCheck );
      pMenu->CheckMenuItem( ID_FILE_APPLICATION_DIRECTUPDATE,     DirCheck );
   }
}

void CRTCUProgDlg::CheckFWDirect( const bool& Direct )
{
   // Var
   UINT DirCheck, BackCheck;
   // Direct Update
   if(Direct) {
      DirCheck  = MF_BYCOMMAND | MF_CHECKED;
      BackCheck = MF_BYCOMMAND | MF_UNCHECKED;
   }
   // Background Update
   else {
      DirCheck  = MF_BYCOMMAND | MF_UNCHECKED;
      BackCheck = MF_BYCOMMAND | MF_CHECKED;
   }
   // Retrieve menu
   CMenu* pMenu = GetMenu();
   if(pMenu) {
      // Update menu
      pMenu->CheckMenuItem( ID_FILE_FIRMWARE_BACKGROUNDUPDATE, BackCheck );
      pMenu->CheckMenuItem( ID_FILE_FIRMWARE_DIRECTUPDATE,     DirCheck );
   }
}

/////////////////////////////////////////////////////////////////////////////
// Messages from unit
/////////////////////////////////////////////////////////////////////////////

void CRTCUProgDlg::OnUnitHalt() 
{
	// Verify with user
	if( AfxMessageBox(_T("Are you sure that you want to Halt execution in the RTCU unit ?"),MB_ICONWARNING|MB_YESNO|MB_DEFBUTTON2) != IDYES ) return;

	// 
	BeginWaitCursor();
	int rc = rmonHalt(hCon);
	if(rc) AfxMessageBox(_T("Error in communicating with RTCU unit"));
}

void CRTCUProgDlg::OnUpdateUnitHalt(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gUnitInfo.Connected);
}

void CRTCUProgDlg::OnUnitReset() 
{
   if( AfxMessageBox(_T("Are you sure you want to Reset the RTCU unit ?"),MB_ICONWARNING|MB_YESNO|MB_DEFBUTTON2) != IDYES ) return;

   // Perform the reset (on cable this is immediate, on modem and GPRS it happens when user presses "Disconnect"
   BeginWaitCursor();
   int con = rmonConnected(hCon);
   int rc = rmonReset(hCon);
   if(rc)
      AfxMessageBox(_T("Error in communicating with RTCU unit"));
   else if( con != RMONCON_LOCAL )
      AfxMessageBox(_T("RTCU unit will automatically reset when this session disconnects"));
}

void CRTCUProgDlg::OnUpdateUnitReset(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gUnitInfo.Connected);
}

void CRTCUProgDlg::OnShowmessagesfromunit() 
{
   // Show Debug messages
   if(m_dlgdebugmsg) m_dlgdebugmsg->ShowWindow(SW_SHOW);
}

void CRTCUProgDlg::OnUpdateShowmessagesfromunit(CCmdUI* pCmdUI) 
{
   if(m_dlgdebugmsg)
      pCmdUI->Enable(gUnitInfo.Connected);
   else
      pCmdUI->Enable(FALSE);
}

void CRTCUProgDlg::OnPassword() 
{
   CUnitPassword dlg;
   if( dlg.DoModal() == IDOK ) {
      int rc = rmonSetPassword(hCon, dlg.m_password);
      if( rc == rmonOK )
         AfxMessageBox(_T("New password has been set."));
      else
         AfxMessageBox(_T("Error in communicating with RTCU unit"));
   }
}

void CRTCUProgDlg::OnUpdatePassword(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(gUnitInfo.Connected);
}

void CRTCUProgDlg::OnRtc() 
{
   CUnitRtc dlg;
   dlg.DoModal();
}

void CRTCUProgDlg::OnUpdateRtc(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(gUnitInfo.Connected);
}

void CRTCUProgDlg::OnUnitsms() 
{
   if(m_dlgsms) m_dlgsms->ShowWindow(SW_SHOW);
}

void CRTCUProgDlg::OnUpdateUnitsms(CCmdUI* pCmdUI) 
{
   if(m_dlgsms)
      pCmdUI->Enable(gUnitInfo.Connected);
   else
      pCmdUI->Enable(FALSE);
}

void CRTCUProgDlg::OnUpgrade()
{
	CUnitUpgrade dlg;
	dlg.DoModal();
}

void CRTCUProgDlg::OnUpdateUpgrade(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(rmonConnected(hCon)!=RMONCON_NONE);
}

void CRTCUProgDlg::OnFlexOptions()
{
   if (m_dlgoptions) m_dlgoptions->ShowWindow(SW_SHOW);
}

void CRTCUProgDlg::OnUpdateFlexOptions(CCmdUI *pCmdUI)
{
   pCmdUI->Enable(rmonConnected(hCon)!=RMONCON_NONE);
}

void CRTCUProgDlg::OnOptionserver()
{
   if (m_dlgoptionserver) m_dlgoptionserver->ShowWindow(SW_SHOW);
}

void CRTCUProgDlg::OnUpdateOptionserver(CCmdUI *pCmdUI)
{
  // Var
  bool enable = true;

  // Rules
  if (rmonConnected(hCon) == RMONCON_NONE)
    enable = false;
  else if (gUnitInfo.TargetID < 100)
    enable = false;
  else if (gUnitInfo.FirmwareVer < 262 || (gUnitInfo.FirmwareVer > 8000 && gUnitInfo.FirmwareVer < 8262))
    enable = false;

  // Setup
   pCmdUI->Enable(enable);
}

void CRTCUProgDlg::OnGatewaysettings() 
{
	CUnitGWSheet dlg(_T("RTCU Communication Hub setup"));
	dlg.DoModal();
}

void CRTCUProgDlg::OnUpdateGatewaysettings(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(gUnitInfo.Connected && gUnitInfo.TargetID > 8);
}

void CRTCUProgDlg::OnGprssetup() 
{
    CUnitNetSheet dlg(_T("Network setup"));
    dlg.DoModal();
}

void CRTCUProgDlg::OnUpdateGprssetup(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(gUnitInfo.Connected && gUnitInfo.TargetID > 8);
}

void CRTCUProgDlg::OnPINcode()
{
   CUnitPinCode dlg;
   if( dlg.DoModal() == IDOK ) {
      int rc = rmonSetGSMPIN(hCon, dlg.m_pin);
      if( rc == rmonOK )
         AfxMessageBox(_T("New PIN code has been set."));
      else
         AfxMessageBox(_T("Error in communicating with RTCU unit"));
   }
}

void CRTCUProgDlg::OnUpdatePINcode(CCmdUI *pCmdUI)
{
   pCmdUI->Enable(gUnitInfo.Connected);
}

void CRTCUProgDlg::OnFilesystem()
{
   if (m_dlgfilesystem) m_dlgfilesystem->ShowWindow(SW_SHOW);
}

void CRTCUProgDlg::OnUpdateFilesystem(CCmdUI *pCmdUI)
{
   pCmdUI->Enable(gUnitInfo.Connected);
}

/////////////////////////////////////////////////////////////////////////////
// Background Update Report
/////////////////////////////////////////////////////////////////////////////

bool CRTCUProgDlg::FindReportFile( const unsigned long& SerialNumber ) const
{
   // Var
   CString File,Temp;
   WIN32_FIND_DATA FindFileData;
   HANDLE hFind;
   int pos;
   TCHAR szPath[MAX_PATH];

   // Build search path
   if (SUCCEEDED(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, szPath))) {
      File  = szPath;
      if (File.Right(1) != _T("\\")) File += _T("\\");
   } else {
      Temp  = AfxGetApp()->m_pszHelpFilePath;
      pos   = Temp.ReverseFind((char)92);     // (char)92 = "\"
      File  = Temp.Left(pos+1);
   }
   Temp.Format(_T("%d.bur"),SerialNumber);
   File += Temp;

   // Search for file
   hFind = FindFirstFile(File, &FindFileData);
   if( hFind != INVALID_HANDLE_VALUE) {
      // Close handle
      FindClose(hFind);

      // Reply: Found
      return true;
   }

   // Reply: Not found
   return false;
}

bool CRTCUProgDlg::LoadReportFile( const unsigned long& SerialNumber, BUR& Report, CString& Path ) const
{
   // Var
   CString Filename,Temp;
   int pos;
   TCHAR szPath[MAX_PATH];

   // Build search path
   if (SUCCEEDED(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, szPath))) {
      Filename  = szPath;
      if (Filename.Right(1) != _T("\\")) Filename += _T("\\");
   } else {
      Temp      = AfxGetApp()->m_pszHelpFilePath;
      pos       = Temp.ReverseFind((char)92);     // (char)92 = "\"
      Filename  = Temp.Left(pos+1);
   }
   Temp.Format(_T("%d.bur"),SerialNumber);
   Filename += Temp;

   // Exception safety
   try {
      // Var
      int  FileID;
      char FileVer;

      // Open file
      CFile File(Filename,CFile::modeRead);

      // Read file ID
      if( File.Read(&FileID,sizeof(FileID)) == sizeof(FileID) ) {
         // Validate file as Backup Update Report
         if( FileID == 0xF00DEA00 ) {
            // Read file version
            if( File.Read(&FileVer,sizeof(FileVer)) == sizeof(FileVer) ) {
               // Var
               int AppCodeSeg, AppHeadSeg;
               int FWCodeSeg, FWConstSeg, FWHeadSeg;

               // Read Application segment
               File.Read( &AppCodeSeg, sizeof(AppCodeSeg) );
               File.Read( &AppHeadSeg, sizeof(AppHeadSeg) );

               // Read Firmware segment
               File.Read( &FWCodeSeg,  sizeof(FWCodeSeg) );
               File.Read( &FWConstSeg, sizeof(FWConstSeg) );
               File.Read( &FWHeadSeg,  sizeof(FWHeadSeg) );

               // Read path
               Temp.Empty();
               File.Read( &FileID,     sizeof(FileID) );
               if( FileID > 0 ) {
                  char str[512];
                  File.Read( str, FileID );
                  str[FileID] = 0;
                  Temp = str;
               }

               // Fill out report struct
               Report.AppCodeSeg = AppCodeSeg;
               Report.AppHeadSeg = AppHeadSeg;
               Report.FWCodeSeg  = FWCodeSeg;
               Report.FWConstSeg = FWConstSeg;
               Report.FWHeadSeg  = FWHeadSeg;

			   // Fill out path string
			   Path              = Temp;

               // Reply: Loaded
               return true;
            }
         }
      }
   }
   catch( CFileException* e ) {
      // Delete exception object
      e->Delete();
   }

   // Reply: Failed to load
   return false;
}

bool CRTCUProgDlg::SaveReportFile( const unsigned long& SerialNumber, const BUR& Report, const CString& Path ) const
{
   // Var
   CString Filename,Temp;
   int pos;
   TCHAR szPath[MAX_PATH];

   // Build search path
   if (SUCCEEDED(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, szPath))) {
      Filename  = szPath;
      if (Filename.Right(1) != _T("\\")) Filename += _T("\\");
   } else {
      Temp      = AfxGetApp()->m_pszHelpFilePath;
      pos       = Temp.ReverseFind((char)92);     // (char)92 = "\"
      Filename  = Temp.Left(pos+1);
   }
   Temp.Format(_T("%d.bur"),SerialNumber);
   Filename += Temp;

   // Exception safety
   try {
      // Open file
      CFile File(Filename,CFile::modeWrite|CFile::modeCreate);

      // Build header
      int  FileID  = 0xF00DEA00;
      char FileVer = 0;

      // Write header
      File.Write( &FileID,  sizeof(FileID) );
      File.Write( &FileVer, sizeof(FileVer) );

      // Write Application segment
      File.Write( &Report.AppCodeSeg, sizeof(Report.AppCodeSeg) );
      File.Write( &Report.AppHeadSeg, sizeof(Report.AppHeadSeg) );

      // Write Firmware segment
      File.Write( &Report.FWCodeSeg,  sizeof(Report.FWCodeSeg) );
      File.Write( &Report.FWConstSeg, sizeof(Report.FWConstSeg) );
      File.Write( &Report.FWHeadSeg,  sizeof(Report.FWHeadSeg) );

	  // Write path
	  FileID       = Path.GetLength();
      File.Write( &FileID, sizeof(FileID) );
      if( FileID > 0 ) File.Write( (LPCSTR)Path, FileID );

      // Reply: Loaded
      return true;
   }
   catch( CFileException* e ) {
      // Delete exception object
      e->Delete();

      // Exception safety
      try {
         CFile::Remove(Filename);
      }
      catch( CFileException* e ) {
         // Delete exception object
         e->Delete();
      }
   }

   // Reply: Failed to save
   return false;
}

void CRTCUProgDlg::DeleteReportFile( const unsigned long& SerialNumber ) const
{
   // Var
   CString Filename,Temp;
   int pos;
   TCHAR szPath[MAX_PATH];

   // Build search path
   if (SUCCEEDED(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, szPath))) {
      Filename  = szPath;
      if (Filename.Right(1) != _T("\\")) Filename += _T("\\");
   } else {
      Temp      = AfxGetApp()->m_pszHelpFilePath;
      pos       = Temp.ReverseFind((char)92);     // (char)92 = "\"
      Filename  = Temp.Left(pos+1);
   }
   Temp.Format(_T("%d.bur"),SerialNumber);
   Filename += Temp;

   // Exception safety
   try {
      CFile::Remove(Filename);
   }
   catch( CFileException* e ) {
      // Delete exception object
      e->Delete();
   }
}
