// RTCUProgDlg.h : header file
//

#if !defined(AFX_RTCUPROGDLG_H__DEF03E66_AB1D_4F95_A6FC_B438F2BA6C38__INCLUDED_)
#define AFX_RTCUPROGDLG_H__DEF03E66_AB1D_4F95_A6FC_B438F2BA6C38__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ConnectGwSheet.h"
#include "ConnectDlg.h"
#include "DebugMsgDlg.h"
#include "DlgUpload.h"
#include "UnitSms.h"
#include "UnitOptions.h"
#include "UnitOptionServer.h"
#include "DlgFilesystem.h"


/////////////////////////////////////////////////////////////////////////////
// CRTCUProgDlg dialog

class CRTCUProgDlg : public CDialog
{
// Construction
public:
	bool m_programmable;
	CRTCUProgDlg(CWnd* pParent = NULL);	// standard constructor
  void ManageLogon(bool quiet);
  void ShowUnitInfo();
	bool m_remoteportavailable;
	bool m_localportavailable;

  void OnInitMenuPopup(CMenu *pPopupMenu, UINT nIndex,BOOL bSysMenu);

   // Unit info
   void UpdateResume();

   // Background Update Report
   bool FindReportFile( const unsigned long& SerialNumber ) const;
   bool LoadReportFile( const unsigned long& SerialNumber, BUR& Report, CString& Path ) const;
   bool SaveReportFile( const unsigned long& SerialNumber, const BUR& Report, const CString& Path ) const;
   void DeleteReportFile( const unsigned long& SerialNumber ) const;

// Dialog Data
	//{{AFX_DATA(CRTCUProgDlg)
	enum { IDD = IDD_RTCUPROG_DIALOG };
	CButton	c_FrameFw;
	CButton	c_FrameApp;
	CStatic	c_FWSelected;
	CStatic	c_AppSelected;
	CButton	m_ctrappfw;
	CButton	m_ctrfwres;
	CButton	m_ctrappres;
	CButton	m_ctrfw;
	CButton	m_ctrapp;
	CStatic	m_ctrstatus;
	CString	m_AppSelected;
	CString	m_FWSelected;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRTCUProgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

   // Unit info
   bool				m_bgsupported;

   // Direct/Background update
   int				m_AppType;
   int				m_FWType;
   void CheckAppDirect( const bool& Direct );
   void CheckFWDirect( const bool& Direct );

   // Messages from unit
   CDebugMsgDlg*        m_dlgdebugmsg;
   CConnectGwSheet*     m_pGWConnect;
   CConnectDlg*         m_ptrdlgconnect;
   CDlgUpload*          m_dlgupload;
   CUnitSms*            m_dlgsms;
   CUnitOptions*        m_dlgoptions;
   CUnitOptionServer*   m_dlgoptionserver;
   CDlgFilesystem*      m_dlgfilesystem;

	// Generated message map functions
	//{{AFX_MSG(CRTCUProgDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFirmwareUpload();
	afx_msg void OnApplicationupload();
	afx_msg void OnAboutbox();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSetting();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnModem();
	afx_msg void OnUpdateModem(CCmdUI* pCmdUI);
	afx_msg void OnGprs();
	afx_msg void OnUpdateGprs(CCmdUI* pCmdUI);
	afx_msg void OnFileApplicationBackgroundupdate();
	afx_msg void OnFileApplicationDirectupdate();
	afx_msg void OnFileFirmwareBackgroundupdate();
	afx_msg void OnFileFirmwareDirectupdate();
	afx_msg void OnFileApplicationSelectfile();
	afx_msg void OnFileFirmwareSelectfile();
	afx_msg void OnShowmessagesfromunit();
	afx_msg void OnUpdateShowmessagesfromunit(CCmdUI* pCmdUI);
	afx_msg void OnFileFirmwareInternet();
	afx_msg void OnApplicationresume();
	afx_msg void OnFirmwareresume();
	afx_msg void OnUploadappandfw();
	afx_msg void OnUpdateFileApplicationBackgroundupdate(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileFirmwareBackgroundupdate(CCmdUI* pCmdUI);
	afx_msg void OnUnitHalt();
	afx_msg void OnUpdateUnitHalt(CCmdUI* pCmdUI);
	afx_msg void OnUnitReset();
	afx_msg void OnUpdateUnitReset(CCmdUI* pCmdUI);
	afx_msg void OnPassword();
	afx_msg void OnUpdatePassword(CCmdUI* pCmdUI);
	afx_msg void OnRtc();
	afx_msg void OnUpdateRtc(CCmdUI* pCmdUI);
	afx_msg void OnUnitsms();
	afx_msg void OnUpdateUnitsms(CCmdUI* pCmdUI);
	afx_msg void OnUpgrade();
	afx_msg void OnUpdateUpgrade(CCmdUI* pCmdUI);
  afx_msg void OnFlexOptions();
  afx_msg void OnUpdateFlexOptions(CCmdUI *pCmdUI);
	afx_msg void OnGatewaysettings();
	afx_msg void OnUpdateGatewaysettings(CCmdUI* pCmdUI);
	afx_msg void OnGprssetup();
	afx_msg void OnUpdateGprssetup(CCmdUI* pCmdUI);
  afx_msg void OnOptionserver();
  afx_msg void OnUpdateOptionserver(CCmdUI *pCmdUI);
   afx_msg void OnPINcode();
   afx_msg void OnUpdatePINcode(CCmdUI *pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
   afx_msg void OnFilesystem();
   afx_msg void OnUpdateFilesystem(CCmdUI *pCmdUI);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RTCUPROGDLG_H__DEF03E66_AB1D_4F95_A6FC_B438F2BA6C38__INCLUDED_)
