// UnitGPRSSetup.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGPRSSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitGPRSSetup dialog


CUnitGPRSSetup::CUnitGPRSSetup(CWnd* pParent /*=NULL*/)
	: CDialog(CUnitGPRSSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnitGPRSSetup)
	m_apn            = _T("");
	m_password       = _T("");
	m_userid         = _T("");
	m_authentication = -1;
	m_init           = _T("");
	//}}AFX_DATA_INIT
}


void CUnitGPRSSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitGPRSSetup)
	DDX_Control(pDX, IDC_INIT, m_ctrinit);
	DDX_Control(pDX, IDC_AUTHENTICATION, m_ctrauthentication);
	DDX_Control(pDX, IDC_GATEWAYIP, m_ctrgatewayip);
	DDX_Control(pDX, IDC_SUBNET, m_ctrsubnet);
	DDX_Control(pDX, IDC_IP, m_ctrip);
	DDX_Control(pDX, IDC_DNS2, m_ctrdns2);
	DDX_Control(pDX, IDC_DNS1, m_ctrdns1);
	DDX_Control(pDX, IDOK, m_ctrclose);
	DDX_Control(pDX, IDC_WRITE, m_ctrwrite);
	DDX_Control(pDX, IDC_READ, m_ctrread);
	DDX_Text(pDX, IDC_APN, m_apn);
	DDV_MaxChars(pDX, m_apn, 32);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDV_MaxChars(pDX, m_password, 16);
	DDX_Text(pDX, IDC_USERID, m_userid);
	DDV_MaxChars(pDX, m_userid, 32);
	DDX_CBIndex(pDX, IDC_AUTHENTICATION, m_authentication);
	DDX_Text(pDX, IDC_INIT, m_init);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitGPRSSetup, CDialog)
	//{{AFX_MSG_MAP(CUnitGPRSSetup)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_BN_CLICKED(IDC_SETDEFAULT, OnSetdefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnitGPRSSetup message handlers

BOOL CUnitGPRSSetup::OnInitDialog() 
{
   CDialog::OnInitDialog();

   m_userid         = AfxGetApp()->GetProfileString("TCP/IP Options", "USERID", "");
   m_password       = AfxGetApp()->GetProfileString("TCP/IP Options", "PASSWORD", "");
   m_ip             = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "IP", 0);
   m_subnet         = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "SUBNET", 0xFFFFFFFF);
   m_apn            = AfxGetApp()->GetProfileString("TCP/IP Options", "APN", "internet");
   m_dns1           = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "DNS1", 0);
   m_dns2           = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "DNS2", 0);
   m_gatewayip      = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "GATEWAYIP", 0);
   m_authentication = AfxGetApp()->GetProfileInt(   "TCP/IP Options", "AUTHENTICATION", 3);

   m_ctrdns1.SetAddress(m_dns1);
   m_ctrdns2.SetAddress(m_dns2);
   m_ctrip.SetAddress(m_ip);
   m_ctrgatewayip.SetAddress(m_gatewayip);
   m_ctrsubnet.SetAddress(m_subnet);

   UpdateData(false);

   int targetid, firmwareversion;
   // Get targetid and firmware revision
   int rc = rmonGetTargetInfo(hCon, &targetid, &firmwareversion);

   m_ctrinit.EnableWindow( targetid >= 9 && firmwareversion >= 454 && rc == 0 );
   m_ctrauthentication.EnableWindow( targetid >= 9 && firmwareversion >= 454 && rc == 0 );
	
   return TRUE;
}

void CUnitGPRSSetup::OnOK() 
{
   UpdateData(true);
   m_ctrdns1.GetAddress(m_dns1);
   m_ctrdns2.GetAddress(m_dns2);
   m_ctrip.GetAddress(m_ip);
   m_ctrsubnet.GetAddress(m_subnet);
   m_ctrgatewayip.GetAddress(m_gatewayip);

   AfxGetApp()->WriteProfileString( "TCP/IP Options", "USERID",         m_userid );
   AfxGetApp()->WriteProfileString( "TCP/IP Options", "PASSWORD",       m_password );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "IP",             m_ip );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "SUBNET",         m_subnet );
   AfxGetApp()->WriteProfileString( "TCP/IP Options", "APN",            m_apn );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "DNS1",           m_dns1 );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "DNS2",           m_dns2 );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "GATEWAYIP",      m_gatewayip );
   AfxGetApp()->WriteProfileInt(    "TCP/IP Options", "AUTHENTICATION", m_authentication );

   CDialog::OnOK();
}

void CUnitGPRSSetup::OnCancel() 
{
   CDialog::OnCancel();
}

void CUnitGPRSSetup::OnRead() 
{
	// Var
	rmonGPRSSettings Settings;
	rmonRet rc;

	// Set controls
	m_ctrwrite.EnableWindow(false);
	m_ctrread.EnableWindow(false);
	m_ctrclose.EnableWindow(false);

	// Fetch TCP/IP settings from unit
	rc = rmonGetGPRSSettings(hCon, &Settings );

	// Set controls
	m_ctrwrite.EnableWindow(true);
	m_ctrread.EnableWindow(true);
	m_ctrclose.EnableWindow(true);

	// Errors?
	if(rc) {
		if( rc == rmonNoData ) {
			AfxMessageBox("No valid data in TCP/IP configuration parameters"); 
		} else {
			AfxMessageBox("Error in communicating with RTCU unit");
		}
		return;
	}

	// Set data
	m_userid   = Settings.username;
	m_password = Settings.password;
	m_ctrip.SetAddress(Settings.ip_address);
	m_ctrsubnet.SetAddress(Settings.subnet_mask);
	m_apn      = Settings.APN;
	m_ctrdns1.SetAddress(Settings.dns_1);
	m_ctrdns2.SetAddress(Settings.dns_2);
	m_ctrgatewayip.SetAddress(Settings.gateway);
	m_authentication = Settings.authentication;
	m_init           = Settings.modem_init;
	UpdateData(false);
}

void CUnitGPRSSetup::OnWrite() 
{
	// Var
	rmonGPRSSettings Settings;
	rmonRet rc;

	// Build struct
	UpdateData(true);
	strcpy_s( (char*)Settings.username, sizeof(Settings.username), (LPCTSTR)m_userid );
	strcpy_s( (char*)Settings.password, sizeof(Settings.password), (LPCTSTR)m_password );
	m_ctrip.GetAddress(Settings.ip_address);
	m_ctrsubnet.GetAddress(Settings.subnet_mask);
	strcpy_s( (char*)Settings.APN, sizeof(Settings.APN), (LPCTSTR)m_apn );
	m_ctrdns1.GetAddress(Settings.dns_1);
	m_ctrdns2.GetAddress(Settings.dns_2);
	m_ctrgatewayip.GetAddress(Settings.gateway);
	Settings.authentication = (unsigned short) m_authentication;
	strcpy_s( (char*)Settings.modem_init, sizeof(Settings.modem_init), (LPCTSTR)m_init );

	// Set controls
	m_ctrwrite.EnableWindow(false);
	m_ctrread.EnableWindow(false);
	m_ctrclose.EnableWindow(false);

	// Write TCP/IP settings to unit
	rc = rmonSetGPRSSettings(hCon, Settings);

	// Set controls
	m_ctrwrite.EnableWindow(true);
	m_ctrread.EnableWindow(true);
	m_ctrclose.EnableWindow(true);

	// Message
	if(rc)
		AfxMessageBox("Error in communicating with RTCU unit");
	else
		AfxMessageBox("Please remember to Reset the RTCU unit for the changes to take effect !");
}

void CUnitGPRSSetup::OnSetdefault() 
{
   if( AfxMessageBox("Are you sure you want to set default values ?", MB_ICONWARNING|MB_YESNO|MB_DEFBUTTON2 ) == IDYES ) {
      m_userid         = "";
      m_password       = "";
      m_ip             = 0;
      m_subnet         = 0;
      m_apn            = "internet";
      m_dns1           = 0;
      m_dns2           = 0;
      m_gatewayip      = 0;
      m_authentication = 3;
      m_ctrdns1.SetAddress(m_dns1);
      m_ctrdns2.SetAddress(m_dns2);
      m_ctrip.SetAddress(m_ip);
      m_ctrgatewayip.SetAddress(m_gatewayip);
      m_ctrsubnet.SetAddress(m_subnet);
      m_init           = "";

      UpdateData(false);
   }
}
