// UnitGWPageFallback.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGWPageFallback.h"
#include "afxdialogex.h"


// CUnitGWPageFallback

IMPLEMENT_DYNAMIC(CUnitGWPageFallback, CPropertyPage)

CUnitGWPageFallback::CUnitGWPageFallback()
  : CPropertyPage(CUnitGWPageFallback::IDD)
{
   m_gwip               = "";
   m_gwkey              = "AABBCCDD";
   m_gwport             = 5000;
   m_gwenable           = FALSE;
   m_gwkeepalive        = 300;
   m_gwmaxconn          = 3;
   m_gwmaxsend          = 5;
   m_gwresptimeout      = 45;
   m_cryptkeyenable     = FALSE;
}

CUnitGWPageFallback::~CUnitGWPageFallback()
{
}

void CUnitGWPageFallback::DoDataExchange(CDataExchange* pDX)
{
   CPropertyPage::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_SPINPORT, m_gwspinport);
   DDX_Text(pDX, IDC_GWIP, m_gwip);
   DDV_MaxChars(pDX, m_gwip, 32);
   DDX_Text(pDX, IDC_GWKEY, m_gwkey);
   DDV_MaxChars(pDX, m_gwkey, 8);
   DDX_Text(pDX, IDC_GWPORT, m_gwport);
   DDV_MinMaxInt(pDX, m_gwport, 1, 65535);
   DDX_Check(pDX, IDC_GWENABLE, m_gwenable);
   DDX_Control(pDX, IDC_SPINRESPTIMEOUT, m_gwspinresptimeout);
   DDX_Control(pDX, IDC_SPINMAXSEND, m_gwspinmaxsend);
   DDX_Control(pDX, IDC_SPINMAXCONN, m_gwspinmaxconn);
   DDX_Control(pDX, IDC_SPINKEEPALIVE, m_gwspinkeepalive);
   DDX_Control(pDX, IDC_CRYPT_KEY, c_cryptkey);
   DDX_Text(pDX, IDC_GWKEEPALIVE, m_gwkeepalive);
   DDV_MinMaxInt(pDX, m_gwkeepalive, 0, 60000);
   DDX_Text(pDX, IDC_GWMAXCONN, m_gwmaxconn);
   DDV_MinMaxInt(pDX, m_gwmaxconn, 1, 60);
   DDX_Text(pDX, IDC_GWMAXSEND, m_gwmaxsend);
   DDV_MinMaxInt(pDX, m_gwmaxsend, 1, 60);
   DDX_Text(pDX, IDC_GWRESPTIMEOUT, m_gwresptimeout);
   DDV_MinMaxInt(pDX, m_gwresptimeout, 5, 60);
   DDX_Check(pDX, IDC_CHECK_CRYPT_KEY, m_cryptkeyenable);
}

BEGIN_MESSAGE_MAP(CUnitGWPageFallback, CPropertyPage)
   ON_BN_CLICKED(IDC_CHECK_CRYPT_KEY, &CUnitGWPageFallback::OnCheckCryptKey)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitGWPageFallback::OnInitDialog()
{
   // Default
   CPropertyPage::OnInitDialog();

   // Set controls
   m_gwspinport.SetRange32(1, 65535);
   m_gwspinkeepalive.SetRange32(0, 60000);
   m_gwspinresptimeout.SetRange(5, 60);
   m_gwspinmaxsend.SetRange(1, 60);
   m_gwspinmaxconn.SetRange(1, 60);
   UpdateData(false);

   // Set crypt key
   c_cryptkey.m_bpr = 8;
   c_cryptkey.SetOptions(false, true, false, false);
   c_cryptkey.SetData(m_crypt_key, 16);

   // Disable cryptkey?
   if (!m_cryptkeyenable)
   {
      c_cryptkey.EnableWindow(FALSE);
   }

   // Update
   UpdateData(false);

   // Completed
   return TRUE;
}

void CUnitGWPageFallback::OnCheckCryptKey()
{
   // Update check state
   UpdateData();

   // Is cryptkey enablet?
   if (m_cryptkeyenable)
   {
      // Enable HexEdit
      c_cryptkey.EnableWindow(TRUE);
   }
   else
   {
      // Disable HexEdit
      c_cryptkey.EnableWindow(FALSE);
   }
}

void CUnitGWPageFallback::UpdateView()
{
   // Is window created?
   if (c_cryptkey.GetSafeHwnd() == NULL) return;

   // Update data
   c_cryptkey.SetData(m_crypt_key, 16);
   UpdateData(false);

   // Disable cryptkey?
   c_cryptkey.EnableWindow(m_cryptkeyenable ? TRUE : FALSE);
}
