// UnitGWPageRCH.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGWPageRCH.h"
#include "afxdialogex.h"


// CUnitGWPageRCH

IMPLEMENT_DYNAMIC(CUnitGWPageRCH, CPropertyPage)

CUnitGWPageRCH::CUnitGWPageRCH()
  : CPropertyPage(CUnitGWPageRCH::IDD)
{
   m_gwip               = "";
   m_gwkey              = "AABBCCDD";
   m_gwport             = 5000;
   m_iface              = 1;
   m_gwenable           = FALSE;
   m_gwkeepalive        = 300;
   m_gwmaxconn          = 3;
   m_gwmaxsend          = 5;
   m_gwresptimeout      = 45;
   m_cryptkeyenable     = FALSE;
   m_secure             = FALSE;
   m_autostart          = FALSE;
}

CUnitGWPageRCH::~CUnitGWPageRCH()
{
}

void CUnitGWPageRCH::DoDataExchange(CDataExchange* pDX)
{
   CPropertyPage::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_SPINPORT, m_gwspinport);
   DDX_Text(pDX, IDC_GWIP, m_gwip);
   DDV_MaxChars(pDX, m_gwip, 32);
   DDX_Text(pDX, IDC_GWKEY, m_gwkey);
   DDV_MaxChars(pDX, m_gwkey, 8);
   DDX_Text(pDX, IDC_GWPORT, m_gwport);
   DDV_MinMaxInt(pDX, m_gwport, 1, 65535);
   DDX_Check(pDX, IDC_GWENABLE, m_gwenable);
   DDX_Control(pDX, IDC_SPINRESPTIMEOUT, m_gwspinresptimeout);
   DDX_Control(pDX, IDC_SPINMAXSEND, m_gwspinmaxsend);
   DDX_Control(pDX, IDC_SPINMAXCONN, m_gwspinmaxconn);
   DDX_Control(pDX, IDC_SPINKEEPALIVE, m_gwspinkeepalive);
   DDX_Text(pDX, IDC_GWKEEPALIVE, m_gwkeepalive);
   DDV_MinMaxInt(pDX, m_gwkeepalive, 0, 60000);
   DDX_Text(pDX, IDC_GWMAXCONN, m_gwmaxconn);
   DDV_MinMaxInt(pDX, m_gwmaxconn, 1, 60);
   DDX_Text(pDX, IDC_GWMAXSEND, m_gwmaxsend);
   DDV_MinMaxInt(pDX, m_gwmaxsend, 1, 60);
   DDX_Text(pDX, IDC_GWRESPTIMEOUT, m_gwresptimeout);
   DDV_MinMaxInt(pDX, m_gwresptimeout, 5, 60);
   DDX_Check(pDX, IDC_SECURITY, m_secure);
   DDX_Check(pDX, IDC_AUTOSHOW, m_autostart);
   DDX_Control(pDX, IDC_CRYPT_KEY, c_cryptkey);
   DDX_Check(pDX, IDC_CHECK_CRYPT_KEY, m_cryptkeyenable);
   DDX_Control(pDX, IDC_DROP_IFACE, c_iface);
}

BEGIN_MESSAGE_MAP(CUnitGWPageRCH, CPropertyPage)
   ON_BN_CLICKED(IDC_CHECK_CRYPT_KEY, &CUnitGWPageRCH::OnCheckCryptKey)
   ON_BN_CLICKED(IDC_SECURITY,        &CUnitGWPageRCH::OnCheckSecurity)
   ON_CBN_SELCHANGE(IDC_DROP_IFACE,   &CUnitGWPageRCH::OnChangeIface)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitGWPageRCH::OnInitDialog()
{
	// Default
	CPropertyPage::OnInitDialog();

	// Set controls
	m_gwspinport.SetRange32(1, 65535);
	m_gwspinkeepalive.SetRange32(0, 60000);
	m_gwspinresptimeout.SetRange(5, 60);
	m_gwspinmaxsend.SetRange(1, 60);
	m_gwspinmaxconn.SetRange(1, 60);
	c_iface.AddString(_T("Cellular"));
	c_iface.AddString(_T("LAN-1"));
	c_iface.AddString(_T("LAN-2"));
	c_iface.AddString(_T("WLAN"));
	UpdateData(false);
	c_iface.SetCurSel(m_iface > 0 ? (m_iface - 1) : 0);

	// Set crypt key
	c_cryptkey.m_bpr = 8;
	c_cryptkey.SetOptions(false, true, false, false);
	c_cryptkey.SetData(m_crypt_key, 16);

	// Disable cryptkey?
	if (!m_cryptkeyenable)
	{
		c_cryptkey.EnableWindow(FALSE);
	}

	// Update
	UpdateData(false);

	// Completed
	return TRUE;
}

void CUnitGWPageRCH::OnCheckCryptKey()
{
	// Update check state
	UpdateData();

	// Is cryptkey enablet?
	if (m_cryptkeyenable)
	{
		// Enable HexEdit
		c_cryptkey.EnableWindow(TRUE);
	}
	else
	{
		// Disable HexEdit
		c_cryptkey.EnableWindow(FALSE);
	}
}

void CUnitGWPageRCH::OnCheckSecurity()
{
	// Update check state
	UpdateData();

	// Validate
	if (m_secure) m_cryptkeyenable = 0;

	// Is cryptkey enablet?
	if (m_cryptkeyenable)
	{
		// Enable HexEdit
		c_cryptkey.EnableWindow(TRUE);
	}
	else
	{
		// Disable HexEdit
		c_cryptkey.EnableWindow(FALSE);
	}
	GetDlgItem(IDC_CHECK_CRYPT_KEY)->EnableWindow(m_secure ? FALSE : TRUE);

	// Update view
	UpdateData(FALSE);
}

void CUnitGWPageRCH::OnChangeIface()
{
	m_iface = c_iface.GetCurSel() + 1;
}

void CUnitGWPageRCH::UpdateView()
{
	// Is window created?
	if (m_gwspinresptimeout.GetSafeHwnd() == NULL) return;

	// Validate
	if (m_secure) m_cryptkeyenable = 0;

	// Update data
	c_cryptkey.SetData(m_crypt_key, 16);
	c_iface.SetCurSel(m_iface > 0 ? (m_iface - 1) : 0);
	UpdateData(false);

	// Disable cryptkey?
	c_cryptkey.EnableWindow(m_cryptkeyenable ? TRUE : FALSE);
	GetDlgItem(IDC_CHECK_CRYPT_KEY)->EnableWindow(m_secure ? FALSE : TRUE);
}
