// UnitGWSheet.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGWSheet.h"

#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitGWSheet

IMPLEMENT_DYNAMIC(CUnitGWSheet, CPropertySheet)

CUnitGWSheet::CUnitGWSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	// Var
	CString str, strList;
	int     i, pos;

	// Hide apply button
	m_psh.dwFlags |= PSH_NOAPPLYNOW;

	//
	// Insert pages
	//

	// Determine pages to show
	if (!gUnitInfo.Connected)
	{
		m_enable_gw = 1;
		m_enable_hub = 0;
	}
	else
	{
		// Get device type
		if (gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 201)
		{
			m_enable_gw = 1;
			m_enable_hub = 0;
		}
		else
		{
//			if (CUtility::version_newer(gUnitInfo.FirmwareVersion, 1, 53, 0))
//			{
				m_enable_gw = 0;
				m_enable_hub = 1;
//			}
//			else
//			{
//				m_enable_gw = 1;
//				m_enable_hub = 0;
//			}
		}
	}

	// Insert pages
	if (m_enable_gw) {
		AddPage(&m_Page1);
		AddPage(&m_Page2);
	}
	if (m_enable_hub) {
		AddPage(&m_Page3);
		AddPage(&m_Page4);
	}

	//
	// Retrieve settings, legacy
	//

	// Retrieve settings
	m_Page1.m_gwip				= AfxGetApp()->GetProfileString(_T("GPRS Options"), _T("GWIP"), _T("domain.net"));
	m_Page1.m_gwport			= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("PORT"), 5000);
	m_Page1.m_gwkey				= AfxGetApp()->GetProfileString(_T("GPRS Options"), _T("KEY"), _T("AABBCCDD"));
	m_Page1.m_gwenable			= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("GW Enable"), 0);
	m_Page2.m_gwkeepalive		= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("KEEPALIVE"), 300);
	m_Page2.m_gwmaxconn			= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("GW Maxconn"), 3);
	m_Page2.m_gwmaxsend			= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("GW Maxsend"), 5);
	m_Page2.m_gwresptimeout		= AfxGetApp()->GetProfileInt(   _T("GPRS Options"), _T("GW Resptimeout"), 45);
	strList						= AfxGetApp()->GetProfileString(_T("GPRS Options"), _T("CRYPTKEY"), _T("00000000-00000000-00000000-00000000"));

	// Iterate cryptkey bytes
	pos = 0;
	for (i = 0; i < 16; i++)
	{
		// Insert byte
		m_Page2.m_crypt_key[i] = hatoi(strList.Mid(pos, 2));

		// Calculate next position
		pos += 2;
		if ((i + 1) % 4 == 0) pos++;
	}


	//
	// Retrieve settings, hub
	//

	// Fallback connection
	m_Page4.m_gwip				= AfxGetApp()->GetProfileString(_T("GPRS Options\\Fallback"), _T("GWIP"), _T("domain.net"));
	m_Page4.m_gwport			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("PORT"), 5000);
	m_Page4.m_gwkey				= AfxGetApp()->GetProfileString(_T("GPRS Options\\Fallback"), _T("KEY"), _T("AABBCCDD"));
	m_Page4.m_gwenable			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Enable"), 0);
	m_Page4.m_gwkeepalive		= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("KEEPALIVE"), 300);
	m_Page4.m_gwmaxconn			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Maxconn"), 3);
	m_Page4.m_gwmaxsend			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Maxsend"), 5);
	m_Page4.m_gwresptimeout		= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Resptimeout"), 45);
	m_Page4.m_cryptkeyenable	= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\Fallback"), _T("CRYPTKEY Enable"), 0);
	strList						= AfxGetApp()->GetProfileString(_T("GPRS Options\\Fallback"), _T("CRYPTKEY"), _T("00000000-00000000-00000000-00000000"));

	// Iterate cryptkey bytes
	pos = 0;
	for (i = 0; i < 16; i++)
	{
		// Insert byte
		m_Page4.m_crypt_key[i] = hatoi(strList.Mid(pos, 2));

		// Calculate next position
		pos += 2;
		if ((i + 1) % 4 == 0) pos++;
	}

	// Connection
	m_Page3.m_autostart			= AfxGetApp()->GetProfileInt(   _T("GPRS Options"),          _T("AutoStart"), 0);
	m_Page3.m_gwip				= AfxGetApp()->GetProfileString(_T("GPRS Options\\server1"), _T("HOST"), _T("domain.net"));
	m_Page3.m_gwport			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("PORT"), 5000);
	m_Page3.m_iface				= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("iface"), 1);
	m_Page3.m_gwkey				= AfxGetApp()->GetProfileString(_T("GPRS Options\\server1"), _T("KEY"), _T("AABBCCDD"));
	m_Page3.m_gwenable			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("Enable"), 0);
	m_Page3.m_gwkeepalive		= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("KEEPALIVE"), 300);
	m_Page3.m_gwmaxconn			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("Maxconn"), 3);
	m_Page3.m_gwmaxsend			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("Maxsend"), 5);
	m_Page3.m_gwresptimeout		= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("Resptimeout"), 45);
	m_Page3.m_secure			= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("Secure"), 0);
	m_Page3.m_cryptkeyenable	= AfxGetApp()->GetProfileInt(   _T("GPRS Options\\server1"), _T("CRYPTKEY Enable"), 0);
	strList						= AfxGetApp()->GetProfileString(_T("GPRS Options\\server1"), _T("CRYPTKEY"), _T("00000000-00000000-00000000-00000000"));

	// Iterate cryptkey bytes
	pos = 0;
	for (i = 0; i < 16; i++)
	{
		// Insert byte
		m_Page3.m_crypt_key[i] = hatoi(strList.Mid(pos, 2));

		// Calculate next position
		pos += 2;
		if ((i + 1) % 4 == 0) pos++;
	}
}

CUnitGWSheet::~CUnitGWSheet()
{
}

BEGIN_MESSAGE_MAP(CUnitGWSheet, CPropertySheet)
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_BN_CLICKED(IDC_SETDEFAULT, OnSetdefault)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitGWSheet::OnInitDialog() 
{
	// Var
	CRect rect, rectWrite, rectFetch, rectDefault, rectDone, txt_error;
	int   start, stop;
	LONG  width, height, button;

	// Default
	BOOL bResult = CPropertySheet::OnInitDialog();

	// Calculate size
	GetPage(0)->GetDlgItem(IDC_TEXT_ENABLE)->GetWindowRect(&rect);
	GetPage(0)->ScreenToClient(&rect);
	width = rect.left;
	GetPage(0)->GetDlgItem(IDC_GWIP)->GetWindowRect(&rect);
	GetPage(0)->ScreenToClient(&rect);
	width += rect.right;
	GetPage(0)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	width = rect.Width() - width;
	GetTabControl()->GetWindowRect(&rect);
	ScreenToClient(&rect);
	m_tab_size = rect.Height();
	start = rect.left;
	stop = rect.right - width;
	height = -rect.bottom;
	button = ((rect.Width() - width) - (2 * start)) / 3;
	GetDlgItem(IDCANCEL)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	rectFetch.SetRect(
		start,
		rect.top,
		start + button,
		rect.bottom
	);
	rectDefault.SetRect(
		stop - button,
		rect.top,
		stop,
		rect.bottom
	);
	rectWrite.SetRect(
		rectFetch.right + start,
		rect.top,
		rectFetch.right + start + button,
		rect.bottom
	);
	rectDone.SetRect(
		stop - button,
		rectFetch.bottom + rect.top + height,
		stop,
		rectFetch.bottom + rect.bottom + height
	);
	txt_error.SetRect(
		rectFetch.left,
		rectDone.top - 5,
		rectWrite.right,
		rectDone.bottom
	);
	height = rectDone.Height();

	// Hide buttons
	GetDlgItem(IDOK)->ShowWindow(SW_HIDE);
	GetDlgItem(IDHELP)->ShowWindow(SW_HIDE);
	ModifyStyle( WS_SYSMENU, 0, 0 );

	// Adjust pages
	for( int i = 0; i < GetPageCount(); ++i )
	{
		if( GetPage(i)->GetSafeHwnd() )
		{
			// Change size
			GetPage(i)->GetWindowRect(&rect);
			rect.right -= width;
			GetPage(i)->SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);
		}
	}

	// Adjust TAB ctrl
	GetTabControl()->GetWindowRect(&rect);
	rect.right -= width;
	GetTabControl()->SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);

	// Adjust sheet
	GetWindowRect(&rect);
	rect.right -= width;
	rect.bottom += height + 7;
	SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height(), SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOZORDER|SWP_NOACTIVATE);

	// Add button done
	GetDlgItem(IDCANCEL)->MoveWindow(&rectDone);
	GetDlgItem(IDCANCEL)->SetWindowText(_T("Close"));

	// Add button Fetch
	m_ctrfetch.CreateEx(0, _T("BUTTON"), _T("Fetch"), WS_CHILD|WS_VISIBLE|WS_TABSTOP, rectFetch, this, IDC_READ, 0);
	m_ctrfetch.SetFont(GetFont());

	// Add button Write
	m_ctrwrite.CreateEx(0, _T("BUTTON"), _T("Apply"), WS_CHILD|WS_VISIBLE|WS_TABSTOP, rectWrite, this, IDC_WRITE, 0);
	m_ctrwrite.SetFont(GetFont());

	// Add button Print
	m_ctrdefault.CreateEx(0, _T("BUTTON"), _T("Default"), WS_CHILD|WS_VISIBLE|WS_TABSTOP, rectDefault, this, IDC_SETDEFAULT, 0);
	m_ctrdefault.SetFont(GetFont());

	// Add warning text
	m_error.Create(_T("Message"), WS_CHILD | WS_TABSTOP, txt_error, this, IDC_STATUS);
	m_error.SetFont(GetFont());

	// Completed
	return bResult;
}

void CUnitGWSheet::OnDestroy()
{
	// Var
	CString str, strList, crypt1, crypt2;

	// Update data
	if (m_Page1.m_gwspinport.GetSafeHwnd()) m_Page1.UpdateData(true);
	if (m_Page2.c_cryptkey.GetSafeHwnd())   m_Page2.UpdateData(true);
	if (m_Page3.m_gwspinport.GetSafeHwnd()) m_Page3.UpdateData(true);
	if (m_Page4.m_gwspinport.GetSafeHwnd()) m_Page4.UpdateData(true);
	if (m_Page2.c_cryptkey.GetSafeHwnd())   m_Page2.c_cryptkey.GetData(m_Page2.m_crypt_key, 16);
	if (m_Page3.c_cryptkey.GetSafeHwnd())   m_Page3.c_cryptkey.GetData(m_Page3.m_crypt_key, 16);
	if (m_Page4.c_cryptkey.GetSafeHwnd())   m_Page4.c_cryptkey.GetData(m_Page4.m_crypt_key, 16);

	// Iterate cryptkey bytes
	for (int i = 0; i < 16; i++)
	{
		// Insert byte
		str.Format("%02X", m_Page2.m_crypt_key[i]);
		strList += str;
		// Divider?
		if ((i + 1) % 4 == 0 && (i + 1) != 16)
		{
			// Insert divider
			strList += _T("-");
		}
	}

	// Iterate cryptkey bytes
	for (int i = 0; i < 16; i++)
	{
		// Insert byte
		str.Format("%02X", m_Page3.m_crypt_key[i]);
		crypt1 += str;
		// Divider?
		if ((i + 1) % 4 == 0 && (i + 1) != 16)
		{
			// Insert divider
			crypt1 += _T("-");
		}
	}

	// Iterate cryptkey bytes
	for (int i = 0; i < 16; i++)
	{
		// Insert byte
		str.Format("%02X", m_Page4.m_crypt_key[i]);
		crypt2 += str;
		// Divider?
		if ((i + 1) % 4 == 0 && (i + 1) != 16)
		{
			// Insert divider
			crypt2 += _T("-");
		}
	}

	//
	// Save settings
	//

	// Legacy
	AfxGetApp()->WriteProfileString(_T("GPRS Options"),           _T("GWIP"), m_Page1.m_gwip);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("PORT"), m_Page1.m_gwport);
	AfxGetApp()->WriteProfileString(_T("GPRS Options"),           _T("KEY"), m_Page1.m_gwkey);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("GW Enable"), m_Page1.m_gwenable);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("KEEPALIVE"), m_Page2.m_gwkeepalive);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("GW Maxconn"), m_Page2.m_gwmaxconn);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("GW Maxsend"), m_Page2.m_gwmaxsend);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("GW Resptimeout"), m_Page2.m_gwresptimeout);
	AfxGetApp()->WriteProfileString(_T("GPRS Options"),           _T("CRYPTKEY"), strList);

	// Fallback
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\Fallback"), _T("GWIP"), m_Page4.m_gwip);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("PORT"), m_Page4.m_gwport);
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\Fallback"), _T("KEY"), m_Page4.m_gwkey);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Enable"), m_Page4.m_gwenable);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("KEEPALIVE"), m_Page4.m_gwkeepalive);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Maxconn"), m_Page4.m_gwmaxconn);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Maxsend"), m_Page4.m_gwmaxsend);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("GW Resptimeout"), m_Page4.m_gwresptimeout);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\Fallback"), _T("CRYPTKEY Enable"), m_Page4.m_cryptkeyenable);
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\Fallback"), _T("CRYPTKEY"), crypt2);

	// Standard
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options"),           _T("AutoStart"), m_Page3.m_autostart);
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\server1"),  _T("HOST"), m_Page3.m_gwip);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("PORT"), m_Page3.m_gwport);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("iface"), m_Page3.m_iface);
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\server1"),  _T("KEY"), m_Page3.m_gwkey);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("Enable"), m_Page3.m_gwenable);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("KEEPALIVE"), m_Page3.m_gwkeepalive);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("Maxconn"), m_Page3.m_gwmaxconn);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("Maxsend"), m_Page3.m_gwmaxsend);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("Resptimeout"), m_Page3.m_gwresptimeout);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("Secure"), m_Page3.m_secure);
	AfxGetApp()->WriteProfileInt(   _T("GPRS Options\\server1"),  _T("CRYPTKEY Enable"), m_Page3.m_cryptkeyenable);
	AfxGetApp()->WriteProfileString(_T("GPRS Options\\server1"),  _T("CRYPTKEY"), crypt1);

	// Default
	CPropertySheet::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// Buttons
/////////////////////////////////////////////////////////////////////////////

void CUnitGWSheet::OnRead() 
{
	// Disable controls
	UpdateControls(true);

	// Read legacy
	if (m_enable_gw)
	{
		// Var
		rmonGWSettings Config;
		unsigned char  enabled;

		// Read Gateway configuration
		int rc = rmonGetGatewaySettings(hCon, &Config);
		if (rc)
		{
			// Popup error message
			if (rmonNoData == rc) {
				m_text[0] = _T("No server settings present in device");
				m_text[1] = _T("No server settings present in device");
				m_error.SetWindowText(_T("No server settings present in device"));
				m_error.ShowWindow(SW_SHOW);
			} else {
				AfxMessageBox(_T("Error in communicating with RTCU unit"));
			}

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}

		// Hide error
		m_error.ShowWindow(SW_HIDE);

		// RTCU GPRS Gateway parameters:
		m_Page1.m_gwenable		= Config.gw_enabled;
		m_Page1.m_gwip			= Config.gw_ip;
		m_Page1.m_gwport		= Config.gw_port;
		m_Page1.m_gwkey			= Config.gw_key;

		// Advanced settings
		m_Page2.m_gwmaxconn		= Config.max_connection_attempt;
		m_Page2.m_gwmaxsend		= Config.max_send_req_attempt;
		m_Page2.m_gwresptimeout	= Config.response_timeout;
		m_Page2.m_gwkeepalive	= Config.alive_freq;
		memset(m_Page2.m_crypt_key, 0, sizeof(m_Page2.m_crypt_key));

		// Update
		if (m_Page1.m_gwspinport.GetSafeHwnd()) m_Page1.UpdateData(false);
		if (m_Page2.c_cryptkey.GetSafeHwnd())   m_Page2.UpdateView();
	}

	// Read setup
	if (m_enable_hub)
	{
		// Var
		rmonRCHConfig Setup;
		int           rc, autostart, valid = 0;

		// Read configuration
		rc = rmonRCHGetConfig(hCon, 1, &Setup);
		if (rc && rmonNoData != rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU unit"));

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}
		if (rmonRCHGetAutoConnect(hCon, &autostart)) autostart = 0;

		// Update info
		if (rmonNoData != rc)
		{
			valid |= 1;
			m_text[0]					= _T("");

			// Server connection setup
			m_Page3.m_autostart			= autostart;
			m_Page3.m_gwenable			= Setup.enabled;
			m_Page3.m_secure			= Setup.secure;
			m_Page3.m_gwip				= Setup.host;
			m_Page3.m_gwport			= Setup.port;
			m_Page3.m_iface				= Setup.iface;
			m_Page3.m_gwkey				= Setup.login_key;
			m_Page3.m_gwmaxconn			= Setup.max_connection_attempt;
			m_Page3.m_gwmaxsend			= Setup.max_send_req_attempt;
			m_Page3.m_gwresptimeout		= Setup.response_timeout;
			m_Page3.m_gwkeepalive		= Setup.alive_freq;
			m_Page3.m_cryptkeyenable	= Setup.crypt_enable;
			memset(m_Page3.m_crypt_key, 0, sizeof(m_Page3.m_crypt_key));
		}
		else
		{
			m_text[0] = _T("No server settings present in device");
		}

		// Read fallback configuration
		rc = rmonRCHGetConfig(hCon, 0, &Setup);
		if (rc && rmonNoData != rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU unit"));

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}

		// Update info
		if (rmonNoData != rc)
		{
			valid |= 2;
			m_text[1]					= _T("");

			// RTCU GPRS Gateway parameters:
			m_Page4.m_gwenable			= Setup.enabled;
			m_Page4.m_gwip				= Setup.host;
			m_Page4.m_gwport			= Setup.port;
			m_Page4.m_gwkey				= Setup.login_key;
			m_Page4.m_gwmaxconn			= Setup.max_connection_attempt;
			m_Page4.m_gwmaxsend			= Setup.max_send_req_attempt;
			m_Page4.m_gwresptimeout		= Setup.response_timeout;
			m_Page4.m_gwkeepalive		= Setup.alive_freq;
			m_Page4.m_cryptkeyenable	= Setup.crypt_enable;
			memset(m_Page4.m_crypt_key, 0, sizeof(m_Page4.m_crypt_key));
		}
		else
		{
			m_text[1] = _T("No fallback settings present in device");
		}

		// Update
		if (valid & 1) m_Page3.UpdateView();
		if (valid & 2) m_Page4.UpdateView();

		// Popup error
		if ((valid & 3) != 3) {
			m_error.SetWindowText(m_text[GetActiveIndex()]);
			m_error.ShowWindow(SW_SHOW);
		} else {
			m_error.ShowWindow(SW_HIDE);
		}
	}

	// Enable controls
	UpdateControls(false);
}

BOOL CUnitGWSheet::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	// Header
	NMHDR* pnmh = (NMHDR*)lParam;

	// Default
	BOOL bResult = CPropertySheet::OnNotify(wParam, lParam, pResult);

	// Is tab changed?
	if (TCN_SELCHANGE == pnmh->code && m_enable_hub)
	{
		// Update
		m_error.SetWindowText(m_text[GetActiveIndex()]);
	}

	// Completed
	return bResult;
}

void CUnitGWSheet::OnWrite() 
{
	// Write legacy
	if (m_enable_gw)
	{
		// Var
		rmonGWSettings Settings;
		int            rc = 0;

		// Update data
		if (m_Page1.m_gwspinport.GetSafeHwnd()) rc += !m_Page1.UpdateData(true);
		if (m_Page2.c_cryptkey.GetSafeHwnd())   rc += !m_Page2.UpdateData(true);
		if (m_Page2.c_cryptkey.GetSafeHwnd())   m_Page2.c_cryptkey.GetData(m_Page2.m_crypt_key, 16);
		if (rc) return;

		// Set data
		strcpy_s((char*)Settings.gw_ip,  sizeof(Settings.gw_ip),  (LPCTSTR)m_Page1.m_gwip);
		strcpy_s((char*)Settings.gw_key, sizeof(Settings.gw_key), (LPCTSTR)m_Page1.m_gwkey);
		memcpy(Settings.crypt_key, m_Page2.m_crypt_key, 16);
		Settings.gw_enabled				= (m_Page1.m_gwenable ? 1 : 0);
		Settings.gw_port				= (unsigned short)m_Page1.m_gwport;
		Settings.max_connection_attempt	= (unsigned short)m_Page2.m_gwmaxconn;
		Settings.max_send_req_attempt	= (unsigned short)m_Page2.m_gwmaxsend;
		Settings.response_timeout		= (unsigned short)m_Page2.m_gwresptimeout;
		Settings.alive_freq				= (unsigned short)m_Page2.m_gwkeepalive;

		// Set controls
		UpdateControls(true);

		// Write gateway settings
		rc = rmonSetGatewaySettings(hCon, Settings);

		// Set controls
		UpdateControls(false);

		// Message
		if (rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU device"));

			// Completed
			return;
		}
	}

	// Write setup
	if (m_enable_hub)
	{
		// Var
		rmonRCHConfig  Setup;
		int            rc = 0;

		// Get parameters
		if (m_Page3.m_gwspinport.GetSafeHwnd()) rc += !m_Page3.UpdateData(true);
		if (m_Page3.c_cryptkey.GetSafeHwnd())   m_Page3.c_cryptkey.GetData(m_Page3.m_crypt_key, 16);
		if (m_Page4.m_gwspinport.GetSafeHwnd()) rc += !m_Page4.UpdateData(true);
		if (m_Page4.c_cryptkey.GetSafeHwnd())   m_Page4.c_cryptkey.GetData(m_Page4.m_crypt_key, 16);
		if (rc) return;

		// Validate encryption
		if (m_Page3.m_cryptkeyenable)
		{
			bool set = false;
			for (int i = 0; i < 16; i++) if (m_Page3.m_crypt_key[i]) set = true;
			if (!set) { MessageBox(_T("Invalid encryption key!\nThe encryption key must be different from zero."), _T("Apply"), MB_OK | MB_ICONERROR); return; }
		}
		if (m_Page4.m_cryptkeyenable)
		{
			bool set = false;
			for (int i = 0; i < 16; i++) if (m_Page4.m_crypt_key[i]) set = true;
			if (!set) { MessageBox(_T("Invalid encryption key!\nThe encryption key must be different from zero."), _T("Apply"), MB_OK | MB_ICONERROR); return; }
		}

		// Disable controls
		UpdateControls(true);

		// Build config
		Setup.size						= sizeof(Setup);
		Setup.enabled					= m_Page3.m_gwenable;
		Setup.secure					= m_Page3.m_secure;
		Setup.iface						= m_Page3.m_iface;
		Setup.port						= m_Page3.m_gwport;
		Setup.max_connection_attempt	= m_Page3.m_gwmaxconn;
		Setup.max_send_req_attempt		= m_Page3.m_gwmaxsend;
		Setup.response_timeout			= m_Page3.m_gwresptimeout;
		Setup.alive_freq				= m_Page3.m_gwkeepalive;
		Setup.crypt_enable				= m_Page3.m_cryptkeyenable;
		strcpy_s(Setup.host, 51, m_Page3.m_gwip);
		strcpy_s(Setup.login_key, 10, m_Page3.m_gwkey);
		if (m_Page3.m_cryptkeyenable)
		{
			memcpy(Setup.crypt_key, m_Page3.m_crypt_key, sizeof(m_Page3.m_crypt_key));
		}
		else
		{
			memset(Setup.crypt_key, 0, sizeof(m_Page3.m_crypt_key));
		}

		// Write config
		rc = rmonRCHSetConfig(hCon, 1, &Setup);
		if (rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU device"));

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}
		rc = rmonRCHSetAutoConnect(hCon, m_Page3.m_autostart);
		if (rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU device"));

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}

		// Build fallback
		Setup.size						= sizeof(Setup);
		Setup.enabled					= m_Page4.m_gwenable;
		Setup.port						= m_Page4.m_gwport;
		Setup.max_connection_attempt	= m_Page4.m_gwmaxconn;
		Setup.max_send_req_attempt		= m_Page4.m_gwmaxsend;
		Setup.response_timeout			= m_Page4.m_gwresptimeout;
		Setup.alive_freq				= m_Page4.m_gwkeepalive;
		Setup.crypt_enable				= m_Page4.m_cryptkeyenable;
		strcpy_s(Setup.host, 51, m_Page4.m_gwip);
		strcpy_s(Setup.login_key, 10, m_Page4.m_gwkey);
		if (m_Page4.m_cryptkeyenable)
		{
			memcpy(Setup.crypt_key, m_Page4.m_crypt_key, sizeof(m_Page4.m_crypt_key));
		}
		else
		{
			memset(Setup.crypt_key, 0, sizeof(m_Page4.m_crypt_key));
		}

		// Write fallback
		rc = rmonRCHSetConfig(hCon, 0, &Setup);
		if (rc)
		{
			// Popup error message
			AfxMessageBox(_T("Error in communicating with RTCU device"));

			// Enable controls
			UpdateControls(false);

			// Completed
			return;
		}

		// Enable controls
		UpdateControls(false);
	}

	// Clear warnings
	m_text[0] = _T("");
	m_text[1] = _T("");
	m_error.ShowWindow(SW_HIDE);

	// Completed
	AfxMessageBox(_T("Please remember to reset the device for the changes to take effect!"));
}

void CUnitGWSheet::OnSetdefault() 
{
	// Verify with user
	if (AfxMessageBox(_T("Are you sure you want to set default values?"), MB_ICONWARNING | MB_YESNO | MB_DEFBUTTON2) == IDYES)
	{
		// Legacy
		m_Page1.m_gwip				= _T("");
		m_Page1.m_gwport			= 5000;
		m_Page1.m_gwkey				= _T("AABBCCDD");
		m_Page1.m_gwenable			= 0;
		m_Page2.m_gwkeepalive		= 300;
		m_Page2.m_gwmaxconn			= 3;
		m_Page2.m_gwmaxsend			= 5;
		m_Page2.m_gwresptimeout		= 45;
		memset(m_Page2.m_crypt_key, 0, sizeof(m_Page2.m_crypt_key));

		// Fallback
		m_Page4.m_gwip				= _T("");
		m_Page4.m_gwport			= 5000;
		m_Page4.m_gwkey				= _T("AABBCCDD");
		m_Page4.m_gwenable			= 0;
		m_Page4.m_gwkeepalive		= 300;
		m_Page4.m_gwmaxconn			= 3;
		m_Page4.m_gwmaxsend			= 5;
		m_Page4.m_gwresptimeout		= 45;
		m_Page4.m_cryptkeyenable	= 0;
		memset(m_Page4.m_crypt_key, 0, sizeof(m_Page4.m_crypt_key));

		// Server
		m_Page3.m_gwip				= _T("");
		m_Page3.m_gwport			= 5000;
		m_Page3.m_iface				= 1;
		m_Page3.m_gwkey				= _T("AABBCCDD");
		m_Page3.m_gwenable			= 0;
		m_Page3.m_gwkeepalive		= 300;
		m_Page3.m_gwmaxconn			= 3;
		m_Page3.m_gwmaxsend			= 5;
		m_Page3.m_gwresptimeout		= 45;
		m_Page3.m_secure			= TRUE;
		m_Page3.m_cryptkeyenable	= 0;
		memset(m_Page3.m_crypt_key, 0, sizeof(m_Page3.m_crypt_key));

		// Update
		if (m_Page1.m_gwspinport.GetSafeHwnd()) m_Page1.UpdateData(false);
		if (m_Page2.c_cryptkey.GetSafeHwnd())   m_Page2.UpdateView();
		if (m_Page3.c_cryptkey.GetSafeHwnd())   m_Page3.UpdateView();
		if (m_Page4.c_cryptkey.GetSafeHwnd())   m_Page4.UpdateView();
	}
}

/////////////////////////////////////////////////////////////////////////////
// Utility
/////////////////////////////////////////////////////////////////////////////

char CUnitGWSheet::hatoi(const CString& ha) const
{
	// Var
	char res = 0, i;

	// Iterate nibles
	for (i = 0; i < 2; i++) {
		// Move last nible
		res <<= 4;
		// Set nible
		if (ha.GetAt(i) >= '0' && ha.GetAt(i) <= '9')      res += (ha.GetAt(i) - '0');
		else if (ha.GetAt(i) >= 'a' && ha.GetAt(i) <= 'f') res += (ha.GetAt(i) - 'a' + 10);
		else if (ha.GetAt(i) >= 'A' && ha.GetAt(i) <= 'F') res += (ha.GetAt(i) - 'A' + 10);
	}

	// Completed
	return res;
}

void CUnitGWSheet::UpdateControls(const bool working)
{
	// Update view
	m_ctrwrite.EnableWindow(!working && gUnitInfo.Connected);
	m_ctrfetch.EnableWindow(!working && gUnitInfo.Connected);
	GetDlgItem(IDCANCEL)->EnableWindow(!working);
}

HBRUSH CUnitGWSheet::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	// Default
	HBRUSH hbr = CPropertySheet::OnCtlColor(pDC, pWnd, nCtlColor);

	// Change colour
	if (nCtlColor == CTLCOLOR_STATIC && pWnd == &m_error)
	{
		pDC->SetTextColor(RGB(255, 0, 0));
	}

	// Completed
	return hbr;
}
