// UnitNetPageAP.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "UnitNetPageAP.h"

extern "C" {
#include "rijndael128.h"
}


// CUnitNetPageAP

IMPLEMENT_DYNAMIC(CUnitNetPageAP, CPropertyPage)

CUnitNetPageAP::CUnitNetPageAP()
	: CPropertyPage(CUnitNetPageAP::IDD)
    , m_nat_forward(FALSE)
    , m_dhcp_enable(FALSE)
    , m_dhcp_time(0)
    , m_dhcp_first(0)
    , m_dhcp_last(0)
    , m_dhcp_dns_type(FALSE)
    , m_dhcp_dns1(0)
    , m_dhcp_dns2(0)
{
}

CUnitNetPageAP::~CUnitNetPageAP()
{
}

void CUnitNetPageAP::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SECURITY, c_security);
    DDX_Control(pDX, IDC_SUBNET, c_subnet);
    DDX_Control(pDX, IDC_IP, c_address);
    DDX_Control(pDX, IDC_HIDE, c_broadcast);
    DDX_Control(pDX, IDC_CHANNEL_SPIN, c_spin_channel);
    DDX_Check(pDX, IDC_CHECK_NAT_FORWARD, m_nat_forward);
    DDX_Check(pDX, IDC_CHECK_DHCP_ENABLE, m_dhcp_enable);
    DDX_Text(pDX, IDC_EDIT_DHCP_TIME, m_dhcp_time);
    DDX_IPAddress(pDX, IDC_IPADDR_DHCP_FIRST, m_dhcp_first);
    DDX_IPAddress(pDX, IDC_IPADDR_DHCP_LAST, m_dhcp_last);
    DDX_Check(pDX, IDC_CHECK_DHCP_DNS_TYPE, m_dhcp_dns_type);
    DDX_IPAddress(pDX, IDC_IPADDR_DHCP_DNS1, m_dhcp_dns1);
    DDX_IPAddress(pDX, IDC_IPADDR_DHCP_DNS2, m_dhcp_dns2);
    DDX_Control(pDX, IDC_LABEL_NAT_FORWARD, c_label_nat_forward);
    DDX_Control(pDX, IDC_LABEL_DHCP_ENABLE, c_label_dhcp_enable);
    DDX_Control(pDX, IDC_LABEL_DHCP_TIME, c_label_dhcp_time);
    DDX_Control(pDX, IDC_LABEL_DHCP_RANGE_START, c_label_dhcp_first);
    DDX_Control(pDX, IDC_LABEL_DHCP_RANGE_END, c_label_dhcp_last);
    DDX_Control(pDX, IDC_LABEL_DHCP_DNS, c_label_dhcp_dns_type);
    DDX_Control(pDX, IDC_LABEL_DHCP_DNS1, c_label_dhcp_dns1);
    DDX_Control(pDX, IDC_LABEL_DHCP_DNS2, c_label_dhcp_dns2);
    DDX_Control(pDX, IDC_CHECK_NAT_FORWARD, c_check_nat_forward);
    DDX_Control(pDX, IDC_CHECK_DHCP_ENABLE, c_check_dhcp_enable);
    DDX_Control(pDX, IDC_EDIT_DHCP_TIME, c_edit_dhcp_time);
    DDX_Control(pDX, IDC_SPIN_DHCP_TIME, c_spin_dhcp_time);
    DDX_Control(pDX, IDC_IPADDR_DHCP_FIRST, c_ipaddr_dhcp_first);
    DDX_Control(pDX, IDC_IPADDR_DHCP_LAST, c_ipaddr_dhcp_last);
    DDX_Control(pDX, IDC_CHECK_DHCP_DNS_TYPE, c_check_dhcp_dns_type);
    DDX_Control(pDX, IDC_IPADDR_DHCP_DNS1, c_ipaddr_dhcp_dns1);
    DDX_Control(pDX, IDC_IPADDR_DHCP_DNS2, c_ipaddr_dhcp_dns2);
    DDX_Control(pDX, IDC_COUNTRY, c_country);
}

BEGIN_MESSAGE_MAP(CUnitNetPageAP, CPropertyPage)
    ON_CBN_SELENDOK(IDC_SECURITY,          &CUnitNetPageAP::OnSelectSecurity)
    ON_BN_CLICKED(IDC_CHECK_DHCP_ENABLE,   &CUnitNetPageAP::OnClickedDHCPEnable)
    ON_BN_CLICKED(IDC_CHECK_DHCP_DNS_TYPE, &CUnitNetPageAP::OnClickedDHCPType)
END_MESSAGE_MAP()

// CUnitNetPageAP message handlers

BOOL CUnitNetPageAP::OnInitDialog()
{
	// Default
	CPropertyPage::OnInitDialog();

    // Initialize controls
    ((CEdit*)GetDlgItem(IDC_SSID))->LimitText(32);
    ((CEdit*)GetDlgItem(IDC_PASSPHRASE))->LimitText(62);
    ((CEdit*)GetDlgItem(IDC_CHANNEL))->LimitText(3);
    c_spin_channel.SetRange32(0, 127);
    c_spin_dhcp_time.SetRange32(1, 24);

    // Fill controls
    c_security.AddString(_T("None"));
    c_security.AddString(_T("WPA/WPA2 - PSK"));

    // Update
    ShowType(m_security);
    UpdateView();

	// Completed
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Function
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageAP::SetDefault(void)
{
    // Set default
    m_ssid          = _T("");
    m_hide          = 0;
    m_country       = GetCountryCode();
    m_channel       = 1;
    m_security      = 0;
    m_phrase        = _T("");
    m_address       = 0;
    m_subnet        = 0;
    m_nat_forward   = 0;
    m_dhcp_enable   = 0;
    m_dhcp_time     = 12;
    m_dhcp_first    = 0;
    m_dhcp_last     = 0;
    m_dhcp_dns_type = 0;
    m_dhcp_dns1     = 0;
    m_dhcp_dns2     = 0;

    // Validate
    if (!c_address.GetSafeHwnd()) return;

    // Update
    ShowType(m_security);
    UpdateData(FALSE);
    UpdateView();
}

BOOL CUnitNetPageAP::ValidateSetup(void)
{
    // Var
    CString title, message;

    // Update
    if (c_address.GetSafeHwnd())
    {
        GetDlgItem(IDC_SSID)->GetWindowText(m_ssid);
        m_hide = c_broadcast.GetCheck() ? 0 : 1;
        m_channel = c_spin_channel.GetPos32();
        m_security = c_security.GetCurSel();
        GetDlgItem(IDC_PASSPHRASE)->GetWindowText(m_phrase);
        c_address.GetAddress(m_address);
        c_subnet.GetAddress(m_subnet);
        c_country.GetLBText(c_country.GetCurSel(), m_country);
        UpdateData(TRUE);
    }

    // Build title
    title = _T("Apply AP configuration");

    // Validate security
    if (m_security)
    {
        if (m_phrase.GetLength() < 8 || m_phrase.GetLength() > 63) {
            // Build message
            message = _T("The passphrase must be between 8 and 63 characters.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
    }

    // Validate DHCP
    if (m_dhcp_enable)
    {
        if (m_dhcp_time < 1 || m_dhcp_time > 24) {
            // Build message
            message = _T("The DHCP Lease time must be between 1 and 24.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_first & m_subnet) != (m_address & m_subnet)) {
            // Build message
            message = _T("The DHCP range start is not the same network as the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_last & m_subnet) != (m_address & m_subnet)) {
            // Build message
            message = _T("The DHCP range end is not the same network as the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_last < m_dhcp_first) {
            // Build message
            message = _T("The order of the DHCP range (start and end) is wrong.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_last - m_dhcp_first) + 1 < 10) {
            // Build message
            message = _T("The DHCP range is too short.\nIt must be large enough for at least 10 addresses.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_first <= m_address) {
            // Build message
            message = _T("The DHCP range includes the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_dns_type && !m_dhcp_dns1 && !m_dhcp_dns2) {
            // Build message
            message = _T("Static DNS is enabled in the DHCP server,\nbut no adresses are given.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
    }

    // Completed
    return TRUE;
}

int CUnitNetPageAP::ReadSetup(void)
{
    // Var
    int rc;

    // Read objects
    rc = rmonObjectRead(
                        hCon,
                        RMONOBJ_TABLE_SYSTEM,
                        "network.ap.*",
                        object_input,
                        this
                       );
    if (rc) return (rc == rmonNoData) ? 1 : 2;

    // Check controls
    if (!c_address.GetSafeHwnd()) return 0;

    // Update
    ShowType(m_security);
    UpdateData(FALSE);
    UpdateView();

    // Completed
    return 0;
}

int CUnitNetPageAP::WriteSetup(void)
{
    // Var
    struct rmonObjectInfo   info[15];
    unsigned char           security[120];
    unsigned long           addr, subnet;
    int                     rc, len = 0, dns_type;
    DWORD                   first, last, dns1, dns2;

    // Update
    if (c_address.GetSafeHwnd())
    {
        GetDlgItem(IDC_SSID)->GetWindowText(m_ssid);
        m_hide = c_broadcast.GetCheck() ? 0 : 1;
        m_channel = c_spin_channel.GetPos32();
        m_security = c_security.GetCurSel();
        GetDlgItem(IDC_PASSPHRASE)->GetWindowText(m_phrase);
        c_address.GetAddress(m_address);
        c_subnet.GetAddress(m_subnet);
        c_country.GetLBText(c_country.GetCurSel(), m_country);
    }

    // Get
    addr = htonl(m_address);
    subnet = htonl(m_subnet);
    if (m_security)
    {
        // Build
        security[0] = m_security;
        strcpy_s((char*)&security[1], 99, (const char*)m_phrase);

        // Encrypt
        object_crypto(1, 100, security, len);
    }
    dns_type = m_dhcp_dns_type + 1;
    first = htonl(m_dhcp_first);
    last = htonl(m_dhcp_last);
    dns1 = htonl(m_dhcp_dns1);
    dns2 = htonl(m_dhcp_dns2);

    // Build
    memset(info, 0, sizeof(info));
    strcpy_s(info[0].name, 200, "network.ap.ssid");
    info[0].type = RMONOBJ_TYPE_STRING;
    info[0].size = m_ssid.GetLength() + 1;
    info[0].data = (unsigned char*)(LPCSTR)m_ssid;
    strcpy_s(info[1].name, 200, "network.ap.hide");
    info[1].type = RMONOBJ_TYPE_BOOL;
    info[1].size = 4;
    info[1].data = (unsigned char*)&m_hide;
    strcpy_s(info[2].name, 200, "network.ap.country");
    info[2].type = RMONOBJ_TYPE_STRING;
    info[2].size = m_country.GetLength() + 1;
    info[2].data = (unsigned char*)(LPCSTR)m_country;
    strcpy_s(info[3].name, 200, "network.ap.channel");
    info[3].type = RMONOBJ_TYPE_INT;
    info[3].size = 4;
    info[3].data = (unsigned char*)&m_channel;
    strcpy_s(info[4].name, 200, "network.ap.security");
    info[4].type = RMONOBJ_TYPE_DATA;
    info[4].size = len;
    info[4].data = !len ? NULL : security;
    strcpy_s(info[5].name, 200, "network.ap.addr");
    info[5].type = RMONOBJ_TYPE_DATA;
    info[5].size = 4;
    info[5].data = (unsigned char*)&addr;
    strcpy_s(info[6].name, 200, "network.ap.subnet");
    info[6].type = RMONOBJ_TYPE_DATA;
    info[6].size = 4;
    info[6].data = (unsigned char*)&subnet;

    // Build NAT configuration
    strcpy_s(info[7].name, 200, "network.ap.nat.forward");
    info[7].type = RMONOBJ_TYPE_BOOL;
    info[7].size = 4;
    info[7].data = (unsigned char*)&m_nat_forward;

    // Build DHCP configuration
    strcpy_s(info[8].name, 200, "network.ap.dhcp.enable");
    info[8].type = RMONOBJ_TYPE_BOOL;
    info[8].size = 4;
    info[8].data = (unsigned char*)&m_dhcp_enable;
    strcpy_s(info[9].name, 200, "network.ap.dhcp.leasetime");
    info[9].type = RMONOBJ_TYPE_INT;
    info[9].size = 4;
    info[9].data = (unsigned char*)&m_dhcp_time;
    strcpy_s(info[10].name, 200, "network.ap.dhcp.type");
    info[10].type = RMONOBJ_TYPE_INT;
    info[10].size = 4;
    info[10].data = (unsigned char*)&dns_type;
    strcpy_s(info[11].name, 200, "network.ap.dhcp.first");
    info[11].type = RMONOBJ_TYPE_DATA;
    info[11].size = 4;
    info[11].data = (unsigned char*)&first;
    strcpy_s(info[12].name, 200, "network.ap.dhcp.last");
    info[12].type = RMONOBJ_TYPE_DATA;
    info[12].size = 4;
    info[12].data = (unsigned char*)&last;
    strcpy_s(info[13].name, 200, "network.ap.dhcp.dns1");
    info[13].type = RMONOBJ_TYPE_DATA;
    info[13].size = 4;
    info[13].data = (unsigned char*)&dns1;
    strcpy_s(info[14].name, 200, "network.ap.dhcp.dns2");
    info[14].type = RMONOBJ_TYPE_DATA;
    info[14].size = 4;
    info[14].data = (unsigned char*)&dns2;

    // Write
    rc = rmonObjectWrite(hCon, RMONOBJ_TABLE_SYSTEM, 2, 15, info, nullptr);
    if (rc) return 1;

    // Completed
    return 0;
}

void CUnitNetPageAP::Load(void)
{
    // Interface
    m_ssid          = AfxGetApp()->GetProfileString(_T("NetworkOptions\\AP"),       _T("SSID"),       _T(""));
    m_hide          = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP"),       _T("HIDE"),       0);
    m_country       = AfxGetApp()->GetProfileString(_T("NetworkOptions\\AP"),       _T("COUNTRY"),    GetCountryCode());
    m_channel       = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP"),       _T("CHANNEL"),    1);
    m_security      = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP"),       _T("SECURITY"),   0);
    m_phrase        = AfxGetApp()->GetProfileString(_T("NetworkOptions\\AP"),       _T("PASSPHRASE"), _T(""));
    m_address       = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP"),       _T("ADDRESS"),    0);
    m_subnet        = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP"),       _T("SUBNET"),     0);

    // NAT
    m_nat_forward   = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\NAT"),  _T("FORWARD"),    0);

    // DHCP
    m_dhcp_enable   = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("enable"),     0);
    m_dhcp_time     = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("time"),       12);
    m_dhcp_first    = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("first"),      0);
    m_dhcp_last     = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("last"),       0);
    m_dhcp_dns_type = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("type"),       0);
    m_dhcp_dns1     = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("DNS1"),       0);
    m_dhcp_dns2     = AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("DNS2"),       0);
}

void CUnitNetPageAP::Save(void)
{
    // Update
    if (c_address.GetSafeHwnd())
    {
        GetDlgItem(IDC_SSID)->GetWindowText(m_ssid);
        m_hide      = c_broadcast.GetCheck() ? 0 : 1;
        m_channel   = c_spin_channel.GetPos32();
        m_security  = c_security.GetCurSel();
        GetDlgItem(IDC_PASSPHRASE)->GetWindowText(m_phrase);
        c_address.GetAddress(m_address);
        c_subnet.GetAddress(m_subnet);
        c_country.GetLBText(c_country.GetCurSel(), m_country);
    }

    // Interface
    AfxGetApp()->WriteProfileString(_T("NetworkOptions\\AP"),       _T("SSID"),       m_ssid);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP"),       _T("HIDE"),       m_hide);
    AfxGetApp()->WriteProfileString(_T("NetworkOptions\\AP"),       _T("COUNTRY"),    m_country);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP"),       _T("CHANNEL"),    m_channel);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP"),       _T("SECURITY"),   m_security);
    AfxGetApp()->WriteProfileString(_T("NetworkOptions\\AP"),       _T("PASSPHRASE"), m_phrase);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP"),       _T("ADDRESS"),    m_address);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP"),       _T("SUBNET"),     m_subnet);

    // NAT
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\NAT"),  _T("FORWARD"),    m_nat_forward);

    // DHCP
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("enable"),     m_dhcp_enable);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("time"),       m_dhcp_time);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("first"),      m_dhcp_first);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("last"),       m_dhcp_last);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("type"),       m_dhcp_dns_type);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("DNS1"),       m_dhcp_dns1);
    AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\AP\\DHCP"), _T("DNS2"),       m_dhcp_dns2);
}


/////////////////////////////////////////////////////////////////////////////
// Security
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageAP::OnSelectSecurity()
{
    ShowType(c_security.GetCurSel());
}


/////////////////////////////////////////////////////////////////////////////
// DHCP
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageAP::OnClickedDHCPEnable()
{
    // Update
    GetDlgItem(IDC_SSID)->GetWindowText(m_ssid);
    m_hide = c_broadcast.GetCheck() ? 0 : 1;
    m_channel = c_spin_channel.GetPos32();
    m_security = c_security.GetCurSel();
    GetDlgItem(IDC_PASSPHRASE)->GetWindowText(m_phrase);
    c_address.GetAddress(m_address);
    c_subnet.GetAddress(m_subnet);
    c_country.GetLBText(c_country.GetCurSel(), m_country);
    UpdateData(TRUE);
    UpdateView();
}

void CUnitNetPageAP::OnClickedDHCPType()
{
    UpdateData(TRUE);
    UpdateView();
}


/////////////////////////////////////////////////////////////////////////////
// Utility
/////////////////////////////////////////////////////////////////////////////

CString CUnitNetPageAP::GetCountryCode(void)
{
    // Var
    CString loc(_T("DK"));
    GEOID   myGEO;
    TCHAR*  buffer;
    int     rc, size;

    // Get location
    myGEO   = GetUserGeoID(GEOCLASS_NATION);
    size    = GetGeoInfo(myGEO, GEO_ISO2, nullptr, 0, 0);
    buffer  = new TCHAR[size];
    rc      = GetGeoInfo(myGEO, GEO_ISO2, buffer, size, 0);
    if (rc == size) loc = buffer;

    // Clean up
    delete[] buffer;

    // Completed
    return loc;
}

void CUnitNetPageAP::ShowType(int type)
{
    // Var
    int show_text_phrase, show_edit_phrase;

    // Validate
    if (!c_address.GetSafeHwnd()) return;

    //
    // Show WPA/WPA2 - PSK
    //
    if (type == 1)
    {
        show_text_phrase = SW_SHOW;
        show_edit_phrase = SW_SHOW;
    }
    else
    {
        show_text_phrase = SW_HIDE;
        show_edit_phrase = SW_HIDE;
    }

    // Show/Hide controls
    GetDlgItem(IDC_TEXT_PASSPHRASE)->ShowWindow(show_text_phrase);
    GetDlgItem(IDC_PASSPHRASE)->ShowWindow(show_edit_phrase);
}

void CUnitNetPageAP::UpdateView(void)
{
    // Var
    BOOL nat_allow;
    BOOL dhcp_allow, dhcp_enable, dhcp_dns_enable;

    // Validate
    if (!c_address.GetSafeHwnd()) return;

    // Check NAT
    nat_allow = TRUE;

    // Check DHCP
    dhcp_allow = TRUE;
    dhcp_enable = dhcp_allow && c_check_dhcp_enable.GetCheck();
    dhcp_dns_enable = dhcp_enable && c_check_dhcp_dns_type.GetCheck();

    // Update
    GetDlgItem(IDC_SSID)->SetWindowText(m_ssid);
    GetDlgItem(IDC_PASSPHRASE)->SetWindowText(m_phrase);
    c_country.SelectString(-1, m_country);
    c_spin_channel.SetPos32(m_channel);
    c_broadcast.SetCheck(m_hide ? 0 : 1);
    c_security.SetCurSel(m_security);
    c_address.SetAddress(m_address);
    c_subnet.SetAddress(m_subnet);

    // Update NAT
    c_label_nat_forward.EnableWindow(nat_allow);
    c_check_nat_forward.EnableWindow(nat_allow);

    // Update DHCP
    c_label_dhcp_enable.EnableWindow(dhcp_allow);
    c_label_dhcp_time.EnableWindow(dhcp_enable);
    c_label_dhcp_first.EnableWindow(dhcp_enable);
    c_label_dhcp_last.EnableWindow(dhcp_enable);
    c_label_dhcp_dns_type.EnableWindow(dhcp_enable);
    c_label_dhcp_dns1.EnableWindow(dhcp_dns_enable);
    c_label_dhcp_dns2.EnableWindow(dhcp_dns_enable);
    c_check_dhcp_enable.EnableWindow(dhcp_allow);
    c_edit_dhcp_time.EnableWindow(dhcp_enable);
    c_spin_dhcp_time.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_first.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_last.EnableWindow(dhcp_enable);
    c_check_dhcp_dns_type.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_dns1.EnableWindow(dhcp_dns_enable);
    c_ipaddr_dhcp_dns2.EnableWindow(dhcp_dns_enable);
}

int CUnitNetPageAP::object_input(
                                 void*          uptr,
                                 const char*    name,
                                 int            type,
                                 int            size,
                                 unsigned char* data,
                                 unsigned long  flags,
                                 int            min_val,
                                 int            max_val,
                                 const char*    description
                                )
{
    // Var
    CUnitNetPageAP* dlg = static_cast<CUnitNetPageAP*>(uptr);
    CString         obj_name;

    // Parse name
    obj_name = CString(name).Mid(11);

    // SSID
    if (!obj_name.CompareNoCase(_T("ssid")))
    {
        dlg->m_ssid = (char*)data;
    }
    // Hide SSID
    else if (!obj_name.CompareNoCase(_T("hide")))
    {
        memcpy(&dlg->m_hide, data, 4);
    }
    // Country
    else if (!obj_name.CompareNoCase(_T("country")))
    {
        dlg->m_country = (char*)data;
    }
    // Channel
    else if (!obj_name.CompareNoCase(_T("channel")))
    {
        memcpy(&dlg->m_channel, data, 4);
    }
    // Security
    else if (!obj_name.CompareNoCase(_T("security")))
    {
        if (size)
        {
            // Var
            int len;

            // De-crypt
            dlg->object_crypto(0, size, data, len);

            // Parse
            dlg->m_security = data[0];
            if (dlg->m_security == 1)
                dlg->m_phrase = &data[1];
        }
        else
        {
            dlg->m_security = 0;
            dlg->m_phrase = _T("");
        }
    }
    // IP address
    else if (!obj_name.CompareNoCase(_T("addr")))
    {
        // Var
        unsigned long value;

        // Get value
        memcpy(&value, data, 4);
        dlg->m_address = ntohl(value);
    }
    // Subnet mask
    else if (!obj_name.CompareNoCase(_T("subnet")))
    {
        // Var
        unsigned long value;

        // Get value
        memcpy(&value, data, 4);
        dlg->m_subnet = ntohl(value);
    }
    // Nat
    else if (!obj_name.CompareNoCase(_T("nat.forward")))     dlg->m_nat_forward   = (BOOL) * ((int*)data);
    // DHCP
    else if (!obj_name.CompareNoCase(_T("dhcp.enable")))     dlg->m_dhcp_enable   = (BOOL) * ((int*)data);
    else if (!obj_name.CompareNoCase(_T("dhcp.leasetime")))  dlg->m_dhcp_time     = (int)*((int*)data);
    else if (!obj_name.CompareNoCase(_T("dhcp.type")))       dlg->m_dhcp_dns_type = ((int)*((int*)data)) - 1;
    else if (!obj_name.CompareNoCase(_T("dhcp.first")))      dlg->m_dhcp_first    = (DWORD)ntohl(*((int*)data));
    else if (!obj_name.CompareNoCase(_T("dhcp.last")))       dlg->m_dhcp_last     = (DWORD)ntohl(*((int*)data));
    else if (!obj_name.CompareNoCase(_T("dhcp.dns1")))       dlg->m_dhcp_dns1     = (DWORD)ntohl(*((int*)data));
    else if (!obj_name.CompareNoCase(_T("dhcp.dns2")))       dlg->m_dhcp_dns2     = (DWORD)ntohl(*((int*)data));

    // Completed
    return 1;
}

void CUnitNetPageAP::object_crypto(
                                   const int      encrypt,
                                   const int      size_in,
                                   unsigned char* data_in,
                                   int&           size_out
                                  )
{
    // Var
    const unsigned char SOS_CRYPT_KEY[16] = { 0xF1, 0x8A, 0x0E, 0x88, 0xC3, 0x0C, 0x11, 0xD0,
                                              0x88, 0x15, 0x00, 0xA0, 0xC9, 0x06, 0xBE, 0xD8 };
    unsigned char* data_out;
    int                 blocks, size;

    // Calculate
    blocks = size_in / 16;
    if (size_in % 16) blocks++;
    size = blocks * 16;

    // Allocate
    data_out = new unsigned char[size];

    // Encrypt
    if (encrypt)
    {
        rijndaelEncryptBuffer128(SOS_CRYPT_KEY, data_in, data_out, blocks);
    }
    // Decrypt
    else
    {
        rijndaelDecryptBuffer128(SOS_CRYPT_KEY, data_in, data_out, blocks);
    }

    // Set output
    memcpy(data_in, data_out, size);
    size_out = size;

    // Clean up
    delete[] data_out;
}
