#pragma once


// CUnitNetPageAP

class CUnitNetPageAP : public CPropertyPage
{
	DECLARE_DYNAMIC(CUnitNetPageAP)

public:
	CUnitNetPageAP();
	~CUnitNetPageAP();

	enum { IDD = IDD_UNIT_NET_PAGE_AP };

	void         SetDefault(void);
	BOOL         ValidateSetup(void);
	int          ReadSetup(void);
	int          WriteSetup(void);
	void         Load(void);
	void         Save(void);

protected:
	// Dialog Data
	CString           m_ssid;
	int               m_hide;
	int               m_channel;
	int               m_security;
	CString           m_phrase;
	unsigned long     m_address;
	unsigned long     m_subnet;
	BOOL              m_nat_forward;
	BOOL              m_dhcp_enable;
	int               m_dhcp_time;
	DWORD             m_dhcp_first;
	DWORD             m_dhcp_last;
	BOOL              m_dhcp_dns_type;
	DWORD             m_dhcp_dns1;
	DWORD             m_dhcp_dns2;
	CString           m_country;

	// Controls
	CComboBox         c_security;
	CIPAddressCtrl    c_address;
	CIPAddressCtrl    c_subnet;
	CSpinButtonCtrl   c_spin_channel;
	CButton           c_broadcast;
	CStatic           c_label_nat_forward;
	CStatic           c_label_dhcp_enable;
	CStatic           c_label_dhcp_time;
	CStatic           c_label_dhcp_first;
	CStatic           c_label_dhcp_last;
	CStatic           c_label_dhcp_dns_type;
	CStatic           c_label_dhcp_dns1;
	CStatic           c_label_dhcp_dns2;
	CButton           c_check_nat_forward;
	CButton           c_check_dhcp_enable;
	CEdit             c_edit_dhcp_time;
	CSpinButtonCtrl   c_spin_dhcp_time;
	CIPAddressCtrl    c_ipaddr_dhcp_first;
	CIPAddressCtrl    c_ipaddr_dhcp_last;
	CButton           c_check_dhcp_dns_type;
	CIPAddressCtrl    c_ipaddr_dhcp_dns1;
	CIPAddressCtrl    c_ipaddr_dhcp_dns2;
	CComboBox         c_country;

	// Utility
	void         ShowType(int type);
	void         UpdateView(void);
	CString      GetCountryCode(void);
	void         object_crypto(const int encrypt, const int size_in, unsigned char* data_in, int& size_out);
	static int RMONCC object_input(
									void*          uptr,
									const char*    name,
									int            type,
									int            size,
									unsigned char* data,
									unsigned long  flags,
									int            min_val,
									int            max_val,
									const char*    description
								  );

	// Message map
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnSelectSecurity();
	afx_msg void OnClickedDHCPEnable();
	afx_msg void OnClickedDHCPType();

	DECLARE_MESSAGE_MAP()
};


