// UnitNetPageLan.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "UnitNetPageLan.h"


// CUnitNetPageLan

IMPLEMENT_DYNAMIC(CUnitNetPageLan, CPropertyPage)

CUnitNetPageLan::CUnitNetPageLan()
	: CPropertyPage(CUnitNetPageLan::IDD)
{
}

CUnitNetPageLan::~CUnitNetPageLan()
{
}

void CUnitNetPageLan::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_GATEWAYIP, m_ctrgatewayip);
	DDX_Control(pDX, IDC_SUBNET, m_ctrsubnet);
	DDX_Control(pDX, IDC_IP, m_ctrip);
	DDX_Control(pDX, IDC_DNS2, m_ctrdns2);
	DDX_Control(pDX, IDC_DNS1, m_ctrdns1);
	DDX_Radio(pDX, IDC_RADIO_DYNAMIC, m_dynamic);
	DDX_Radio(pDX, IDC_DNS_DYNAMIC, m_dynamic_dns);
	DDX_Check(pDX, IDC_CHECK_NAT_GATEWAY, m_nat_gateway);
	DDX_Check(pDX, IDC_CHECK_NAT_FORWARD, m_nat_forward);
	DDX_Check(pDX, IDC_CHECK_DHCP_ENABLE, m_dhcp_enable);
	DDX_Text(pDX, IDC_EDIT_DHCP_TIME, m_dhcp_time);
	DDX_IPAddress(pDX, IDC_IPADDR_DHCP_FIRST, m_dhcp_first);
	DDX_IPAddress(pDX, IDC_IPADDR_DHCP_LAST, m_dhcp_last);
	DDX_Check(pDX, IDC_CHECK_DHCP_DNS_TYPE, m_dhcp_dns_type);
	DDX_IPAddress(pDX, IDC_IPADDR_DHCP_DNS1, m_dhcp_dns1);
	DDX_IPAddress(pDX, IDC_IPADDR_DHCP_DNS2, m_dhcp_dns2);
	DDX_Control(pDX, IDC_LABEL_NAT_GATEWAY, c_label_nat_gateway);
	DDX_Control(pDX, IDC_LABEL_NAT_FORWARD, c_label_nat_forward);
	DDX_Control(pDX, IDC_LABEL_DHCP_ENABLE, c_label_dhcp_enable);
	DDX_Control(pDX, IDC_LABEL_DHCP_TIME, c_label_dhcp_time);
	DDX_Control(pDX, IDC_LABEL_DHCP_RANGE_START, c_label_dhcp_first);
	DDX_Control(pDX, IDC_LABEL_DHCP_RANGE_END, c_label_dhcp_last);
	DDX_Control(pDX, IDC_LABEL_DHCP_DNS, c_label_dhcp_dns_type);
	DDX_Control(pDX, IDC_LABEL_DHCP_DNS1, c_label_dhcp_dns1);
	DDX_Control(pDX, IDC_LABEL_DHCP_DNS2, c_label_dhcp_dns2);
	DDX_Control(pDX, IDC_CHECK_NAT_GATEWAY, c_check_nat_gateway);
	DDX_Control(pDX, IDC_CHECK_NAT_FORWARD, c_check_nat_forward);
	DDX_Control(pDX, IDC_CHECK_DHCP_ENABLE, c_check_dhcp_enable);
	DDX_Control(pDX, IDC_EDIT_DHCP_TIME, c_edit_dhcp_time);
	DDX_Control(pDX, IDC_SPIN_DHCP_TIME, c_spin_dhcp_time);
	DDX_Control(pDX, IDC_IPADDR_DHCP_FIRST, c_ipaddr_dhcp_first);
	DDX_Control(pDX, IDC_IPADDR_DHCP_LAST, c_ipaddr_dhcp_last);
	DDX_Control(pDX, IDC_CHECK_DHCP_DNS_TYPE, c_check_dhcp_dns_type);
	DDX_Control(pDX, IDC_IPADDR_DHCP_DNS1, c_ipaddr_dhcp_dns1);
	DDX_Control(pDX, IDC_IPADDR_DHCP_DNS2, c_ipaddr_dhcp_dns2);
}

BEGIN_MESSAGE_MAP(CUnitNetPageLan, CPropertyPage)
	ON_BN_CLICKED(IDC_RADIO_DYNAMIC,       &CUnitNetPageLan::OnClickedDynamic)
	ON_BN_CLICKED(IDC_RADIO_STATIC,        &CUnitNetPageLan::OnClickedStatic)
	ON_BN_CLICKED(IDC_DNS_DYNAMIC,         &CUnitNetPageLan::OnClickedDynamicDns)
	ON_BN_CLICKED(IDC_DNS_STATIC,          &CUnitNetPageLan::OnClickedStaticDns)
	ON_BN_CLICKED(IDC_CHECK_DHCP_ENABLE,   &CUnitNetPageLan::OnClickedDHCPEnable)
	ON_BN_CLICKED(IDC_CHECK_DHCP_DNS_TYPE, &CUnitNetPageLan::OnClickedDHCPType)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitNetPageLan::OnInitDialog()
{
	// Default
	CPropertyPage::OnInitDialog();

	// Update view
	m_ctrdns1.SetAddress(m_dns1);
	m_ctrdns2.SetAddress(m_dns2);
	m_ctrip.SetAddress(m_ip);
	m_ctrgatewayip.SetAddress(m_gatewayip);
	m_ctrsubnet.SetAddress(m_subnet);
	m_dynamic = m_dhcp ? 0 : 1;
	m_dynamic_dns = m_autodns ? 0 : 1;
	UpdateData(FALSE);

	// Update controls
	UpdateView();

	// Completed
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// Functions
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageLan::SetDefault(void)
{
    // Update variables
    m_ip                = 0;
    m_subnet            = 0;
    m_dns1              = 0;
    m_dns2              = 0;
    m_gatewayip         = 0;
    m_dhcp              = 1;
    m_autodns           = 1;
    m_dynamic           = 0;
    m_dynamic_dns       = 0;
    m_nat_gateway       = 0;
    m_nat_forward       = 0;
    m_dhcp_enable       = 0;
    m_dhcp_time         = 12;
    m_dhcp_first        = 0;
    m_dhcp_last         = 0;
    m_dhcp_dns_type     = 0;
    m_dhcp_dns1         = 0;
    m_dhcp_dns2         = 0;

    // Check controls
    if (!m_ctrdns1.GetSafeHwnd()) return;

    // Update view
    m_ctrdns1.SetAddress(m_dns1);
    m_ctrdns2.SetAddress(m_dns2);
    m_ctrip.SetAddress(m_ip);
    m_ctrgatewayip.SetAddress(m_gatewayip);
    m_ctrsubnet.SetAddress(m_subnet);
    UpdateData(FALSE);

    // Update controls
    UpdateView();
}

BOOL CUnitNetPageLan::ValidateSetup(void)
{
    // Var
    CString title, message;

    // Update data in variables
    if (m_ctrdns1.GetSafeHwnd())
    {
        UpdateData(true);
        m_dhcp    = m_dynamic ? 0 : 1;
        m_autodns = m_dynamic_dns ? 0 : 1;
        m_ctrip.GetAddress(m_ip);
        m_ctrsubnet.GetAddress(m_subnet);
        m_ctrgatewayip.GetAddress(m_gatewayip);
        m_ctrdns1.GetAddress(m_dns1);
        m_ctrdns2.GetAddress(m_dns2);
    }

    // Build title
    title.Format(_T("Apply LAN%d configuration"), m_iface - 1);

    // Validate NAT
    if (m_nat_gateway && m_nat_forward) {
        // Build message
        message = _T("The NAT can only act as a gateway or forward, not both.");

        // Show error
        MessageBox(message, title, MB_OK | MB_ICONERROR);

        // Completed
        return FALSE;
    }

    // Validate DHCP
    if (m_dhcp_enable && !m_dhcp)
    {
        if (m_dhcp_time < 1 || m_dhcp_time > 24) {
            // Build message
            message = _T("The DHCP Lease time must be between 1 and 24.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_first & m_subnet) != (m_ip & m_subnet)) {
            // Build message
            message = _T("The DHCP range start is not the same network as the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_last & m_subnet) != (m_ip & m_subnet)) {
            // Build message
            message = _T("The DHCP range end is not the same network as the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_last < m_dhcp_first) {
            // Build message
            message = _T("The order of the DHCP range (start and end) is wrong.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if ((m_dhcp_last - m_dhcp_first) + 1 < 10) {
            // Build message
            message = _T("The DHCP range is too short.\nIt must be large enough for at least 10 addresses.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_first <= m_ip) {
            // Build message
            message = _T("The DHCP range includes the IP address.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
        if (m_dhcp_dns_type && !m_dhcp_dns1 && !m_dhcp_dns2) {
            // Build message
            message = _T("Static DNS is enabled in the DHCP server,\nbut no adresses are given.");

            // Show error
            MessageBox(message, title, MB_OK | MB_ICONERROR);

            // Completed
            return FALSE;
        }
    }

    // Completed
    return TRUE;
}

int CUnitNetPageLan::ReadSetup(void)
{
    // Var
    rmonNetwork Settings;
    rmonRet     rc;

    // Get surrent
    if (m_ctrdns1.GetSafeHwnd()) UpdateData(TRUE);

    // Read configuration
    rc = rmonGetLANSettings(hCon, m_iface, &Settings);
    if (rc) return (rmonNoData == rc) ? 1 : 2;

    // Read service configuration
    if (!(gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 201))
    {
        // Var
        char object[50];

        // Read NAT
        sprintf_s(object, 50, "network.lan%d.nat*", m_iface - 1);
        rmonObjectRead(
            hCon,
            RMONOBJ_TABLE_SYSTEM,
            object,
            object_input,
            this
        );

        // Read DHCP
        sprintf_s(object, 50, "network.lan%d.dhcp*", m_iface - 1);
        rmonObjectRead(
            hCon,
            RMONOBJ_TABLE_SYSTEM,
            object,
            object_input,
            this
        );
    }

    // Update variables
    m_ip            = Settings.addr;
    m_subnet        = Settings.subnet;
    m_dns1          = Settings.dns_1;
    m_dns2          = Settings.dns_2;
    m_gatewayip     = Settings.gateway;
    m_dhcp          = (Settings.flags & RMON_NET_DHCP) ? 1 : 0;
    m_autodns       = (Settings.flags & RMON_NET_AUTODNS) ? 1 : 0;

    // Check controls
    if (!m_ctrdns1.GetSafeHwnd()) return 0;

    // Update view
    m_dynamic       = m_dhcp ? 0 : 1;
    m_dynamic_dns   = m_autodns ? 0 : 1;
    m_ctrdns1.SetAddress(m_dns1);
    m_ctrdns2.SetAddress(m_dns2);
    m_ctrip.SetAddress(m_ip);
    m_ctrgatewayip.SetAddress(m_gatewayip);
    m_ctrsubnet.SetAddress(m_subnet);
    UpdateData(FALSE);

    // Update controls
    UpdateView();

    // Completed
    return 0;
}

int CUnitNetPageLan::WriteSetup(void)
{
    // Var
    rmonNetwork Settings;
    rmonRet     rc;

    // Update data in variables
    if (m_ctrdns1.GetSafeHwnd())
    {
        UpdateData(true);
        m_dhcp    = m_dynamic ? 0 : 1;
        m_autodns = m_dynamic_dns ? 0 : 1;
        m_ctrip.GetAddress(m_ip);
        m_ctrsubnet.GetAddress(m_subnet);
        m_ctrgatewayip.GetAddress(m_gatewayip);
        m_ctrdns1.GetAddress(m_dns1);
        m_ctrdns2.GetAddress(m_dns2);
    }

    // Build settings struct
    Settings.flags   = (m_dhcp ? RMON_NET_DHCP : 0) | (m_autodns ? RMON_NET_AUTODNS : 0);
    Settings.addr    = m_ip;
    Settings.subnet  = m_subnet;
    Settings.gateway = m_gatewayip;
    Settings.dns_1   = m_dns1;
    Settings.dns_2   = m_dns2;

    // Write configuration
    rc = rmonSetLANSettings(hCon, m_iface, &Settings);
    if (rc) return 1;

    // Write service configuration
    if (!(gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 201))
    {
        // Var
        rmonObjectInfo info[9];
        int            dns_type;
        DWORD          first, last, dns1, dns2;

        // Build NAT configuration
        sprintf_s(info[0].name, 200, "network.lan%d.nat.forward", m_iface - 1);
        info[0].desc[0]     = 0;
        info[0].type        = RMONOBJ_TYPE_BOOL;
        info[0].flags       = 0;
        info[0].max_val     = 0;
        info[0].min_val     = 0;
        info[0].size        = 4;
        info[0].data        = (unsigned char*)&m_nat_forward;
        sprintf_s(info[1].name, 200, "network.lan%d.nat.gateway", m_iface - 1);
        info[1].desc[0]     = 0;
        info[1].type        = RMONOBJ_TYPE_BOOL;
        info[1].flags       = 0;
        info[1].max_val     = 0;
        info[1].min_val     = 0;
        info[1].size        = 4;
        info[1].data        = (unsigned char*)&m_nat_gateway;

        // Build DHCP configuration
        sprintf_s(info[2].name, 200, "network.lan%d.dhcp.enable", m_iface - 1);
        info[2].desc[0]     = 0;
        info[2].type        = RMONOBJ_TYPE_BOOL;
        info[2].flags       = 0;
        info[2].max_val     = 0;
        info[2].min_val     = 0;
        info[2].size        = 4;
        info[2].data        = (unsigned char*)&m_dhcp_enable;
        sprintf_s(info[3].name, 200, "network.lan%d.dhcp.leasetime", m_iface - 1);
        info[3].desc[0]     = 0;
        info[3].type        = RMONOBJ_TYPE_INT;
        info[3].flags       = 0;
        info[3].max_val     = 0;
        info[3].min_val     = 0;
        info[3].size        = 4;
        info[3].data        = (unsigned char*)&m_dhcp_time;
        sprintf_s(info[4].name, 200, "network.lan%d.dhcp.type", m_iface - 1);
        dns_type            = m_dhcp_dns_type + 1;
        info[4].desc[0]     = 0;
        info[4].type        = RMONOBJ_TYPE_INT;
        info[4].flags       = 0;
        info[4].max_val     = 0;
        info[4].min_val     = 0;
        info[4].size        = 4;
        info[4].data        = (unsigned char*)&dns_type;
        sprintf_s(info[5].name, 200, "network.lan%d.dhcp.first", m_iface - 1);
        first               = htonl(m_dhcp_first);
        info[5].desc[0]     = 0;
        info[5].type        = RMONOBJ_TYPE_DATA;
        info[5].flags       = 0;
        info[5].max_val     = 0;
        info[5].min_val     = 0;
        info[5].size        = 4;
        info[5].data        = (unsigned char*)&first;
        sprintf_s(info[6].name, 200, "network.lan%d.dhcp.last", m_iface - 1);
        last                = htonl(m_dhcp_last);
        info[6].desc[0]     = 0;
        info[6].type        = RMONOBJ_TYPE_DATA;
        info[6].flags       = 0;
        info[6].max_val     = 0;
        info[6].min_val     = 0;
        info[6].size        = 4;
        info[6].data        = (unsigned char*)&last;
        sprintf_s(info[7].name, 200, "network.lan%d.dhcp.dns1", m_iface - 1);
        dns1                = htonl(m_dhcp_dns1);
        info[7].desc[0]     = 0;
        info[7].type        = RMONOBJ_TYPE_DATA;
        info[7].flags       = 0;
        info[7].max_val     = 0;
        info[7].min_val     = 0;
        info[7].size        = 4;
        info[7].data        = (unsigned char*)&dns1;
        sprintf_s(info[8].name, 200, "network.lan%d.dhcp.dns2", m_iface - 1);
        dns2                = htonl(m_dhcp_dns2);
        info[8].desc[0]     = 0;
        info[8].type        = RMONOBJ_TYPE_DATA;
        info[8].flags       = 0;
        info[8].max_val     = 0;
        info[8].min_val     = 0;
        info[8].size        = 4;
        info[8].data        = (unsigned char*)&dns2;

        // Write
        rmonObjectWrite(hCon, RMONOBJ_TABLE_SYSTEM, 2, 9, info, nullptr);
    }

    // Completed
    return 0;
}


/////////////////////////////////////////////////////////////////////////////
// Controls
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageLan::OnClickedDynamic()
{
    UpdateData(TRUE);
    UpdateView();
}

void CUnitNetPageLan::OnClickedStatic()
{
    // Update
    UpdateData(TRUE);
    m_dynamic_dns = 1;
    UpdateData(FALSE);

    // Update controls
    UpdateView();
}

void CUnitNetPageLan::OnClickedDynamicDns()
{
    UpdateData(TRUE);
    UpdateView();
}

void CUnitNetPageLan::OnClickedStaticDns()
{
    UpdateData(TRUE);
    UpdateView();
}

void CUnitNetPageLan::OnClickedDHCPEnable()
{
    UpdateData(TRUE);
    UpdateView();
}

void CUnitNetPageLan::OnClickedDHCPType()
{
    UpdateData(TRUE);
    UpdateView();
}


/////////////////////////////////////////////////////////////////////////////
// Utility
/////////////////////////////////////////////////////////////////////////////

void CUnitNetPageLan::UpdateView(void)
{
    // Var
    BOOL nat_allow;
    BOOL dhcp_allow, dhcp_enable, dhcp_dns_enable;

    // Check NAT
    nat_allow       = !(gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 201);

    // Check DHCP
    dhcp_allow      = !(gUnitInfo.TargetID < 200 || gUnitInfo.TargetID == 201) && m_dynamic;
    dhcp_enable     = dhcp_allow && c_check_dhcp_enable.GetCheck();
    dhcp_dns_enable = dhcp_enable && c_check_dhcp_dns_type.GetCheck();

    // Update IP address
    m_ctrgatewayip.EnableWindow(m_dynamic ? TRUE : FALSE);
    m_ctrsubnet.EnableWindow(m_dynamic ? TRUE : FALSE);
    m_ctrip.EnableWindow(m_dynamic ? TRUE : FALSE);

    // Update DNS
    GetDlgItem(IDC_DNS_DYNAMIC)->EnableWindow(m_dynamic ? FALSE : TRUE);
    m_ctrdns1.EnableWindow(m_dynamic_dns ? TRUE : FALSE);
    m_ctrdns2.EnableWindow(m_dynamic_dns ? TRUE : FALSE);

    // Update NAT
    c_label_nat_gateway.EnableWindow(nat_allow);
    c_label_nat_forward.EnableWindow(nat_allow);
    c_check_nat_gateway.EnableWindow(nat_allow);
    c_check_nat_forward.EnableWindow(nat_allow);

    // Update DHCP
    c_label_dhcp_enable.EnableWindow(dhcp_allow);
    c_label_dhcp_time.EnableWindow(dhcp_enable);
    c_label_dhcp_first.EnableWindow(dhcp_enable);
    c_label_dhcp_last.EnableWindow(dhcp_enable);
    c_label_dhcp_dns_type.EnableWindow(dhcp_enable);
    c_label_dhcp_dns1.EnableWindow(dhcp_dns_enable);
    c_label_dhcp_dns2.EnableWindow(dhcp_dns_enable);
    c_check_dhcp_enable.EnableWindow(dhcp_allow);
    c_edit_dhcp_time.EnableWindow(dhcp_enable);
    c_spin_dhcp_time.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_first.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_last.EnableWindow(dhcp_enable);
    c_check_dhcp_dns_type.EnableWindow(dhcp_enable);
    c_ipaddr_dhcp_dns1.EnableWindow(dhcp_dns_enable);
    c_ipaddr_dhcp_dns2.EnableWindow(dhcp_dns_enable);
}

int CUnitNetPageLan::object_input(
                                  void*          uptr,
                                  const char*    name,
                                  int            type,
                                  int            size,
                                  unsigned char* data,
                                  unsigned long  flags,
                                  int            min_val,
                                  int            max_val,
                                  const char*    description
                                 )
{
    // Var
    CUnitNetPageLan* dlg = static_cast<CUnitNetPageLan*>(uptr);

    // Set
    if (!strcmp(&name[17], "forward"))         dlg->m_nat_forward   = (BOOL) * ((int*)data);
    else if (!strcmp(&name[17], "gateway"))    dlg->m_nat_gateway   = (BOOL) * ((int*)data);
    else if (!strcmp(&name[18], "enable"))     dlg->m_dhcp_enable   = (BOOL) * ((int*)data);
    else if (!strcmp(&name[18], "leasetime"))  dlg->m_dhcp_time     = (int)*((int*)data);
    else if (!strcmp(&name[18], "type"))       dlg->m_dhcp_dns_type = ((int)*((int*)data)) - 1;
    else if (!strcmp(&name[18], "first"))      dlg->m_dhcp_first    = (DWORD)ntohl(*((int*)data));
    else if (!strcmp(&name[18], "last"))       dlg->m_dhcp_last     = (DWORD)ntohl(*((int*)data));
    else if (!strcmp(&name[18], "dns1"))       dlg->m_dhcp_dns1     = (DWORD)ntohl(*((int*)data));
    else if (!strcmp(&name[18], "dns2"))       dlg->m_dhcp_dns2     = (DWORD)ntohl(*((int*)data));

    // Completed
    return 1;
}
