#pragma once


// CUnitNetPageLan

class CUnitNetPageLan : public CPropertyPage
{
	DECLARE_DYNAMIC(CUnitNetPageLan)

public:
	CUnitNetPageLan();
	~CUnitNetPageLan();

	// Functions
	void         SetDefault(void);
	BOOL         ValidateSetup(void);
	int          ReadSetup(void);
	int          WriteSetup(void);

	enum { IDD = IDD_UNIT_NET_PAGE_LAN };
	BOOL            m_dhcp;
	DWORD           m_ip;
	DWORD           m_subnet;
	DWORD           m_gatewayip;
	BOOL            m_autodns;
	DWORD           m_dns1;
	DWORD           m_dns2;
	int             m_iface;
	BOOL            m_nat_gateway;
	BOOL            m_nat_forward;
	BOOL            m_dhcp_enable;
	int             m_dhcp_time;
	DWORD           m_dhcp_first;
	DWORD           m_dhcp_last;
	BOOL            m_dhcp_dns_type;
	DWORD           m_dhcp_dns1;
	DWORD           m_dhcp_dns2;

protected:
	// Controls
	CIPAddressCtrl  m_ctrgatewayip;
	CIPAddressCtrl  m_ctrsubnet;
	CIPAddressCtrl  m_ctrip;
	CIPAddressCtrl  m_ctrdns2;
	CIPAddressCtrl  m_ctrdns1;
	int             m_dynamic;
	int             m_dynamic_dns;
	CStatic         c_label_nat_gateway;
	CStatic         c_label_nat_forward;
	CStatic         c_label_dhcp_enable;
	CStatic         c_label_dhcp_time;
	CStatic         c_label_dhcp_first;
	CStatic         c_label_dhcp_last;
	CStatic         c_label_dhcp_dns_type;
	CStatic         c_label_dhcp_dns1;
	CStatic         c_label_dhcp_dns2;
	CButton         c_check_nat_gateway;
	CButton         c_check_nat_forward;
	CButton         c_check_dhcp_enable;
	CEdit           c_edit_dhcp_time;
	CSpinButtonCtrl c_spin_dhcp_time;
	CIPAddressCtrl  c_ipaddr_dhcp_first;
	CIPAddressCtrl  c_ipaddr_dhcp_last;
	CButton         c_check_dhcp_dns_type;
	CIPAddressCtrl  c_ipaddr_dhcp_dns1;
	CIPAddressCtrl  c_ipaddr_dhcp_dns2;

	// Utility
	void         UpdateView(void);
	static int RMONCC object_input(
									void*          uptr,
									const char*    name,
									int            type,
									int            size,
									unsigned char* data,
									unsigned long  flags,
									int            min_val,
									int            max_val,
									const char*    description
								  );

	// Message map functions
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnClickedDynamic();
	afx_msg void OnClickedDynamicDns();
	afx_msg void OnClickedStatic();
	afx_msg void OnClickedStaticDns();
	afx_msg void OnClickedDHCPEnable();
	afx_msg void OnClickedDHCPType();

	DECLARE_MESSAGE_MAP()
};
