#pragma once

#define WIFI_NETWORKS         11

// CUnitNetPageWlan

class CUnitNetPageWlan : public CPropertyPage
{
	DECLARE_DYNAMIC(CUnitNetPageWlan)

public:
	CUnitNetPageWlan();
	~CUnitNetPageWlan();

	enum { IDD = IDD_UNIT_NET_PAGE_WLAN };
	BOOL				m_nat_gateway;

	void         SetDefault(void);
	BOOL         ValidateSetup(void);
	int          ReadSetup(void);
	int          WriteSetup(void);
	void         Load(void);
	void         Save(void);

protected:
	// Structure
	struct wifi_security_t
	{
		int              type;
		CString          phrase;
	};
	struct wifi_ipv4_t
	{
		unsigned short   flags;
		unsigned long    ip;
		unsigned long    subnet;
		unsigned long    gateway;
		unsigned long    dns1;
		unsigned long    dns2;
	};
	struct wifi_node_t
	{
		CString          ssid;
		wifi_security_t  security;
		wifi_ipv4_t      ipv4;
	};

	// Dialog Data
	wifi_node_t*		m_wifi_nodes[WIFI_NETWORKS];

	// Controls
	CListCtrl			c_list;
	CButton				c_add;
	CButton				c_remove;
	CButton				c_check_nat_gateway;
	CStatic				c_label_nat_gateway;

protected:
	// Data
	void         UpdateList(void);
	static int RMONCC object_input(
									void* uptr,
									const char* name,
									int type,
									int size,
									unsigned char* data,
									unsigned long flags,
									int min_val,
									int max_val,
									const char* description
								  );

	// Controls
	int          GetCurSel(void);
	void         UpdateView(void);

	// Message map functions
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnClickedAdd();
	afx_msg void OnClickedRemove();
	afx_msg void OnListSelection(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnListDClick(NMHDR* pNMHDR, LRESULT* pResult);

	DECLARE_MESSAGE_MAP()
};


