#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitNetSheet.h"

IMPLEMENT_DYNAMIC(CUnitNetSheet, CPropertySheet)

CUnitNetSheet::CUnitNetSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	// Hide apply button
	m_psh.dwFlags |= PSH_NOAPPLYNOW;

	// Get device state
	if (gUnitInfo.TargetID == 129)
	{
		m_enable_lan  = (gUnitInfo.SerialNumber / 1000000) != 295 ? 1 : 0;
		m_enable_wifi = 0;
	}
	else if (gUnitInfo.TargetID >= 200 && gUnitInfo.TargetID != 201)
	{
		m_enable_lan  = 2;
		m_enable_wifi = 1;
	}
	else
	{
		m_enable_lan  = 0;
		m_enable_wifi = 0;
	}

	// Insert pages
	AddPage(&m_Page1);
	if (m_enable_lan > 0)  AddPage(&m_Page2);
	if (m_enable_lan > 1)  AddPage(&m_Page3);
	if (m_enable_wifi > 0) AddPage(&m_Page4);
	if (m_enable_wifi > 0) AddPage(&m_Page5);

	// Setup dialog
	m_Page1.m_userid			= AfxGetApp()->GetProfileString(_T("NetworkOptions\\Cell"),       _T("USERID"),         _T(""));
	m_Page1.m_password			= AfxGetApp()->GetProfileString(_T("NetworkOptions\\Cell"),       _T("PASSWORD"),       _T(""));
	m_Page1.m_apn				= AfxGetApp()->GetProfileString(_T("NetworkOptions\\Cell"),       _T("APN"),            _T("internet"));
	m_Page1.m_apn_history		= AfxGetApp()->GetProfileString(_T("NetworkOptions\\Cell"),       _T("APN-HISTORY"),    _T(""));
	m_Page1.m_ip				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("IP"),             0);
	m_Page1.m_subnet			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("SUBNET"),         0);
	m_Page1.m_dns1				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("DNS1"),           0);
	m_Page1.m_dns2				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("DNS2"),           0);
	m_Page1.m_gatewayip			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("GATEWAYIP"),      0);
	m_Page1.m_authentication	= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("AUTHENTICATION"), 3);
	m_Page1.m_init				= AfxGetApp()->GetProfileString(_T("NetworkOptions\\Cell"),       _T("MODEMINIT"),      _T(""));
	m_Page1.m_dynamic			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell"),       _T("DYNAMIC"),        1);
	m_Page1.m_nat_gateway		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\Cell\\NAT"),  _T("GATEWAY"),        0);
	m_Page2.m_iface				= 2;
	m_Page2.m_dhcp				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DHCP"),           1);
	m_Page2.m_ip				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("IP"),             0);
	m_Page2.m_subnet			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("SUBNET"),         0);
	m_Page2.m_dns1				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DNS1"),           0);
	m_Page2.m_dns2				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DNS2"),           0);
	m_Page2.m_gatewayip			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("GATEWAYIP"),      0);
	m_Page2.m_autodns			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1"),       _T("AutoDNS"),        1);
	m_Page2.m_nat_forward		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\NAT"),  _T("FORWARD"),        0);
	m_Page2.m_nat_gateway		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\NAT"),  _T("GATEWAY"),        0);
	m_Page2.m_dhcp_enable		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("enable"),         0);
	m_Page2.m_dhcp_time			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("time"),           12);
	m_Page2.m_dhcp_first		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("first"),          0);
	m_Page2.m_dhcp_last			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("last"),           0);
	m_Page2.m_dhcp_dns_type		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("type"),           0);
	m_Page2.m_dhcp_dns1			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("DNS1"),           0);
	m_Page2.m_dhcp_dns2			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("DNS2"),           0);
	m_Page3.m_iface				= 3;
	m_Page3.m_dhcp				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DHCP"),           1);
	m_Page3.m_ip				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("IP"),             0);
	m_Page3.m_subnet			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("SUBNET"),         0);
	m_Page3.m_dns1				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DNS1"),           0);
	m_Page3.m_dns2				= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DNS2"),           0);
	m_Page3.m_gatewayip			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("GATEWAYIP"),      0);
	m_Page3.m_autodns			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2"),       _T("AutoDNS"),        1);
	m_Page3.m_nat_forward		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\NAT"),  _T("FORWARD"),        0);
	m_Page3.m_nat_gateway		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\NAT"),  _T("GATEWAY"),        0);
	m_Page3.m_dhcp_enable		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("enable"),         0);
	m_Page3.m_dhcp_time			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("time"),           12);
	m_Page3.m_dhcp_first		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("first"),          0);
	m_Page3.m_dhcp_last			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("last"),           0);
	m_Page3.m_dhcp_dns_type		= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("type"),           0);
	m_Page3.m_dhcp_dns1			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("DNS1"),           0);
	m_Page3.m_dhcp_dns2			= AfxGetApp()->GetProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("DNS2"),           0);
	m_Page4.Load();
	m_Page5.Load();

	// Remove whitespace
	m_Page1.StripWhiteSpace(m_Page1.m_userid);
	m_Page1.StripWhiteSpace(m_Page1.m_password);
	m_Page1.StripWhiteSpace(m_Page1.m_apn);
	m_Page1.StripWhiteSpace(m_Page1.m_apn_history);
}

CUnitNetSheet::~CUnitNetSheet()
{
}

BEGIN_MESSAGE_MAP(CUnitNetSheet, CPropertySheet)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_READ,       &CUnitNetSheet::OnRead)
	ON_BN_CLICKED(IDC_WRITE,      &CUnitNetSheet::OnWrite)
	ON_BN_CLICKED(IDC_SETDEFAULT, &CUnitNetSheet::OnSetdefault)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitNetSheet::OnInitDialog()
{
	// Var
	CRect           rc;
	int             start, stop, button, height, width;
	RECT            rectReset, rectRead, rectWrite, rectDone;
	CString         text;

	// Default
	BOOL bResult = CPropertySheet::OnInitDialog();

	// Calculate
	GetTabControl()->GetWindowRect(&rc);
	ScreenToClient(&rc);
	height				= rc.bottom;
	start				= rc.left;
	stop				= rc.right;
	width				= rc.right;
	m_Page1.GetDlgItem(IDC_FRAME)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	width				= (width - rc.right) - rc.left;
	stop               -= width;
	GetDlgItem(IDOK)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	button				= ((stop - start) - (2 * start)) / 3;
	rectRead.top		= rc.top;
	rectRead.bottom		= rc.bottom;
	rectRead.left		= start;
	rectRead.right		= start + button;
	rectWrite.top		= rc.top;
	rectWrite.bottom	= rc.bottom;
	rectWrite.left		= rectRead.right + start;
	rectWrite.right		= rectWrite.left + button;
	rectReset.top		= rc.top;
	rectReset.bottom	= rc.bottom;
	rectReset.left		= stop - button;
	rectReset.right		= stop;
	height				= rectRead.bottom - height;
	rectDone.top		= rectRead.top + height;
	rectDone.bottom		= rectRead.bottom + height;
	rectDone.left		= stop - button;
	rectDone.right		= stop;

	// Adjust pages
	for (int i = 0; i < GetPageCount(); ++i)
	{
		if (GetPage(i)->GetSafeHwnd())
		{
			// Change size
			GetPage(i)->GetWindowRect(&rc);
			rc.right -= width;
			GetPage(i)->SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_NOACTIVATE);
		}
	}

	// Adjust TAB ctrl
	GetTabControl()->GetWindowRect(&rc);
	rc.right -= width;
	GetTabControl()->SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_NOACTIVATE);

	// Adjust sheet
	GetWindowRect(&rc);
	rc.right -= width;
	rc.bottom += height + 7;
	SetWindowPos(NULL, 0, 0, rc.Width(), rc.Height(), SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER | SWP_NOACTIVATE);

	// Hide buttons
	GetDlgItem(IDOK)->ShowWindow(SW_HIDE);
	GetDlgItem(IDHELP)->ShowWindow(SW_HIDE);
	ModifyStyle(WS_SYSMENU, 0, 0);

	// Add button done
	GetDlgItem(IDCANCEL)->MoveWindow(&rectDone);
	GetDlgItem(IDCANCEL)->SetWindowText(_T("Close"));

	// Add button Fetch
	m_read.CreateEx(0, _T("BUTTON"), "Fetch", WS_CHILD | WS_VISIBLE | WS_TABSTOP, rectRead, this, IDC_READ, 0);
	m_read.SetFont(GetFont());

	// Add button Write
	m_write.CreateEx(0, _T("BUTTON"), "Apply", WS_CHILD | WS_VISIBLE | WS_TABSTOP, rectWrite, this, IDC_WRITE, 0);
	m_write.SetFont(GetFont());

	// Add button Reset
	m_reset.CreateEx(0, _T("BUTTON"), "Default", WS_CHILD | WS_VISIBLE | WS_TABSTOP, rectReset, this, IDC_SETDEFAULT, 0);
	m_reset.SetFont(GetFont());

	// Adjust title
	if (m_enable_lan > 1)
	{
		// Var
		CString text;
		TC_ITEM item;

		// Setup
		item.mask    = TCIF_TEXT;

		// Update LAN 1
		text         = _T("LAN 1");
		item.pszText = (LPTSTR)(LPCTSTR)text;
		GetTabControl()->SetItem(1, &item);

		// Update LAN 2
		text         = _T("LAN 2");
		item.pszText = (LPTSTR)(LPCTSTR)text;
		GetTabControl()->SetItem(2, &item);
	}

	// Completed
	return bResult;
}

void CUnitNetSheet::OnDestroy()
{
	// Save settings
	AfxGetApp()->WriteProfileString(_T("NetworkOptions\\Cell"),       _T("USERID"),         m_Page1.m_userid);
	AfxGetApp()->WriteProfileString(_T("NetworkOptions\\Cell"),       _T("PASSWORD"),       m_Page1.m_password);
	AfxGetApp()->WriteProfileString(_T("NetworkOptions\\Cell"),       _T("APN"),            m_Page1.m_apn);
	AfxGetApp()->WriteProfileString(_T("NetworkOptions\\Cell"),       _T("APN-HISTORY"),    m_Page1.m_apn_history);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("IP"),             m_Page1.m_ip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("SUBNET"),         m_Page1.m_subnet);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("DNS1"),           m_Page1.m_dns1);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("DNS2"),           m_Page1.m_dns2);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("GATEWAYIP"),      m_Page1.m_gatewayip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("AUTHENTICATION"), m_Page1.m_authentication);
	AfxGetApp()->WriteProfileString(_T("NetworkOptions\\Cell"),       _T("MODEMINIT"),      m_Page1.m_init);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell"),       _T("DYNAMIC"),        m_Page1.m_dynamic);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\Cell\\NAT"),  _T("GATEWAY"),        m_Page1.m_nat_gateway);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DHCP"),           m_Page2.m_dhcp);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("IP"),             m_Page2.m_ip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("SUBNET"),         m_Page2.m_subnet);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DNS1"),           m_Page2.m_dns1);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("DNS2"),           m_Page2.m_dns2);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("GATEWAYIP"),      m_Page2.m_gatewayip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1"),       _T("AutoDNS"),        m_Page2.m_autodns);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\NAT"),  _T("FORWARD"),        m_Page2.m_nat_forward);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\NAT"),  _T("GATEWAY"),        m_Page2.m_nat_gateway);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("enable"),         m_Page2.m_dhcp_enable);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("time"),           m_Page2.m_dhcp_time);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("first"),          m_Page2.m_dhcp_first);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("last"),           m_Page2.m_dhcp_last);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("type"),           m_Page2.m_dhcp_dns_type);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("DNS1"),           m_Page2.m_dhcp_dns1);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN1\\DHCP"), _T("DNS2"),           m_Page2.m_dhcp_dns2);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DHCP"),           m_Page3.m_dhcp);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("IP"),             m_Page3.m_ip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("SUBNET"),         m_Page3.m_subnet);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DNS1"),           m_Page3.m_dns1);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("DNS2"),           m_Page3.m_dns2);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("GATEWAYIP"),      m_Page3.m_gatewayip);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2"),       _T("AutoDNS"),        m_Page3.m_autodns);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\NAT"),  _T("FORWARD"),        m_Page3.m_nat_forward);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\NAT"),  _T("GATEWAY"),        m_Page3.m_nat_gateway);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("enable"),         m_Page3.m_dhcp_enable);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("time"),           m_Page3.m_dhcp_time);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("first"),          m_Page3.m_dhcp_first);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("last"),           m_Page3.m_dhcp_last);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("type"),           m_Page3.m_dhcp_dns_type);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("DNS1"),           m_Page3.m_dhcp_dns1);
	AfxGetApp()->WriteProfileInt(   _T("NetworkOptions\\LAN2\\DHCP"), _T("DNS2"),           m_Page3.m_dhcp_dns2);
	m_Page4.Save();
	m_Page5.Save();

	// Default
	CPropertySheet::OnDestroy();
}

/////////////////////////////////////////////////////////////////////////////
// Buttons
/////////////////////////////////////////////////////////////////////////////

void CUnitNetSheet::OnRead()
{
	// Var
	int rc;

	// Disable controls
	m_write.EnableWindow(false);
	m_read.EnableWindow(false);
	m_reset.EnableWindow(false);
	GetDlgItem(IDCANCEL)->EnableWindow(false);

	// Read setup
	rc = m_Page1.ReadSetup();
	if (rc == 1) MessageBox(_T("No cellular network settings present in device"), _T("Fetch settings"));
	if (m_enable_lan)
	{
		if (rc != 2) rc = m_Page2.ReadSetup();
		if (rc == 1) MessageBox(_T("No LAN network settings present in device"), _T("Fetch settings"));
		if (m_enable_lan == 2)
		{
			if (rc != 2) rc = m_Page3.ReadSetup();
			if (rc == 1) MessageBox(_T("No LAN network 2 settings present in device"), _T("Fetch settings"));
		}
	}
	if (m_enable_wifi)
	{
		if (rc != 2) rc = m_Page4.ReadSetup();
		if (rc == 1) MessageBox(_T("No WiFi network settings present in device"), _T("Fetch settings"));
		if (rc != 2) rc = m_Page5.ReadSetup();
		if (rc == 1) MessageBox(_T("No Access Point network settings present in device"), _T("Fetch settings"));
	}

	// Enable controls
	m_write.EnableWindow(true);
	m_read.EnableWindow(true);
	m_reset.EnableWindow(true);
	GetDlgItem(IDCANCEL)->EnableWindow(true);

	// Show error
	if (rc == 2) AfxMessageBox(_T("Error in communicating with device"));
}

void CUnitNetSheet::OnWrite()
{
	// Var
	BOOL valid;
	int  rc, count;

	// Disable controls
	m_write.EnableWindow(false);
	m_read.EnableWindow(false);
	m_reset.EnableWindow(false);
	GetDlgItem(IDCANCEL)->EnableWindow(false);

	// Validate setup
	count = 0;
	valid = m_Page1.ValidateSetup();
	if (m_Page1.m_nat_gateway) count++;
	if (m_enable_lan)
	{
		if (valid) valid = m_Page2.ValidateSetup();
		if (m_Page2.m_nat_gateway) count++;
		if (m_enable_lan == 2)
		{
			if (valid) valid = m_Page3.ValidateSetup();
			if (m_Page3.m_nat_gateway) count++;
		}
	}
	if (m_enable_wifi)
	{
		if (valid) valid = m_Page4.ValidateSetup();
		if (valid) valid = m_Page5.ValidateSetup();
		if (m_Page4.m_nat_gateway) count++;
	}
	if (valid && count > 1)
	{
		// Var
		CString title, message;

		// Build
		title   = _T("Apply configuration");
		message = _T("Only one network interface can be a NAT gateway.");
		valid   = FALSE;

		// Show error
		MessageBox(message, title, MB_OK | MB_ICONERROR);
	}

	// Write setup
	if (valid)
	{
		rc = m_Page1.WriteSetup();
		if (m_enable_lan)
		{
			if (!rc) rc = m_Page2.WriteSetup();
			if (m_enable_lan == 2)
			{
				if (!rc) rc = m_Page3.WriteSetup();
			}
		}
		if (m_enable_wifi)
		{
			if (!rc) rc = m_Page4.WriteSetup();
			if (!rc) rc = m_Page5.WriteSetup();
		}
	}

	// Enable controls
	m_write.EnableWindow(true);
	m_read.EnableWindow(true);
	m_reset.EnableWindow(true);
	GetDlgItem(IDCANCEL)->EnableWindow(true);

	// Completed
	if (valid)
	{
		if (rc) AfxMessageBox(_T("Error in communicating with device"));
		else    AfxMessageBox(_T("Please remember to Reset the device for the changes to take effect!"));
	}
}

void CUnitNetSheet::OnSetdefault()
{
	// Verify with user
	if (AfxMessageBox(_T("Are you sure you want to set default values?"), MB_ICONWARNING | MB_YESNO | MB_DEFBUTTON2) == IDYES)
	{
		// Var
		CPropertyPage* pPage = GetActivePage();

		// Set to default values
		if (pPage == &m_Page1)      m_Page1.SetDefault();
		else if (pPage == &m_Page2) m_Page2.SetDefault();
		else if (pPage == &m_Page3) m_Page3.SetDefault();
		else if (pPage == &m_Page4) m_Page4.SetDefault();
		else if (pPage == &m_Page5) m_Page5.SetDefault();
	}
}
