// UnitOptions.cpp : implementation file
//

#include "stdafx.h"
#include "RTCUProg.h"
#include "UnitOptions.h"

extern bool gConnected;

// CUnitOptions dialog

IMPLEMENT_DYNAMIC(CUnitOptions, CDialog)

CUnitOptions::CUnitOptions(CWnd* pParent /*=NULL*/)
  : CDialog(CUnitOptions::IDD, pParent)
{
}

CUnitOptions::~CUnitOptions()
{
}

void CUnitOptions::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_EDIT_OPTION, m_option);
}


BEGIN_MESSAGE_MAP(CUnitOptions, CDialog)
  ON_WM_SHOWWINDOW()
  ON_EN_CHANGE(IDC_EDIT_OPTION, &CUnitOptions::OnChangeOption)
END_MESSAGE_MAP()


// CUnitOptions message handlers

BOOL CUnitOptions::OnInitDialog()
{
  CDialog::OnInitDialog();
  m_option.SetCurrentMask(_T("####-####-###"));
  return TRUE;
}

void CUnitOptions::PostNcDestroy()
{
  // Cleanup
  CDialog::PostNcDestroy();
  delete this;
}

void CUnitOptions::OnCancel()
{
  ShowWindow(SW_HIDE);
  m_option.SetWindowText(_T(""));
}

void CUnitOptions::OnOK()
{
  // Get option
  CString text;
  m_option.GetWindowText(text);
  text.Remove(_T('-'));

  // Update unit
  int rc = rmonFlexOption(hCon, (LPTSTR)(LPCTSTR)text);
  switch (rc) {
    case rmonOK:            text = _T("Option is enabled!\n\nPlease note that the option will\nnot take effect until the unit is reset."); break;
    case rmonComError:      text = _T("Error communicating with unit!"); break;
    case rmonIllegalHandle: text = _T("Connection closed!"); break;
    case rmonTargetError:   text = _T("Unit does not support Flex Options!"); break;
    case rmonError:         text = _T("Option key is rejected by unit!"); break;
    default: text.Format(_T("Unknown error (%d)"), rc);
  }
  MessageBox(text, _T("Options"), MB_OK|MB_ICONINFORMATION);
  if (rc) {
    m_option.SetFocus();
    return;
  }

  // Completed
  ShowWindow(SW_HIDE);
  m_option.SetWindowText(_T(""));
}

void CUnitOptions::OnShowWindow(BOOL bShow, UINT nStatus)
{
  CDialog::OnShowWindow(bShow, nStatus);
  if (bShow) {
    m_option.SetFocus();
  }
}

void CUnitOptions::OnChangeOption()
{
  // Var
  CString text;

  // Update
  m_option.GetWindowText(text);
  GetDlgItem(IDOK)->EnableWindow((text.GetLength()==13 && gConnected) ? true : false);
}

void CUnitOptions::ConnectChanged(void)
{
  // Var
  CString text;

  // Update
  m_option.GetWindowText(text);
  GetDlgItem(IDOK)->EnableWindow((text.GetLength()==13 && gConnected) ? true : false);
}
