// UnitRtc.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitRtc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitRtc dialog


CUnitRtc::CUnitRtc(CWnd* pParent /*=NULL*/)
	: CDialog(CUnitRtc::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnitRtc)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CUnitRtc::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitRtc)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitRtc, CDialog)
	//{{AFX_MSG_MAP(CUnitRtc)
	ON_BN_CLICKED(IDC_SETDATETIME, OnSetdatetime)
	ON_BN_CLICKED(IDC_SETCURRENT, OnSetcurrent)
	ON_BN_CLICKED(IDC_FETCH, OnFetch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnitRtc message handlers

BOOL CUnitRtc::OnInitDialog() 
{
   CDialog::OnInitDialog();

   CWnd *pWnd = GetDlgItem(IDC_RTCDATEFRAME);
   if(!pWnd) return TRUE;
   CRect rc;
   pWnd->GetWindowRect(rc);
   pWnd->DestroyWindow(); // pWnd was just a placeholder;
   ScreenToClient(rc);
   m_RTCDate.Create( WS_DISABLED|WS_CHILD|WS_VISIBLE|DTS_SHORTDATEFORMAT, rc, this, IDC_RTCDATEFRAME );

   pWnd = GetDlgItem(IDC_RTCTIMEFRAME);
   if(!pWnd) return TRUE;
   pWnd->GetWindowRect(rc);
   pWnd->DestroyWindow(); //pWnd was just a placeholder;
   ScreenToClient(rc);
   m_RTCTime.Create( WS_DISABLED|WS_CHILD|WS_VISIBLE|DTS_TIMEFORMAT, rc, this, IDC_RTCTIMEFRAME );

   pWnd = GetDlgItem(IDC_SETDATEFRAME);
   if(!pWnd) return TRUE;
   pWnd->GetWindowRect(rc);
   pWnd->DestroyWindow(); //pWnd was just a placeholder;
   ScreenToClient(rc);
   m_SetDate.Create( WS_CHILD|WS_VISIBLE|DTS_SHORTDATEFORMAT, rc, this, IDC_SETDATEFRAME );

   pWnd = GetDlgItem(IDC_SETTIMEFRAME);
   if(!pWnd) return TRUE;
   pWnd->GetWindowRect(rc);
   pWnd->DestroyWindow(); //pWnd was just a placeholder;
   ScreenToClient(rc);
   m_SetTime.Create( WS_CHILD|WS_VISIBLE|DTS_TIMEFORMAT, rc, this, IDC_SETTIMEFRAME );

   m_RTCTime.ShowWindow(false);
   m_RTCDate.ShowWindow(false);

   return TRUE;
}

void CUnitRtc::OnSetdatetime() 
{
   // Get value in Time field
   CTime setTime;
   m_SetTime.GetTime(setTime);
   // Get value of Date field
   CTime setDate;
   m_SetDate.GetTime(setDate);
   rmonRTCTime SetRTCTime;

   // Create RTC time value from the Time and Date fields
   SetRTCTime.hour     = (unsigned char) setTime.GetHour();
   SetRTCTime.minute   = (unsigned char) setTime.GetMinute();
   SetRTCTime.second   = (unsigned char) setTime.GetSecond();

   SetRTCTime.year     = (unsigned short) setDate.GetYear();
   SetRTCTime.month    = (unsigned char) setDate.GetMonth();
   SetRTCTime.date     = (unsigned char) setDate.GetDay();
   SetRTCTime.reserved = 0;

   // No date at or before 2000 is allowed when not Superman
   if( setDate.GetYear() < 2000 ) {
      AfxMessageBox( "It is not allowed to set the clock before year 2000 !", MB_ICONEXCLAMATION|MB_OK|MB_DEFBUTTON1 );
      return;
   }

   // Set the new time
   if( rmonSetRTC(hCon, &SetRTCTime) != rmonOK ) {
      AfxMessageBox( "Error in communicating with RTCU unit", MB_ICONEXCLAMATION|MB_OK|MB_DEFBUTTON1 );
      return;
   }

   // Go fetch it from RTCU, and show it...
   OnFetch();
}

void CUnitRtc::OnSetcurrent() 
{
   BeginWaitCursor();

   // Get PC Clock time
   time_t ltime;
   time(&ltime);

   struct tm rtcTime;
   // ltime is now the "official" RTC time
   localtime_s(&rtcTime, &ltime);

   rmonRTCTime RTCTime;

   RTCTime.hour=(unsigned char)rtcTime.tm_hour;
   RTCTime.minute=(unsigned char)rtcTime.tm_min;
   RTCTime.second=(unsigned char)rtcTime.tm_sec;

   RTCTime.year=(unsigned short)rtcTime.tm_year+1900;
   RTCTime.month=(unsigned char)rtcTime.tm_mon+1;
   RTCTime.date=(unsigned char)rtcTime.tm_mday;
   RTCTime.reserved=0;

   // Set the new time
   if( rmonSetRTC(hCon, &RTCTime) != rmonOK ) {
      AfxMessageBox( "Error in communicating with RTCU unit", MB_ICONEXCLAMATION|MB_OK|MB_DEFBUTTON1 );
      return;
   }

   SYSTEMTIME sysTime;
   memset(&sysTime, 0, sizeof(sysTime));
   sysTime.wYear   = RTCTime.year;
   sysTime.wMonth  = RTCTime.month;
   sysTime.wDay    = RTCTime.date;

   sysTime.wHour   = RTCTime.hour;
   sysTime.wMinute = RTCTime.minute;
   sysTime.wSecond = RTCTime.second; 

   m_RTCTime.SetTime(&sysTime);
   m_RTCDate.SetTime(&sysTime);

   // Go fetch it from RTCU, and show it...
   OnFetch();
}

void CUnitRtc::OnFetch() 
{
   BeginWaitCursor();
   rmonRTCTime RTCTime;

   if( rmonGetRTC(hCon, &RTCTime) != rmonOK ) {
      AfxMessageBox( "Error in communicating with RTCU unit", MB_ICONEXCLAMATION|MB_OK|MB_DEFBUTTON1 );
      return;
   }

   m_RTCTime.ShowWindow(true);
   m_RTCDate.ShowWindow(true);

   SYSTEMTIME sysTime;
   memset(&sysTime, 0, sizeof(sysTime));
   sysTime.wYear   = RTCTime.year;
   sysTime.wMonth  = RTCTime.month;
   sysTime.wDay    = RTCTime.date;

   sysTime.wHour   = RTCTime.hour;
   sysTime.wMinute = RTCTime.minute;
   sysTime.wSecond = RTCTime.second; 

   UpdateData(true);
   m_RTCTime.SetTime(&sysTime);
   m_RTCDate.SetTime(&sysTime);
   UpdateData(false);
}
