// UnitUpgrade.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitUpgrade.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitUpgrade dialog


CUnitUpgrade::CUnitUpgrade(CWnd* pParent /*=NULL*/)
	: CDialog(CUnitUpgrade::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnitUpgrade)
	m_keyvalue = _T("");
	//}}AFX_DATA_INIT
}


void CUnitUpgrade::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitUpgrade)
	DDX_Control(pDX, IDOK, m_ctrok);
	DDX_Text(pDX, IDC_KEYVALUE, m_keyvalue);
	DDV_MaxChars(pDX, m_keyvalue, 34);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitUpgrade, CDialog)
	//{{AFX_MSG_MAP(CUnitUpgrade)
	ON_EN_CHANGE(IDC_KEYVALUE, OnChangeKeyvalue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Upgrade
/////////////////////////////////////////////////////////////////////////////

void CUnitUpgrade::OnChangeKeyvalue() 
{
   UpdateData(true);

   if( m_keyvalue.GetLength() == 34 )
      m_ctrok.EnableWindow(true);
   else
      m_ctrok.EnableWindow(false);
}

void CUnitUpgrade::OnOK() 
{
	// Var
	CString txt;
	rmonRet rc;
	int     res;

	// Upgrade unit
	UpdateData(true);
	rc = rmonSoftwareUpgrade(hCon, (LPTSTR)(LPCTSTR)m_keyvalue, &res);
	if(rc) {
		if( rc == rmonComError )
			AfxMessageBox("Error communicating with RTCU unit !");
		else {
			Sleep(2000);
			AfxMessageBox("Not a valid Key !");
		}
		return;
	}

	// Upgrade return res = 0 if anything went wrong...
	if( res == 0 )
		txt = _T("Error when trying to upgrade unit! Check for proper connection to unit");
	else if (res == 4)
		txt = _T("The password in the unit is cleared!");
	else {
		// Upgrade text
		txt = _T("The connected unit has been upgraded with the feature \"");
		switch(res) {
			case 1:  txt += _T("GPRS support"); break;
			case 2:  txt += _T("Micro -> Max"); break;
			case 3:  txt += _T("LCD Display"); break;
			case 4:  txt += _T("Password cleared"); break;
			case 5:  txt += _T("Battery Enabled"); break;
			case 6:  txt += _T("FMI support"); break;
			case 7:  txt += _T("7"); break;
			case 8:  txt += _T("8"); break;
			case 9:  txt += _T("9"); break;
			case 10: txt += _T("Citect support"); break;
			case 11: txt += _T("Web Enabled"); break;
		}
		txt += _T("\"\nPlease reset the unit now for the upgrade to take effect.");
	}
	AfxMessageBox(txt);
}

void CUnitUpgrade::OnCancel() 
{
	// Default
	CDialog::OnCancel();
}
